2012-05-22  Vitaly Buka  <vitalybuka@chromium.org>

        Fix iframe printing.
        https://bugs.webkit.org/show_bug.cgi?id=85118

        Reviewed by Darin Adler, Eric Seidel.

        Patch fixed two issues by disabling special handling of subframes for printing.
        1. Regression. Division by zero when forceLayoutForPagination called for subframes
        and page sizes set to zero.
        2. Old issue. RendererView adjusted layout of subframes for printing and set invalid
        dimensions. Sometimes it caused missing iframe when printed.

        Test: printing/iframe-print.html

        * page/Frame.cpp:
        (WebCore::Frame::setPrinting): Calls forceLayoutForPagination for root frames only.
        (WebCore::Frame::resizePageRectsKeepingRatio): Added ASSERTs to catch division by zero.
        * rendering/RenderView.cpp: Replaced printing() with shouldUsePrintingLayout() for most calls.
        (WebCore::RenderView::computeLogicalHeight):
        (WebCore::RenderView::computeLogicalWidth):
        (WebCore::RenderView::layout):
        (WebCore::RenderView::shouldUsePrintingLayout): Returns true only if printing enabled and it's a root frame.
        (WebCore::RenderView::viewRect):
        (WebCore::RenderView::viewHeight):
        (WebCore::RenderView::viewWidth):
        * rendering/RenderView.h:

2012-05-22  Rafael Brandao  <rafael.lobo@openbossa.org>

        [Qt] canvas/philip/tests/2d.path.stroke.overlap.html fails with Qt-4.6.2 or higher
        https://bugs.webkit.org/show_bug.cgi?id=40362

        Reviewed by Noam Rosenthal.

        Before drawing the stroke from a certain path, it should make the union of the stroke areas.
        The previous implementation didn't consider that so the intersection was painted twice.
        By using QPainterPathStroker, we create a QPainterPath on top of the platform path, and
        then we fill it with the expected brush. This way we avoid repainting areas.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::fillPathStroke):
        (WebCore):
        (WebCore::GraphicsContext::strokePath):

2012-05-21  Gavin Barraclough  <barraclough@apple.com>

        Disable private names by default in WebCore
        https://bugs.webkit.org/show_bug.cgi?id=87088

        Reviewed by Geoff Garen.

        r117859 introduced a preliminary implementation of ES6-like private name objects to JSC.
        These are probably not yet ready to be web-facing, so disabling by default in WebCore.
        Opting-in for JSC & DumpRenderTree so that we can still run the fast/js/names.html test.

        * WebCore.exp.in:
            - Added export.
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore):
        (WebCore::JSDOMWindowBase::javaScriptExperimentsEnabled):
            - Override default from JSC, enable based on corresponding Setting.
        * bindings/js/JSDOMWindowBase.h:
        (JSDOMWindowBase):
            - Added declaration for javaScriptExperimentsEnabled. 
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        (WebCore::Settings::setJavaScriptExperimentsEnabled):
        (WebCore):
        * page/Settings.h:
        (Settings):
        (WebCore::Settings::javaScriptExperimentsEnabled):
            - Added Setting, reflecting WebPreference.

2012-05-22  Adam Barth  <abarth@webkit.org>

        !HAVE(ACCESSIBILITY) depends on AccessibilityObject::actionVerb in the Chromium Android build
        https://bugs.webkit.org/show_bug.cgi?id=87141

        Reviewed by Eric Seidel.

        In the Chromium Android build there is still one remaining dependency
        on object files in the accessibility directory:
        AccessibilityObject::actionVerb. I missed this function in my previous
        patch, but this patch changes it to be an inline stub.

        * accessibility/AccessibilityObject.cpp:
        (WebCore):
        * accessibility/AccessibilityObject.h:
        (WebCore):
        (WebCore::actionVerb):
        (WebCore::AccessibilityObject::lineForPosition):
        (WebCore::AccessibilityObject::updateBackingStore):

2012-05-22  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Support Array-type key paths
        https://bugs.webkit.org/show_bug.cgi?id=84207

        Reviewed by Tony Chang.

        Implement IDB spec behavior that key paths can be arrays of strings; when 
        evaluated, these yield arrays of keys, providing compound key support. Also
        changes exception types to match the spec.

        Test: storage/indexeddb/keypath-arrays.html
        Test: storage/indexeddb/keypath-basics.html

        * Modules/indexeddb/IDBDatabase.cpp:
        (WebCore::IDBDatabase::createObjectStore): Look for both string and array in option dict,
        throw exceptions for forbidden combinations of key generator and key paths.
        * Modules/indexeddb/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::createIndex): Handle special cases (accepted and forbidden).
        (WebCore):
        * Modules/indexeddb/IDBObjectStore.h:
        (IDBObjectStore):
        (WebCore::IDBObjectStore::createIndex): Overloads to satisfy IDL overloads and optional dicts.
        * Modules/indexeddb/IDBObjectStore.idl: Add DOMString array overload.
        * bindings/v8/IDBBindingUtilities.cpp: Implement spec logic for evaluating array key paths.
        (WebCore::createIDBKeyFromSerializedValueAndKeyPath):
        (WebCore):

2012-05-22  Martin Robinson  <mrobinson@igalia.com>

        [GTK] REGRESSION(r116135): Keys that confirm composition trigger a default action
        https://bugs.webkit.org/show_bug.cgi?id=86925

        Reviewed by Gustavo Noronha Silva.

        No new tests. Creating tests for GTK+ input methods is quite difficult, as they
        can differ from machine to machine. It's also hard to simulate composition
        sequences.

        * platform/gtk/CompositionResults.h: Instead of holding composition results, just
        keep a flag describing whether or not this event had results.
        (CompositionResults):

2012-05-22  Abhishek Arya  <inferno@chromium.org>

        Assertion failure (toRenderBox() called on a RenderInline) beneath RenderBlock::blockBeforeWithinSelectionRoot()
        https://bugs.webkit.org/show_bug.cgi?id=86500

        Reviewed by Ojan Vafai.

        Patch by Dan Bernstein<mitz@apple.com>. I just added the test.

        Test: fast/block/line-layout/selection-highlight-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::blockBeforeWithinSelectionRoot): Demoted the object local variable to
        RenderObject, changed use of parentBox() to parent(), and added toRenderBlock() in two places.

2012-05-22  Rob Buis  <rbuis@rim.com>

        ASSERTs in RenderInline::layout()
        https://bugs.webkit.org/show_bug.cgi?id=63365

        Reviewed by Nikolas Zimmermann.

        Do not allow creation of renderers for text content children in elements by default.
        Subclasses like SVGTextElement override this behavior.
        This also fixes the <a><textPath</a> case because the <a> parent decides to allow <textPath> or not:
        http://www.w3.org/2003/01/REC-SVG11-20030114-errata#linking-text-environment

        Test: svg/custom/disallowed-text-content-rendering.svg

        * svg/SVGElement.cpp:
        (WebCore::SVGElement::childShouldCreateRenderer):
        * svg/SVGElement.h:
        (SVGElement):

2012-05-22  Takashi Sakamoto  <tasak@google.com>

        Implement DOM_KEY_LOCATION_LEFT and RIGHT of KeyboardEvent's location property
        https://bugs.webkit.org/show_bug.cgi?id=86694

        As KeyboardEvent for left/right location key, e.g. left-control,
        right-control, provides DOM_KEY_LOCATION_STANDARD as keyLocation property,
        modified KeyCodeConversion to make PlatformKeyboardEvent
        provide virtual keycodes with location information, e.g. VK_LCONTROL or
        VK_RCONTROL, and modified KeyboardEvent to generate location information
        from the virtual keycodes, e.g. genrating DOM_KEY_LOCATION_LEFT for
        VK_LCONTROL. KeyboardEvent also removes location information from
        the virtual keycodes, e.g. genrating VK_CONTROL for VK_LCONTROL.
        The location property is defined in the W3C DOM3 specification:
        http://www.w3.org/TR/DOM-Level-3-Events/#events-keyboardevents

        Reviewed by Alexey Proskuryakov.

        Test: fast/events/keydown-leftright-keys.html

        * dom/KeyboardEvent.cpp:
        (WebCore::windowsVirtualKeyCodeWithoutLocation):
        Added a function which removes location information from a given
        keycode. For example, when VK_LCONTROL is given, returns VK_CONTROL.
        (WebCore::keyLocationCode):
        Added a function which provides location information from a given
        keycode. For example, when VK_LCONTROL is given,
        returns DOM_KEY_LOCATION_LEFT.
        (WebCore::KeyboardEvent::KeyboardEvent):
        Initialized m_keyLocation by using the above keyLocationCode.
        (WebCore::KeyboardEvent::keyCode):
        Modified to use the above two functions to initialize keycode property
        and keylocation property.
        * platform/chromium/KeyCodeConversionAndroid.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):
        * platform/chromium/KeyCodeConversionGtk.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):
        * platform/cocoa/KeyEventCocoa.mm:
        (WebCore::windowsKeyCodeForKeyCode):
        Modified these keycode conversions to return keycodes with location
        information, e.g. modified keycode conversions returns VK_LCONTROL
        for left control.

2012-05-22  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: provide content-related actions on the sources panel.
        https://bugs.webkit.org/show_bug.cgi?id=87144

        Reviewed by Vsevolod Vlasov.

        Now that the authoring focus moved to the Source panel, context menu actions should follow:
        - refactored context menu actions to be provider-based
        - edited call sites to add applicable actions.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/ContextMenu.js:
        (WebInspector.ContextMenu.prototype.appendApplicableItems):
        * inspector/front-end/HandlerRegistry.js:
        (WebInspector.HandlerRegistry.prototype.unregisterHandler):
        (WebInspector.HandlerRegistry.prototype.appendApplicableItems.doSave):
        (WebInspector.HandlerRegistry.prototype.appendApplicableItems.save):
        (WebInspector.HandlerRegistry.prototype.appendApplicableItems):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.populateTextAreaContextMenu):
        * inspector/front-end/NavigatorView.js:
        (WebInspector.NavigatorView.prototype.handleContextMenu):
        (WebInspector.BaseNavigatorTreeElement.prototype.onattach):
        * inspector/front-end/NetworkPanel.js:
        (WebInspector.NetworkPanel):
        (WebInspector.NetworkPanel.prototype.searchCanceled):
        (WebInspector.NetworkPanel.prototype.appendApplicableItems.reveal):
        (WebInspector.NetworkPanel.prototype.appendApplicableItems):
        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceSourceFrame.prototype._contentChanged):
        (WebInspector.ResourceSourceFrame.prototype.populateTextAreaContextMenu):
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.FrameResourceTreeElement.prototype._handleContextMenuEvent):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.appendApplicableItems):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype.populateTextAreaContextMenu):
        * inspector/front-end/TextViewer.js:
        (WebInspector.TextViewer.prototype._contextMenu):
        * inspector/front-end/UIUtils.js:
        * inspector/front-end/externs.js:
        * inspector/front-end/inspector.js:
        (WebInspector._doLoadedDoneWithCapabilities.get if):

2012-05-22  Nico Weber  <thakis@chromium.org>

        Give FileInputType a setFiles() method, let Drag-n-Drop call it.
        https://bugs.webkit.org/show_bug.cgi?id=87139

        Reviewed by Ojan Vafai.

        filesChosen(), the FileChooserClient callback, used to modify
        m_fileList directly. Instead, convert the FileChooserClient
        data to a FileList and pass that to a factored-out setFiles()
        method. This is in preparation to making the files property
        writable.

        Pure refactoring, no functionality change.

        * html/FileInputType.cpp:
        (WebCore::FileInputType::toFileList):
        (WebCore::FileInputType::setFiles):
        (WebCore::FileInputType::filesChosen):
        (WebCore):
        * html/FileInputType.h:
        (FileInputType):

2012-05-22  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: JavaScriptSourceFrame should be based on JavaScriptSource not UISourceCode.
        https://bugs.webkit.org/show_bug.cgi?id=87135

        Reviewed by Pavel Feldman.

        Renamed _uiSourceCode to _javaScriptSource in JavaScriptSourceFrame.
        Removed unused uiSourceCode getter from JavaScriptSourceFrame.

        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame):
        (WebInspector.JavaScriptSourceFrame.prototype.canEditSource):
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        (WebInspector.JavaScriptSourceFrame.prototype._onContentChanged):
        (WebInspector.JavaScriptSourceFrame.prototype.populateLineGutterContextMenu):
        (WebInspector.JavaScriptSourceFrame.prototype.populateTextAreaContextMenu):
        (WebInspector.JavaScriptSourceFrame.prototype.afterTextChanged):
        (WebInspector.JavaScriptSourceFrame.prototype.beforeTextChanged):
        (WebInspector.JavaScriptSourceFrame.prototype._onMouseDown):
        (WebInspector.JavaScriptSourceFrame.prototype._breakpointAdded):
        (WebInspector.JavaScriptSourceFrame.prototype._breakpointRemoved):
        (WebInspector.JavaScriptSourceFrame.prototype.onTextViewerContentLoaded):
        (WebInspector.JavaScriptSourceFrame.prototype._setBreakpoint):
        (WebInspector.JavaScriptSourceFrame.prototype._continueToLine):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._createSourceFrame):

2012-05-22  Lu Guanqun  <guanqun.lu@intel.com>

        add OVERRIDE annotations to classes derived from CCAnimationCurve
        https://bugs.webkit.org/show_bug.cgi?id=87073

        Reviewed by James Robinson.

        No new tests required.

        * platform/graphics/chromium/cc/CCAnimationCurve.h:

2012-05-22  Lu Guanqun  <guanqun.lu@intel.com>

        add OVERRIDE annotations to CCThreadTask
        https://bugs.webkit.org/show_bug.cgi?id=87074

        Reviewed by James Robinson.

        No new tests required.

        * platform/graphics/chromium/cc/CCThreadTask.h:

2012-05-22  Julien Chaffraix  <jchaffraix@webkit.org>

        Centralize and clean-up table column iteration
        https://bugs.webkit.org/show_bug.cgi?id=87051

        Reviewed by Eric Seidel.

        Tests: fast/table/caption-between-column-and-column-group.html
               fast/table/caption-between-column-group-and-column.html
               fast/table/caption-between-columns.html

        The existing code had duplications between different classes and some
        of the iterating functions could use a better place. That's what this
        change solves, along with several renamings.

        * rendering/RenderTableCol.h:
        (WebCore::RenderTableCol::isTableColumnGroupWithColumnChildren):
        Renamed isTableColGroup to this to better reflect what it checks.
        Also added a new function: nextColumn.

        * rendering/FixedTableLayout.cpp:
        (WebCore::FixedTableLayout::calcWidthArray):
        Updated after isTableColGroup renaming.

        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::firstColumn):
        Added this new function to get the first column (or column group).

        (WebCore::RenderTable::colElement):
        Cleaned up this function: switched the loop to a 'for' now that the
        helper functions make it easy. Cleaned up the ordering and the naming.

        * rendering/RenderTable.h:
        Added firstColumn.

        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::styleOrColLogicalWidth):
        Updated to use nextColumn().

        * rendering/RenderTableCol.cpp:
        (WebCore::RenderTableCol::nextColumn):
        Added this new helper function to centralize the code to iterate over columns.

2012-05-22  Hao Zheng  <zhenghao@chromium.org>

        [chromium] Make color of spelling check marker cross-platform.
        https://bugs.webkit.org/show_bug.cgi?id=87095

        Reviewed by Adam Barth.

        Pixel layout is RGBA on Android, while it is BGRA on other platforms.

        No new tests. To run tests on Android.

        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::drawLineForDocumentMarker):

2012-05-22  Dana Jansens  <danakj@chromium.org>

        [chromium] Expand damage from the background-blurred layer to ensure readback is only including pixels below that layer
        https://bugs.webkit.org/show_bug.cgi?id=86884

        Reviewed by Adrienne Walker.

        Consider layers in back-to-front order A, B, and C, where layer B has
        a blur background filter applied, and C exactly covers A. When B does
        its readback to perform its blur, it should include the pixels of A
        not C. With partial swap, if B is damaged, that damaged area will read
        pixels from outside of the damage rect. Those pixels should use the
        contents of A, not C, so we must expand the damage to ensure we redraw
        all pixels that are going to be included in the blur for the current
        frame.

        Also, when a layer below B has damage outside the contentBounds of B
        but within its blur radius, then that damage will be blurred inside B,
        so expand all damage within B's blurred contentBounds.

        Unit test: CCDamageTrackerTest.verifyDamageForBackgroundBlurredChild

        * platform/graphics/chromium/cc/CCDamageTracker.cpp:
        (WebCore::expandRectWithFilters):
        (WebCore::expandDamageRectInsideRectWithFilters):
        (WebCore::CCDamageTracker::updateDamageTrackingState):
        (WebCore::CCDamageTracker::extendDamageForRenderSurface):

2012-05-22  Mihnea Ovidenie  <mihnea@adobe.com>

        [CSSRegions] Add region styling support for color property
        https://bugs.webkit.org/show_bug.cgi?id=85633

        Reviewed by David Hyatt.

        Test: fast/regions/region-style-color.html

        This patch extends the region styling support. In addition to background-color, it adds
        the possibility of styling color in regions.

        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::collectMatchingRulesForList):
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::removeFlowChildInfo):
        (WebCore::RenderFlowThread::addRegionToThread):
        (WebCore::RenderFlowThread::removeRegionFromThread):
        (WebCore::RenderFlowThread::clearRenderObjectCustomStyle):
        (WebCore::RenderFlowThread::setRegionRangeForBox):
        (WebCore):
        (WebCore::RenderFlowThread::checkRegionsWithStyling):
        * rendering/RenderFlowThread.h:
        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::updateAlwaysCreateLineBoxes):
        * rendering/RenderObjectChildList.cpp:
        (WebCore::RenderObjectChildList::removeChildNode):
        * rendering/RenderRegion.cpp:
        (WebCore::RenderRegion::paintReplaced):
        (WebCore::RenderRegion::styleDidChange):
        (WebCore::RenderRegion::setRegionObjectsRegionStyle):
        (WebCore::RenderRegion::restoreRegionObjectsOriginalStyle):
        (WebCore::RenderRegion::computeStyleInRegion):
        (WebCore):
        (WebCore::RenderRegion::computeChildrenStyleInRegion):
        (WebCore::RenderRegion::setObjectStyleInRegion):
        (WebCore::RenderRegion::clearObjectStyleInRegion):
        * rendering/RenderRegion.h:
        (RenderRegion):
        (ObjectRegionStyleInfo):

2012-05-22  Kentaro Hara  <haraken@chromium.org>

        [V8] Remove GenerateSetDOMException() from CodeGeneratorV8.pm
        https://bugs.webkit.org/show_bug.cgi?id=87114

        Reviewed by Nate Chapin.

        GenerateSetDOMException() is used by only one place. This patch removes it.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateNormalAttrGetter):

2012-05-22  David Grogan  <dgrogan@chromium.org>

        IndexedDB: Fire error when there are problems opening a DB
        https://bugs.webkit.org/show_bug.cgi?id=85579

        We used to either fire success or get into an infinite loop.

        Reviewed by Tony Chang.

        New unit test in
        Source/WebKit/chromium/tests/IDBAbortOnCorruptTest.cpp

        * Modules/indexeddb/IDBDatabaseBackendImpl.cpp:
        (WebCore::IDBDatabaseBackendImpl::IDBDatabaseBackendImpl):
        (WebCore::IDBDatabaseBackendImpl::openInternal):
        (WebCore::IDBDatabaseBackendImpl::openConnection):
        * Modules/indexeddb/IDBDatabaseBackendImpl.h:
        (WebCore::IDBDatabaseBackendImpl::create):
        (IDBDatabaseBackendImpl):
        * Modules/indexeddb/IDBFactoryBackendImpl.cpp:
        (WebCore::IDBFactoryBackendImpl::deleteDatabase):
        (WebCore::IDBFactoryBackendImpl::openInternal):
        * Modules/indexeddb/IDBFactoryBackendImpl.h:
        (IDBFactoryBackendImpl):
        * Modules/indexeddb/IDBLevelDBBackingStore.h:
        (IDBLevelDBBackingStore):

2012-05-22  Nikolas Zimmermann  <nzimmermann@rim.com>

        Not reviewed.

        Follow-up patch after r117975, as the strict approach fires assertions.
        CSS generated content can violate the ASSERT(child->isSVGInline() || child->isSVGInlineText()) logic.

        * rendering/svg/RenderSVGText.cpp:
        (WebCore::RenderSVGText::subtreeChildWasAdded):
        (WebCore::RenderSVGText::subtreeChildWillBeRemoved):

2012-05-22  Dominic Mazzoni  <dmazzoni@google.com>

        Chromium AX: Crash when menulist adds selected option via document.write
        https://bugs.webkit.org/show_bug.cgi?id=87028

        Reviewed by Chris Fleizach.

        Test: platform/chromium/accessibility/add-to-menu-list-crashes.html

        * rendering/RenderMenuList.cpp:
        (WebCore::RenderMenuList::addChild):

2012-05-22  Nikolas Zimmermann  <nzimmermann@rim.com>

        Crash in WebCore::SVGTextLayoutAttributesBuilder::fillCharacterDataMap
        https://bugs.webkit.org/show_bug.cgi?id=86781

        Reviewed by Rob Buis.

        Always invalidate the text positioning element cache if the <text> render subtree mutates.
        Currently only RenderSVGInlineText renderers are tracked correctly, RenderSVGInline
        renderers like RenderSVGTSpan didn't cause text positioning element cache mutations
        so far. Fix that.

        Test: svg/custom/bug86781.html

        * rendering/svg/RenderSVGInline.cpp:
        (WebCore::RenderSVGInline::removeChild):
        * rendering/svg/RenderSVGText.cpp:
        (WebCore::RenderSVGText::subtreeChildWasAdded):
        (WebCore::RenderSVGText::subtreeChildWillBeRemoved):
        (WebCore::RenderSVGText::removeChild):
        * rendering/svg/RenderSVGText.h:
        (RenderSVGText):

2012-05-22  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: make "Go to source" shortcut accessible from all panels.
        https://bugs.webkit.org/show_bug.cgi?id=87132

        Reviewed by Vsevolod Vlasov.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/AdvancedSearchController.js:
        (WebInspector.AdvancedSearchController.prototype.handleShortcut):
        * inspector/front-end/FilteredItemSelectionDialog.js:
        (WebInspector.OpenResourceDialog.filterOutEmptyURLs):
        (WebInspector.OpenResourceDialog.compareFunction):
        (WebInspector.OpenResourceDialog):
        (WebInspector.OpenResourceDialog.prototype.itemTitleAt):
        (WebInspector.OpenResourceDialog.prototype.itemKeyAt):
        (WebInspector.OpenResourceDialog.prototype.itemsCount):
        (WebInspector.OpenResourceDialog.prototype.requestItems):
        (WebInspector.OpenResourceDialog.prototype.selectItem):
        (WebInspector.OpenResourceDialog.show):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.appendApplicableItems):
        (WebInspector.ScriptsPanel.prototype.showGoToSourceDialog):
        * inspector/front-end/SearchController.js:
        (WebInspector.SearchController.prototype.handleShortcut):
        * inspector/front-end/inspector.js:
        (WebInspector._registerShortcuts):
        (WebInspector.documentKeyDown):

2012-05-22  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: HeapSnapshot: speedUp buildAggregates.
        https://bugs.webkit.org/show_bug.cgi?id=87131

        Engine can't inline getters and use fast-case if the function has for(i in object) loops.

        Reviewed by Yury Semikhatsky.

        No logic changes.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.classIndex):
        (WebInspector.HeapSnapshot.prototype._buildAggregates):
        (WebInspector.HeapSnapshot.prototype._calculateClassesRetainedSize):

2012-05-22  Nikolas Zimmermann  <nzimmermann@rim.com>

        Crash in WebCore::RenderSVGContainer::paint
        https://bugs.webkit.org/show_bug.cgi?id=86392

        Reviewed by Rob Buis.

        Modernize the <marker> code, switch to the same design pattern used for handling zero-length subpaths.
        Decouple the generation of the marker start/mid/end positions from the actual usage of these information.
        Only generate those marker positions if the underlying Path changes, and never else.

        When figuring out the bounds for a shape, access to current set of RenderSVGResourceMarker start/mid/end resources
        and ask the marker resources for their bounds using the previously figured out marker positions on the Path.
        Drawing markers is handled in the same way.

        Remove SVGMarkerLayoutInfo alltogether which stored raw pointers to the RenderSVGResourceMarkers.
        We assumed that those objects would stay alive from layout() to paint(), but that assumption is wrong.

        Tests: svg/custom/bug86392.html
               svg/custom/marker-zero-length-linecaps-expected.svg
               svg/custom/marker-zero-length-linecaps.svg

        * CMakeLists.txt: Remove SVGMarkerLayoutInfo.*.
        * GNUmakefile.list.am: Ditto.
        * Target.pri: Ditto.
        * WebCore.gypi: Ditto.
        * WebCore.order: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * rendering/svg/RenderSVGAllInOne.cpp: Ditto.
        * rendering/svg/RenderSVGShape.cpp: Handle markers just like the existing zero leng subpath code, which is superior.
        (WebCore::RenderSVGShape::createShape):
        (WebCore::RenderSVGShape::layout):
        (WebCore::RenderSVGShape::shouldGenerateMarkerPositions):
        (WebCore::RenderSVGShape::paint):
        (WebCore::markerForType):
        (WebCore::RenderSVGShape::markerRect):
        (WebCore::RenderSVGShape::inflateWithStrokeAndMarkerBounds):
        (WebCore::RenderSVGShape::drawMarkers):
        (WebCore::RenderSVGShape::processMarkerPositions):
        * rendering/svg/RenderSVGShape.h:
        (RenderSVGShape):
        * rendering/svg/SVGMarkerData.h:
        (WebCore::MarkerPosition::MarkerPosition):
        (MarkerPosition):
        (WebCore::SVGMarkerData::SVGMarkerData):
        (WebCore::SVGMarkerData::updateFromPathElement):
        (WebCore::SVGMarkerData::pathIsDone):
        (SVGMarkerData):
        (WebCore::SVGMarkerData::currentAngle):
        * rendering/svg/SVGMarkerLayoutInfo.cpp: Removed.
        * rendering/svg/SVGMarkerLayoutInfo.h: Removed.
        * rendering/svg/SVGResourcesCache.cpp:
        (WebCore::resourcesCacheFromRenderObject):
        (WebCore::SVGResourcesCache::cachedResourcesForRenderObject):
        * rendering/svg/SVGResourcesCache.h:
        (SVGResourcesCache):

2012-05-22  Alexander Pavlov  <apavlov@chromium.org>

        [Chromium] Implement the ContextMenuItem SubMenu type
        https://bugs.webkit.org/show_bug.cgi?id=86625

        Reviewed by Pavel Feldman.

        This change is the WebKit part of a two-sided patch that adds subMenuItems to ContextMenuItem
        and introduces code needed to handle it properly.

        * platform/ContextMenuItem.h:
        (PlatformMenuItemDescription): Add a Vector for subMenuItems.
        * platform/PlatformMenuDescription.h:
        (WebCore): Introduce a meaningful typedef for PlatformMenuDescription in Chromium.
        * platform/chromium/ContextMenuChromium.cpp:
        (WebCore::ContextMenu::itemWithAction): Search submenus when looking up a requested action id.
        (WebCore::ContextMenu::platformDescription): Return a real PlatformMenuDescription rather than 0.
        * platform/chromium/ContextMenuItemChromium.cpp:
        (WebCore::ContextMenuItem::ContextMenuItem): Set submenu if one has been passed in.
        (WebCore::ContextMenuItem::platformSubMenu): Return real subMenuItems instead of an empty PlatformMenuDescription.
        (WebCore::ContextMenuItem::setSubMenu): Implemented.
        (WebCore):

2012-05-22  Andrey Kosyakov  <caseq@chromium.org>

        Web Inspector: use canvas to render timeline category strips in overview pane
        https://bugs.webkit.org/show_bug.cgi?id=87109

        Reviewed by Pavel Feldman.

        - use canvas, not DOM to represent timeline category strips in the default overview mode

        * inspector/front-end/TimelineOverviewPane.js:
        (WebInspector.TimelineOverviewPane):
        (WebInspector.TimelineOverviewPane.prototype._setVerticalOverview): propagate to TimelineCategoryStrips;
        (WebInspector.TimelineOverviewPane.prototype._onCategoryVisibilityChanged): force update of category strips;
        (WebInspector.TimelineOverviewPane.prototype._update):
        (WebInspector.TimelineOverviewPane.prototype.setShowShortEvents):
        (WebInspector.TimelineCategoryStrips):
        (WebInspector.TimelineCategoryStrips.prototype.update.appendRecord): process one record;
        (WebInspector.TimelineCategoryStrips.prototype.update): re-draw everything;
        (WebInspector.TimelineCategoryStrips.prototype.setShowShortEvents):
        (WebInspector.TimelineCategoryStrips.prototype._renderBar): render single bar;
        (WebInspector.TimelineVerticalOverview):
        (WebInspector.TimelineVerticalOverview.prototype._renderBar):
        * inspector/front-end/TimelinePresentationModel.js:
        (WebInspector.TimelinePresentationModel.categories):
        (WebInspector.TimelinePresentationModel.createFillStyle): utility methods to create gradients for category bars;
        (WebInspector.TimelinePresentationModel.createFillStyleForCategory):
        (WebInspector.TimelineCategory):

2012-05-22  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: [regression] dynamically created script tab is bound to the document resource.
        https://bugs.webkit.org/show_bug.cgi?id=87119

        Reviewed by Vsevolod Vlasov.

        Test: inspector/debugger/dynamic-script-tag.html

        * inspector/front-end/BreakpointManager.js:
        (WebInspector.BreakpointManager.Breakpoint.prototype._setInDebugger.didSetBreakpoint):
        (WebInspector.BreakpointManager.Breakpoint.prototype._setInDebugger):
        * inspector/front-end/DebuggerModel.js:
        (WebInspector.DebuggerModel.prototype.rawLocationToUILocation):
        * inspector/front-end/ResourceScriptMapping.js:
        (WebInspector.ResourceScriptMapping.prototype.addScript):
        (WebInspector.ResourceScriptMapping.prototype._shouldBindScriptToContentProvider):
        * inspector/front-end/Script.js:
        (WebInspector.Script.prototype.rawLocationToUILocation):
        (WebInspector.Script.Location.prototype.update):

2012-05-22  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: JavaScript breakpoints disappear when Ctrl+S is pressed for the script without changes.
        https://bugs.webkit.org/show_bug.cgi?id=87121

        Reviewed by Pavel Feldman.

        JavaScriptSourceFrame and StylesSourceFrame should not commit working copy unless UISourceCode is dirty.

        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSourceFrame.prototype.commitEditing):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype.commitWorkingCopy):

2012-05-22  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: HeapSnapshot: speed-up calculateRetainedSize functon.
        https://bugs.webkit.org/show_bug.cgi?id=87124

        I found that in all dominators related functions we use nodeOrdinals.
        At the moment we divide nodeIndex to nodeFieldCount and this operation too expensive for these simple algorithms.

        Reviewed by Yury Semikhatsky.

        Covered by existing tests.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get dominatorIndex):
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype._buildPostOrderIndex):
        (WebInspector.HeapSnapshot.prototype._buildDominatorTree):
        (WebInspector.HeapSnapshot.prototype._calculateRetainedSizes):
        (WebInspector.HeapSnapshot.prototype._buildDominatedNodes):

2012-05-22  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: annotate InjectedScriptSource.js for closure compiler
        https://bugs.webkit.org/show_bug.cgi?id=87120

        Reviewed by Pavel Feldman.

        Annotated InjectedScriptSource.js for closure compiler. Replaced call of undefined
        _isPrimitiveValue function with isPrimitiveValue.

        * inspector/InjectedScriptExterns.js: Added. External APIs used in InjectedScriptSource.js
        (console.log):
        (InjectedScriptHost.prototype.storageId):
        (InjectedScriptHost.prototype.functionDetails):
        (InjectedScriptHost.prototype.isHTMLAllCollection):
        (InjectedScriptHost.prototype.internalConstructorName):
        (InjectedScriptHost.prototype.copyText):
        (InjectedScriptHost.prototype.clearConsoleMessages):
        (InjectedScriptHost.prototype.inspectedObject):
        (InjectedScriptHost.prototype.databaseId):
        (InjectedScriptHost.prototype.inspect):
        (InjectedScriptHost.prototype.type):
        (InjectedScriptHost.prototype.getEventListeners):
        (JavaScriptCallFrame.prototype.scopeType):
        * inspector/InjectedScriptSource.js:

2012-05-22  Ian Vollick  <vollick@chromium.org>

        [chromium] Speed up CCLayerTreeHostTestTickAnimationWhileBackgrounded
        https://bugs.webkit.org/show_bug.cgi?id=86871

        Reviewed by James Robinson.

        With this patch, the background animation timer is lazily created,
        allowing for different time intervals to be used. In particular, a
        very short interval for unit tests.

        Unit tests: CCLayerTreeHostTestTickAnimationWhileBackgrounded.runSingleThread
                    CCLayerTreeHostTestTickAnimationWhileBackgrounded.runMultiThread

        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.cpp:
        (WebCore::CCLayerTreeHostImpl::CCLayerTreeHostImpl):
        (WebCore::CCLayerTreeHostImpl::setBackgroundTickingEnabled):
        (WebCore):
        (WebCore::CCLayerTreeHostImpl::setVisible):
        (WebCore::CCLayerTreeHostImpl::animateLayers):
        (WebCore::CCLayerTreeHostImpl::lowFrequencyAnimationInterval):
        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.h:
        (CCLayerTreeHostImpl):
        * platform/graphics/chromium/cc/CCSingleThreadProxy.cpp:
        (WebCore::CCSingleThreadProxy::setVisible):

2012-05-22  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: [Styles] Odd synthetic shorthands may appear in the style
        https://bugs.webkit.org/show_bug.cgi?id=87081

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertiesSection.prototype.onpopulate):

2012-05-22  Hayato Ito  <hayato@chromium.org>

        Fix crashes when a mouse points a <svg> element in shadow DOM subtree.
        https://bugs.webkit.org/show_bug.cgi?id=86795

        Reviewed by Nikolas Zimmermann.

        <svg> elements in shadow dom subtree are still not supported.
        This fixes only crashes.

        Test: fast/dom/shadow/shadow-dom-event-dispatching.html

        * dom/EventDispatcher.cpp:
        (WebCore::eventTargetRespectingSVGTargetRules):
        * page/EventHandler.cpp:
        (WebCore::instanceAssociatedWithShadowTreeElement):

2012-05-22  Andreas Kling  <kling@webkit.org>

        DOM Attr objects pointing to "style" attribute should force reification when read.
        <http://webkit.org/b/87076>

        Reviewed by Antti Koivisto.

        Make sure that the "style" attribute is reserialized as needed when it gets retrieved
        through an Attr object. This fixes a bug where updating an element's inline style
        through the CSSOM API, and then retrieving the style attribute through an Attr node
        that was previously created by element.getAttributeNode() would return the old style
        attribute value.

        Test: fast/dom/attr-style-too-lazy.html

        * dom/Attr.cpp:
        (WebCore::Attr::value):

2012-05-22  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: HeapProfiler: upstream retainedSize calculation.
        https://bugs.webkit.org/show_bug.cgi?id=87107

        This patch upstreams V8::HeapSnapshotGenerator::CalculateRetainedSizes function to front-end.
        After that we will be able to drop retainedSize field from the snapshot serialized data.
        See meta-bug https://bugs.webkit.org/show_bug.cgi?id=87089

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get retainedSize):
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype._calculateRetainedSizes):

2012-05-22  Emil A Eklund  <eae@chromium.org>

        Change RenderBlock to user RenderBox/RenderInline writing mode logic
        https://bugs.webkit.org/show_bug.cgi?id=87040

        Reviewed by Eric Seidel.

        Remove unnecessary writing mode logic in RenderBlock and use the
        implementation in RenderBox and RenderInline instead.

        No new tests, no change in functionality.

        * rendering/RenderBlock.cpp:
        (WebCore):
        * rendering/RenderBlock.h:
        (WebCore::RenderBlock::marginBeforeForChild):
        (WebCore::RenderBlock::marginAfterForChild):
        (WebCore::RenderBlock::marginStartForChild):
        (WebCore::RenderBlock::marginEndForChild):
        (WebCore::RenderBlock::setMarginStartForChild):
        (WebCore::RenderBlock::setMarginEndForChild):
        (WebCore::RenderBlock::setMarginBeforeForChild):
        (WebCore::RenderBlock::setMarginAfterForChild):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::marginBefore):
        (WebCore::RenderBox::marginAfter):
        (WebCore::RenderBox::marginStart):
        (WebCore::RenderBox::marginEnd):
        (WebCore::RenderBox::setMarginStart):
        (WebCore::RenderBox::setMarginEnd):
        (WebCore::RenderBox::setMarginBefore):
        (WebCore::RenderBox::setMarginAfter):
        * rendering/RenderBox.h:
        (RenderBox):
        * rendering/RenderBoxModelObject.h:
        (RenderBoxModelObject):
        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::marginStart):
        (WebCore::RenderInline::marginEnd):
        (WebCore::RenderInline::marginBefore):
        (WebCore::RenderInline::marginAfter):
        * rendering/RenderInline.h:
        (RenderInline):

2012-05-22  Li Yin  <li.yin@intel.com>

        [WebSocket] WebSocket object should fire a simple event named error when it is required to fail the websocket connection.
        https://bugs.webkit.org/show_bug.cgi?id=86958

        Reviewed by Kent Tamura.

        Spec:http://dev.w3.org/html5/websockets/#feedback-from-the-protocol
        If the user agent was required to fail the websocket connection or the 
        WebSocket connection is closed with prejudice, fire a simple event 
        named error at the WebSocket object.

        Tests: http/tests/websocket/tests/hybi/close.html

        * Modules/websockets/WebSocket.cpp:
        (WebCore::WebSocket::didReceiveMessageError):
        * Modules/websockets/WebSocketChannel.cpp:
        (WebCore::WebSocketChannel::fail):

2012-05-22  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: allow showing selected object in another heap profiler view
        https://bugs.webkit.org/show_bug.cgi?id=87098

        Reviewed by Vsevolod Vlasov.

        Added 2 context menu actions: 1) to jump from a node in the heap snapshot summary
        view to the same node in the dominators view; 2) to jump from a node in the dominators
        view to the same node in the summary view.

        * inspector/front-end/HeapSnapshotDataGrids.js:
        (WebInspector.HeapSnapshotSortableDataGrid): "sorting complete" event is only dispatched on
        when the data grid is populated. If we switch to already populated data grid the event is not
        dispatched. However when switching between different views of a heap snapshot we want to track
        the moment when the data grid is shown and populated. I added
        WebInspector.HeapSnapshotSortableDataGrid.Events.ContentShown for such cases. The event will always
        be dispatched after the data grid is shown and its content is populated.
        (WebInspector.HeapSnapshotSortableDataGrid.prototype.wasShown):
        (WebInspector.HeapSnapshotSortableDataGrid.prototype._sortingComplete):
        (WebInspector.HeapSnapshotSortableDataGrid.prototype.populateContextMenu.revealInDominatorsView):
        (WebInspector.HeapSnapshotSortableDataGrid.prototype.populateContextMenu.else.revealInSummaryView):
        (WebInspector.HeapSnapshotSortableDataGrid.prototype.populateContextMenu):
        (WebInspector.HeapSnapshotSortableDataGrid.prototype._performSorting):
        * inspector/front-end/HeapSnapshotGridNodes.js:
        (WebInspector.HeapSnapshotGenericObjectNode.prototype._createObjectCell):
        (WebInspector.HeapSnapshotDominatorObjectNode.prototype.retrieveChildBySnapshotObjectId):
        * inspector/front-end/HeapSnapshotView.js:
        (WebInspector.HeapSnapshotView.prototype.populateContextMenu):
        (WebInspector.HeapSnapshotView.prototype.changeView.dataGridContentShown):
        (WebInspector.HeapSnapshotView.prototype.changeView):
        (WebInspector.HeapSnapshotView.prototype._onSelectedViewChanged):
        (WebInspector.HeapSnapshotView.prototype._changeView):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype._handleContextMenuEvent):

2012-05-22  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: show more button node should have height multiple of row height
        https://bugs.webkit.org/show_bug.cgi?id=87104

        Reviewed by Vsevolod Vlasov.

        Made "show more" button height multiple of the data grid row height.

        * inspector/front-end/ShowMoreDataGridNode.js:
        (WebInspector.ShowMoreDataGridNode.prototype.nodeHeight):
        * inspector/front-end/dataGrid.css:
        (.data-grid button):

2012-05-22  Kentaro Hara  <haraken@chromium.org>

        [V8] Add an optional 'isolate' argument to throwTypeError()
        https://bugs.webkit.org/show_bug.cgi?id=87070

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch adds an optional 'isolate' argument to throwTypeError(),
        and passes Isolate to throwTypeError()s. In a following patch,
        I'll pass Isolate to all throwTypeError("message")s.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateNormalAttrSetter):
        (GenerateOverloadedFunctionCallback):
        (GenerateParametersCheck):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::overloadedMethodCallback):
        (WebCore::TestObjV8Internal::overloadedMethod1Callback):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::throwTypeError):
        * bindings/v8/V8Proxy.h:
        (V8Proxy):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8DataViewCustom.cpp:
        (WebCore::V8DataView::constructorCallback):
        * bindings/v8/custom/V8SVGLengthCustom.cpp:
        (WebCore::V8SVGLength::valueAccessorSetter):
        * bindings/v8/custom/V8WebGLRenderingContextCustom.cpp:
        (WebCore::V8WebGLRenderingContext::getAttachedShadersCallback):
        (WebCore::V8WebGLRenderingContext::getProgramParameterCallback):
        (WebCore::V8WebGLRenderingContext::getShaderParameterCallback):
        (WebCore::V8WebGLRenderingContext::getUniformCallback):
        (WebCore::vertexAttribAndUniformHelperf):
        (WebCore::uniformHelperi):
        (WebCore::uniformMatrixHelper):

2012-05-22  Yoshifumi Inoue  <yosin@chromium.org>

        [Forms][Meter][Progress] Change function signature of parseToDoubleForNumberType
        https://bugs.webkit.org/show_bug.cgi?id=87077

        Reviewed by Hajime Morita.

        This patch changes function signature of parseToDoubleForNumberType and
        parseToDoubleForNumberTypeWithDecimalPlaces to return double value instead
        of bool for reducing code in call sites for ease of maintenance. This patch
        also allows to use functional style of using these functions.

        No new tests. This patch doesn't change behavior.

        * html/HTMLMeterElement.cpp:
        (WebCore::HTMLMeterElement::min): Changed for using double return value.
        (WebCore::HTMLMeterElement::max): Changed for using double return value.
        (WebCore::HTMLMeterElement::value): Changed for using double return value.
        (WebCore::HTMLMeterElement::low): Changed for using double return value.
        (WebCore::HTMLMeterElement::high): Changed for using double return value.
        (WebCore::HTMLMeterElement::optimum): Changed for using double return value.
        * html/HTMLProgressElement.cpp:
        (WebCore::HTMLProgressElement::value): Changed for using double return value.
        (WebCore::HTMLProgressElement::max): Changed for using double return value.
        * html/NumberInputType.cpp:
        (WebCore::NumberInputType::typeMismatchFor): Changed for using double return value.
        (WebCore::NumberInputType::sizeShouldIncludeDecoration): Changed for using double return value.
        (WebCore::NumberInputType::parseToDouble): Changed for using double return value.
        (WebCore::NumberInputType::parseToDoubleWithDecimalPlaces): Changed for using double return value.
        (WebCore::NumberInputType::visibleValue): Changed for using double return value.
        (WebCore::NumberInputType::sanitizeValue): Changed for using double return value.
        * html/RangeInputType.cpp:
        (WebCore::RangeInputType::parseToDouble): Changed for using double return value.
        * html/StepRange.cpp:
        (WebCore::StepRange::parseStep): Changed for using double return value.
        * html/StepRange.h:
        (WebCore::StepRange::defaultValue): Added "const" attribute
        (WebCore::StepRange::proportionFromValue): Added "const" attribute
        (WebCore::StepRange::valueFromProportion): Added "const" attribute
        * html/parser/HTMLParserIdioms.cpp:
        (WebCore::parseToDoubleForNumberType): Changed for using double return value. Added one parameter function.
        (WebCore::parseToDoubleForNumberTypeWithDecimalPlaces): Changed for using double return value. Added function for providing default fallback value.
        * html/parser/HTMLParserIdioms.h: Changed function prototype and added one parameter prototypes.
        * html/shadow/SliderThumbElement.cpp:
        (WebCore::sliderPosition): Changed for using double return value.

2012-05-22  Kentaro Hara  <haraken@chromium.org>

        REGRESSION r110315: Event handler throws TypeError for an input element with name="arguments"
        https://bugs.webkit.org/show_bug.cgi?id=86991

        Reviewed by Ojan Vafai.

        Original Chromium bug: http://code.google.com/p/chromium/issues/detail?id=128723

        Consider the following html:

        <html><body><form>
        <input type="hidden" name="arguments"></input>
        <div onclick="onclicked()" id="divInsideForm">Click here</div>
        </form></body>
        <script>
        function onclicked() {
          alert("onclicked");
        }
        </script>
        </html>

        If we click "Click here", JavaScript throws "Uncaught TypeError: undefined has no properties".

        This is a regression caused by r110315. V8LazyEventListener should not use
        'arguments' to retrieve the execution contexts, since 'arguments' can be
        shadowed by JavaScript.

        This patch changes V8LazyEventListener so that it retrieves contexts
        by this[2], this[1] and this[0].

        Test: fast/forms/form-input-named-arguments.html

        * bindings/v8/V8LazyEventListener.cpp:
        (WebCore::V8LazyEventListener::prepareListenerObject):

2012-05-22  Kentaro Hara  <haraken@chromium.org>

        [V8] setDOMException() should return v8::Handle<v8::Value>()
        https://bugs.webkit.org/show_bug.cgi?id=87083

        Reviewed by Adam Barth.

        The following patterns are used here and there in V8 bindings:

            setDOMException();
            return v8::Handle<v8::Value>();

        and

            setDOMException();
            return v8::Undefined();

        By returning v8::Handle<v8::Value>() from setDOMException(), we can simplify the above patterns into this:

            return setDOMException();

        This patch just replaces the code in CodeGeneratorV8.pm. I'll replace
        all other custom bindings in a follow-up patch.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateSetDOMException):
        (GenerateFunctionCallback):
        (GenerateFunctionCallString):
        * bindings/scripts/test/V8/V8TestEventTarget.cpp:
        (WebCore::TestEventTargetV8Internal::itemCallback):
        (WebCore::TestEventTargetV8Internal::dispatchEventCallback):
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        (WebCore::TestInterfaceV8Internal::supplementalMethod2Callback):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::attrWithGetterExceptionAttrGetter):
        (WebCore::TestObjV8Internal::stringAttrWithGetterExceptionAttrGetter):
        (WebCore::TestObjV8Internal::withScriptStateAttributeRaisesAttrGetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAttributeRaisesAttrGetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateAttributeRaisesAttrGetter):
        (WebCore::TestObjV8Internal::methodThatRequiresAllArgsAndThrowsCallback):
        (WebCore::TestObjV8Internal::methodWithExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptStateVoidExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptStateObjExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateObjExceptionCallback):
        (WebCore::TestObjV8Internal::getSVGDocumentCallback):
        (WebCore::TestObjV8Internal::strictFunctionCallback):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::setDOMException):
        * bindings/v8/V8Proxy.h:
        (V8Proxy):

2012-05-22  MORITA Hajime  <morrita@google.com>

        Unreviewed expectations update against r117989.

        * bindings/scripts/test/V8/V8Float64Array.cpp:
        * bindings/scripts/test/V8/V8TestActiveDOMObject.cpp:
        * bindings/scripts/test/V8/V8TestCustomNamedGetter.cpp:
        * bindings/scripts/test/V8/V8TestEventConstructor.cpp:
        * bindings/scripts/test/V8/V8TestEventTarget.cpp:
        * bindings/scripts/test/V8/V8TestException.cpp:
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        * bindings/scripts/test/V8/V8TestMediaQueryListListener.cpp:
        * bindings/scripts/test/V8/V8TestNamedConstructor.cpp:
        * bindings/scripts/test/V8/V8TestNode.cpp:
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::V8TestObj::installPerContextProperties):
        * bindings/scripts/test/V8/V8TestSerializedScriptValueInterface.cpp:

2012-05-21  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: migrate dominatorIndex code to the front-end calculated dominatorsTree.
        https://bugs.webkit.org/show_bug.cgi?id=87024

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get dominatorIndex):
        (WebInspector.HeapSnapshot.prototype._init):

2012-05-22  Kentaro Hara  <haraken@chromium.org>

        [V8] Replace 'throwError(); return Undefined();' with 'return throwError()'
        https://bugs.webkit.org/show_bug.cgi?id=87079

        Reviewed by Adam Barth.

        This patch replaces

            throwError();
            return v8::Undefined();

        with

            return throwError();

        No tests. No change in behavior.

        * bindings/v8/DateExtension.cpp:
        (WebCore::DateExtension::OnSleepDetected):
        * bindings/v8/custom/V8HTMLDocumentCustom.cpp:
        (WebCore::V8HTMLDocument::openCallback):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::V8InjectedScriptHost::inspectedObjectCallback):
        * bindings/v8/custom/V8SQLResultSetRowListCustom.cpp:
        (WebCore::V8SQLResultSetRowList::itemCallback):
        * bindings/v8/custom/V8WebGLRenderingContextCustom.cpp:
        (WebCore::V8WebGLRenderingContext::getAttachedShadersCallback):
        (WebCore::V8WebGLRenderingContext::getProgramParameterCallback):
        (WebCore::V8WebGLRenderingContext::getShaderParameterCallback):
        (WebCore::V8WebGLRenderingContext::getUniformCallback):
        (WebCore::vertexAttribAndUniformHelperf):
        (WebCore::uniformHelperi):
        (WebCore::uniformMatrixHelper):

2012-05-22  Kenneth Russell  <kbr@google.com>

        Must set/reset pixel unpack alignment to 1 during texSubImage2D
        https://bugs.webkit.org/show_bug.cgi?id=86877

        Reviewed by James Robinson.

        Set pixel unpack alignment to 1 during upload, resetting afterward.

        Tests: fast/canvas/webgl/tex-image-and-sub-image-2d-with-canvas-rgb565.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-canvas-rgba4444.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-canvas-rgba5551.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-canvas.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-data-rgb565.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-data-rgba4444.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-data-rgba5551.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-rgb565.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-rgba4444.html
               fast/canvas/webgl/tex-image-and-sub-image-2d-with-image-rgba5551.html

        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::texSubImage2DImpl):
        (WebCore::WebGLRenderingContext::texSubImage2D):
            Set pixel unpack alignment to 1 during upload; reset afterward.

2012-05-21  Sam D  <dsam2912@gmail.com>

        Web Inspector: "Deactivate All Breakpoints" should visually get reflected in Breakpoints pane.
        https://bugs.webkit.org/show_bug.cgi?id=86844

        Reviewed by Pavel Feldman.

        Added an option for activate/deactivate breakpoints into Breakpoints
        pane section. Style properties has been attached with
        breakpoint list to reflect active state of breakpoints.

        No new tests. UI Change.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/BreakpointsSidebarPane.js:
        (WebInspector.JavaScriptBreakpointsSidebarPane.prototype._breakpointContextMenu):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._breakpointsActiveStateChanged):
        * inspector/front-end/inspector.css:
        (.breakpoints-list-deactivated):

2012-05-21  Alexis Menard  <alexis.menard@openbossa.org>

        Web Inspector: Remove some dead code in CSSStyleModel.js.
        https://bugs.webkit.org/show_bug.cgi?id=87048

        Reviewed by Pavel Feldman.

        Remove dead and unused code in CSSStyleModel.js.

        No new tests : the code is supposedly dead so we should not have
        any regressions.

        * inspector/front-end/CSSStyleModel.js:

2012-05-21  Adam Barth  <abarth@webkit.org>

        !HAVE(ACCESSIBILITY) should be able to build without linking in any code from WebCore/accessibility
        https://bugs.webkit.org/show_bug.cgi?id=87035

        Reviewed by Chris Fleizach.

        The OS(ANDROID) already builds with !HAVE(ACCESSIBILITY), but because
        there are a few straggling references to objects in the
        WebCore/accessibility directory, we end up pulling in a bunch of code
        into the binary that we don't need.

        This patch stubs out a few more functions for !HAVE(ACCESSIBILITY) so
        we can link without any objects from WebCore/accessibility. This patch
        also locks in that property by actually excluding the
        WebCore/accessibility directory from the build on OS(ANDROID).

        * WebCore.gyp/WebCore.gyp:
        * accessibility/AXObjectCache.h:
        (AXObjectCache):
        (WebCore::AXObjectCache::enableAccessibility):
        (WebCore::AXObjectCache::setEnhancedUserInterfaceAccessibility):
        (WebCore::AXObjectCache::accessibilityEnabled):
        (WebCore::AXObjectCache::accessibilityEnhancedUserInterfaceEnabled):
        (WebCore::AXObjectCache::AXObjectCache):
        (WebCore::AXObjectCache::~AXObjectCache):
        (WebCore::AXObjectCache::get):
        (WebCore::AXObjectCache::getOrCreate):
        (WebCore::AXObjectCache::rootObject):
        (WebCore::AXObjectCache::rootObjectForFrame):
        (WebCore::AXObjectCache::rootAXEditableElement):
        (WebCore::AXObjectCache::childrenChanged):
        (WebCore::AXObjectCache::contentChanged):
        (WebCore::AXObjectCache::detachWrapper):
        (WebCore::AXObjectCache::handleActiveDescendantChanged):
        (WebCore::AXObjectCache::handleAriaRoleChanged):
        (WebCore::AXObjectCache::handleFocusedUIElementChanged):
        (WebCore::AXObjectCache::handleScrolledToAnchor):
        (WebCore::AXObjectCache::nodeTextChangeNotification):
        (WebCore::AXObjectCache::nodeTextChangePlatformNotification):
        (WebCore::AXObjectCache::postNotification):
        (WebCore::AXObjectCache::postPlatformNotification):
        (WebCore::AXObjectCache::remove):
        (WebCore::AXObjectCache::selectedChildrenChanged):
        * accessibility/AccessibilityObject.h:
        (WebCore):
        (WebCore::AccessibilityObject::updateBackingStore):
        (WebCore::AccessibilityObject::lineForPosition):
        (WebCore::AccessibilityObject::children):

2012-05-21  Andreas Kling  <kling@webkit.org>

        Use stack-allocated BitArray in StylePropertySet serialization.
        <http://webkit.org/b/87071>

        Reviewed by Anders Carlsson.

        Use BitArray instead of BitVector to track seen properties in StylePropertySet::asText().
        This removes two heap allocations from this path.

        * css/StylePropertySet.cpp:
        (WebCore::StylePropertySet::asText):

2012-05-21  Hajime Morrita  <morrita@chromium.org>

        Unreviewed Qt build fix against r117898.

        * Target.pri:

2012-05-21  Hajime Morrita  <morrita@chromium.org>

        [V8] Shadow DOM should be per-window-configurable.
        https://bugs.webkit.org/show_bug.cgi?id=86555

        Reviewed by Kentaro Hara.

        This change introduces an IDL attribute named "V8EnabledAtContext"
        which allows DOMWindow properties to be turned on or off per
        windows basis. RuntimeEnabledFeatures::xxxAllowed() method decides the availability.

        - CodeGeneratorV8.pm now accepts V8EnabledAtContext and allows such properties
          to be configured per-Object basis, instead of per-ObjectTemplate basis.
          The script generates V8Window::installPerContextProperties(), which injects such
          per-object-turnable properties to newly created DOMWindow wrapper.
        - Added RuntimeEnabledFeatures::shadowDOMAllowed(DOMWindow*) which is used to
          decide the shadow dom availability of Shadow DOM feature.
          It delegates the call to FrameLoaderClient::shadowDOMAllowed() to make the decision.
        - The new IDL attribute is applied to DOMWindow.WebKitShadowRoot.
        - Updated existing shadowDOMEnabled() call sites with shadowDOMAllowed().

        No new tests except run-bindings-test. This isn't testable from
        DRT and this change itself doesn't chagne the behaviour.  It needs
        a client implementation.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/generic/ContextEnabledFeatures.cpp: Added.
        (WebCore):
        (WebCore::ContextEnabledFeatures::shadowDOMEnabled):
        * bindings/generic/ContextEnabledFeatures.h: Added.
        (WebCore):
        (ContextEnabledFeatures):
        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateHeader):
        (GenerateImplementation):
        (GetContextEnableFunction):
        * bindings/scripts/IDLAttributes.txt:
        * bindings/scripts/test/TestObj.idl:
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::enabledAtContextAttr1AttrGetter):
        (TestObjV8Internal):
        (WebCore::TestObjV8Internal::enabledAtContextAttr1AttrSetter):
        (WebCore::TestObjV8Internal::enabledAtContextAttr2AttrGetter):
        (WebCore::TestObjV8Internal::enabledAtContextAttr2AttrSetter):
        (WebCore::V8TestObj::installPerContextProperties):
        * bindings/scripts/test/V8/V8TestObj.h:
        (V8TestObj):
        * bindings/v8/V8DOMWindowShell.cpp:
        (WebCore::V8DOMWindowShell::installDOMWindow): Adopted installPerContextProperties()
        * bindings/v8/V8Proxy.h:
        (WebCore):
        (WebCore::configureAttribute): Generalized to accept both ObjectTemplate and Object.
        * dom/Position.cpp: Adopted ContextEnabledFeatures
        (WebCore::Position::Position):
        (WebCore::Position::findParent):
        * dom/ShadowRoot.idl:
        * dom/TreeScope.cpp:
        (WebCore::TreeScope::getSelection):
        * html/shadow/HTMLContentElement.cpp: Adopted ContextEnabledFeatures
        (WebCore::contentTagName):
        (WebCore::HTMLContentElement::create):
        * loader/FrameLoaderClient.h:
        (FrameLoaderClient):
        (WebCore::FrameLoaderClient::shadowDOMAllowed): Added with a default behavior.
        * page/DOMWindow.cpp:
        * page/DOMWindow.idl:


2012-05-21  Tony Chang  <tony@chromium.org>

        auto margins on flexbox should allocate space in the flex direction
        https://bugs.webkit.org/show_bug.cgi?id=83086

        Reviewed by Ojan Vafai.

        Test: css3/flexbox/flex-flow-auto-margins.html

        * rendering/RenderFlexibleBox.cpp:
        (WebCore::RenderFlexibleBox::autoMarginOffsetInMainAxis):
        (WebCore):
        (WebCore::RenderFlexibleBox::updateAutoMarginsInMainAxis):
        (WebCore::RenderFlexibleBox::layoutAndPlaceChildren): Update the margins on the RenderBox *after* we do the final child layout.
        * rendering/RenderFlexibleBox.h:

2012-05-21  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL] Add inital mediaControlsEflfullscreen.css for fullscreen control UI
        https://bugs.webkit.org/show_bug.cgi?id=86988

        Reviewed by Eric Carlson.

        In order to support fullscreen feature, EFL port needs to have new css file for fullscreen media control UI.

        No new tests because this patch is covered by existing tests.

        * PlatformEfl.cmake:
        * css/mediaControlsEflFullscreen.css: Added.
        (video::-webkit-media-controls-panel):
        (video:-webkit-full-page-media::-webkit-media-controls-panel):
        (video::-webkit-media-controls-mute-button):
        (video::-webkit-media-controls-play-button):
        (video::-webkit-media-controls-timeline-container):
        (video::-webkit-media-controls-current-time-display):
        (video::-webkit-media-controls-time-remaining-display):
        (video::-webkit-media-controls-timeline):
        (video::-webkit-media-controls-volume-slider-container):
        (video::-webkit-media-controls-volume-slider):
        (video::-webkit-media-controls-seek-back-button):
        (video::-webkit-media-controls-seek-forward-button):
        (video::-webkit-media-controls-fullscreen-button):
        (video::-webkit-media-controls-rewind-button):
        (video::-webkit-media-controls-return-to-realtime-button):
        (video::-webkit-media-controls-toggle-closed-captions-button):
        * platform/efl/RenderThemeEfl.cpp:
        (WebCore):
        (WebCore::RenderThemeEfl::extraFullScreenStyleSheet):
        * platform/efl/RenderThemeEfl.h:
        (RenderThemeEfl):

2012-05-21  Kentaro Hara  <haraken@chromium.org>

        [V8] Remove V8Proxy::notHandledByInterceptor()
        https://bugs.webkit.org/show_bug.cgi?id=86831

        Reviewed by Adam Barth.

        This patch replaces 'return V8Proxy::notHandledByInterceptor()'
        with 'return v8::Handle<v8::Value>()'. See the discussion in
        https://bugs.webkit.org/show_bug.cgi?id=85330 for more details.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateOverloadedFunctionCallback):
        (GenerateParametersCheck):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::overloadedMethodCallback):
        (WebCore::TestObjV8Internal::overloadedMethod1Callback):
        * bindings/v8/V8Collection.h:
        (WebCore::collectionNamedPropertyGetter):
        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore::V8DOMWrapper::convertEventTargetToV8Object):
        * bindings/v8/V8NPObject.cpp:
        (WebCore::npObjectSetProperty):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::runScript):
        (WebCore::V8Proxy::throwError):
        * bindings/v8/V8Proxy.h:
        (WebCore):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArrayWithArrayBufferArgument):
        (WebCore::setWebGLArrayHelper):
        * bindings/v8/custom/V8CSSStyleDeclarationCustom.cpp:
        (WebCore::V8CSSStyleDeclaration::namedPropertyGetter):
        (WebCore::V8CSSStyleDeclaration::namedPropertySetter):
        * bindings/v8/custom/V8DOMStringMapCustom.cpp:
        (WebCore::V8DOMStringMap::namedPropertyGetter):
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::V8DOMWindow::indexedPropertyGetter):
        (WebCore::V8DOMWindow::namedPropertyGetter):
        * bindings/v8/custom/V8HTMLAllCollectionCustom.cpp:
        (WebCore::V8HTMLAllCollection::namedPropertyGetter):
        * bindings/v8/custom/V8HTMLCollectionCustom.cpp:
        (WebCore::V8HTMLCollection::namedPropertyGetter):
        * bindings/v8/custom/V8HTMLFormElementCustom.cpp:
        (WebCore::V8HTMLFormElement::indexedPropertyGetter):
        (WebCore::V8HTMLFormElement::namedPropertyGetter):
        * bindings/v8/custom/V8HTMLFrameSetElementCustom.cpp:
        (WebCore::V8HTMLFrameSetElement::namedPropertyGetter):
        * bindings/v8/custom/V8HTMLOptionsCollectionCustom.cpp:
        (WebCore::V8HTMLOptionsCollection::indexedPropertyGetter):
        * bindings/v8/custom/V8HTMLPlugInElementCustom.cpp:
        (WebCore::npObjectNamedGetter):
        (WebCore::npObjectNamedSetter):
        (WebCore::npObjectIndexedGetter):
        (WebCore::npObjectIndexedSetter):
        * bindings/v8/custom/V8HTMLSelectElementCustom.cpp:
        (WebCore::V8HTMLSelectElement::indexedPropertyGetter):
        * bindings/v8/custom/V8NamedNodeMapCustom.cpp:
        (WebCore::V8NamedNodeMap::indexedPropertyGetter):
        (WebCore::V8NamedNodeMap::namedPropertyGetter):
        * bindings/v8/custom/V8NodeListCustom.cpp:
        (WebCore::V8NodeList::namedPropertyGetter):
        * bindings/v8/custom/V8StorageCustom.cpp:
        (WebCore::storageGetter):
        (WebCore::V8Storage::namedPropertyGetter):
        (WebCore::storageSetter):
        * bindings/v8/custom/V8StyleSheetListCustom.cpp:
        (WebCore::V8StyleSheetList::namedPropertyGetter):
        * bindings/v8/custom/V8WebGLRenderingContextCustom.cpp:
        (WebCore::V8WebGLRenderingContext::getAttachedShadersCallback):
        (WebCore::V8WebGLRenderingContext::getProgramParameterCallback):
        (WebCore::V8WebGLRenderingContext::getShaderParameterCallback):
        (WebCore::V8WebGLRenderingContext::getUniformCallback):
        (WebCore::vertexAttribAndUniformHelperf):
        (WebCore::uniformHelperi):
        (WebCore::uniformMatrixHelper):

2012-05-21  Rob Buis  <rbuis@rim.com>

        Shrink FontDescription object size
        https://bugs.webkit.org/show_bug.cgi?id=86950

        Reviewed by Alexey Proskuryakov.

        Reduce object size of FontDescription by 8 bytes on 64-bit, 4 bytes on 32-bit systems.
        Note that this means Font, StyleInheritedData and RenderSVGInlineText shrink too.

        * platform/graphics/FontDescription.cpp:
        * platform/graphics/FontDescription.h:
        (WebCore::FontDescription::script):
        (FontDescription):

2012-05-21  Abhishek Arya  <inferno@chromium.org>

        Regression(r117482): Run-in crashes relating to generated content and inline line box clearing.
        https://bugs.webkit.org/show_bug.cgi?id=86879

        Reviewed by Julien Chaffraix.

        Tests: fast/runin/generated-content-crash.html
               fast/runin/move-run-in-original-position-crash.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks): Use the new helper
        placeRunInIfNeeded. Do not place the run-in if it is a generated container since
        the caller such as updateBeforeAfterContent might be keeping a reference to it
        and adding children to it later.
        (WebCore::destroyRunIn): Add ability to clear line box tree for inlines.
        (WebCore::RenderBlock::placeRunInIfNeeded): Helper to place run-in. Add an
        argument to not modify generated content during addChild, it should be moved
        only at end of updateBeforeAfterContent.
        (WebCore::RenderBlock::moveRunInUnderSiblingBlockIfNeeded): 
        (WebCore::RenderBlock::runInIsPlacedIntoSiblingBlock): helper to tell if this run-in
        is actually placed into the next sibling block.
        (WebCore::RenderBlock::moveRunInToOriginalPosition):
        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::deleteLineBoxTree): like RenderBlock, add a helper
        for deleteLineBoxTree. Virtualizing this might not be good, since this is
        the only call site for inline line box tree clearing and RenderBlock::deleteLineBoxTree
        is called a lot.
        * rendering/RenderObjectChildList.cpp:
        (WebCore::createRendererForBeforeAfterContent): fix a typo.
        (WebCore::RenderObjectChildList::updateBeforeAfterContent): If insertBefore is equal
        to the intruded run-in, then set it to next sibling so that new child will come after it. At
        the end, place the generatedContainer if it is a run-in.

2012-05-21  James Robinson  <jamesr@chromium.org>

        [chromium] Port chromium compositor to use WebFilterOperation(s)
        https://bugs.webkit.org/show_bug.cgi?id=87046

        Reviewed by Adrienne Walker.

        This converts all compositor implementation logic to use WebFilterOperation(s) directly instead of the WebCore
        types. GraphicsLayerChromium bridges between a WebCore::FilterOperations to WebFilterOperations, doing the
        necessary type conversions and checking for filters that our compositor implementation supports. This cleans up
        the chromium compositor's dependencies and removes any thread constraints from WebCore::FilterOperation /
        WebCore::FilterOperations.

        Covered by existing layout tests and unit tests in FilterOperationsTest.cpp

        * WebCore.gyp/WebCore.gyp:
        * WebCore.gypi:
        * platform/chromium/support/WebFilterOperations.cpp: Moved to Source/Platform/chromium/src/
        * platform/graphics/chromium/GraphicsLayerChromium.cpp:
        (WebCore::copyWebCoreFilterOperationsToWebFilterOperations):
        (WebCore):
        (WebCore::GraphicsLayerChromium::setFilters):
        (WebCore::GraphicsLayerChromium::setBackgroundFilters):
        (WebCore::GraphicsLayerChromium::updateTransform):
        (WebCore::GraphicsLayerChromium::updateChildrenTransform):
        * platform/graphics/chromium/GraphicsLayerChromium.h:
        (GraphicsLayerChromium):
        * platform/graphics/chromium/LayerChromium.cpp:
        (WebCore::LayerChromium::setFilters):
        (WebCore::LayerChromium::setBackgroundFilters):
        (WebCore::LayerChromium::pushPropertiesTo):
        * platform/graphics/chromium/LayerChromium.h:
        (LayerChromium):
        (WebCore::LayerChromium::filters):
        (WebCore::LayerChromium::backgroundFilters):
        * platform/graphics/chromium/RenderSurfaceChromium.h:
        (WebCore::RenderSurfaceChromium::setFilters):
        (WebCore::RenderSurfaceChromium::filters):
        (WebCore::RenderSurfaceChromium::setBackgroundFilters):
        (WebCore::RenderSurfaceChromium::backgroundFilters):
        (RenderSurfaceChromium):
        * platform/graphics/chromium/cc/CCDamageTracker.cpp:
        (WebCore::expandDamageRectWithFilters):
        (WebCore::expandDamageRectInsideRectWithFilters):
        (WebCore::CCDamageTracker::updateDamageTrackingState):
        * platform/graphics/chromium/cc/CCDamageTracker.h:
        (WebKit):
        (WebCore):
        (CCDamageTracker):
        * platform/graphics/chromium/cc/CCLayerImpl.cpp:
        (WebCore::CCLayerImpl::setFilters):
        (WebCore::CCLayerImpl::setBackgroundFilters):
        * platform/graphics/chromium/cc/CCLayerImpl.h:
        (CCLayerImpl):
        (WebCore::CCLayerImpl::filters):
        (WebCore::CCLayerImpl::backgroundFilters):
        * platform/graphics/chromium/cc/CCRenderSurface.cpp:
        (WebCore::CCRenderSurface::applyFilters):
        * platform/graphics/chromium/cc/CCRenderSurface.h:
        (WebCore::CCRenderSurface::setFilters):
        (WebCore::CCRenderSurface::filters):
        (CCRenderSurface):
        (WebCore::CCRenderSurface::setBackgroundFilters):
        (WebCore::CCRenderSurface::backgroundFilters):
        * platform/graphics/chromium/cc/CCRenderSurfaceFilters.cpp:
        (WebCore::CCRenderSurfaceFilters::apply):
        * platform/graphics/chromium/cc/CCRenderSurfaceFilters.h:
        (WebKit):
        (CCRenderSurfaceFilters):
        * testing/Internals.cpp:
        (WebCore::Internals::setBackgroundBlurOnNode):

2012-05-15  Gavin Barraclough  <barraclough@apple.com>

        Add support for private names
        https://bugs.webkit.org/show_bug.cgi?id=86509

        Reviewed by Oliver Hunt.

        The spec isn't final, but we can start adding support to allow property maps
        to contain keys that aren't identifiers.

        Test: fast/js/names.html

        * bindings/js/JSCSSStyleDeclarationCustom.cpp:
        (WebCore::cssPropertyIDForJSCSSPropertyName):
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::findAtomicString):
        (WebCore::objectToStringFunctionGetter):
        * bindings/js/JSDOMBinding.h:
        (WebCore::propertyNameToString):
        (WebCore::propertyNameToAtomicString):
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::nonCachingStaticFunctionGetter):
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::nonCachingStaticBackFunctionGetter):
        (WebCore::nonCachingStaticForwardFunctionGetter):
        (WebCore::nonCachingStaticGoFunctionGetter):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::nonCachingStaticReplaceFunctionGetter):
        (WebCore::nonCachingStaticReloadFunctionGetter):
        (WebCore::nonCachingStaticAssignFunctionGetter):
        * bridge/c/c_class.cpp:
        (JSC::Bindings::CClass::methodsNamed):
        (JSC::Bindings::CClass::fieldNamed):
        * bridge/c/c_instance.cpp:
        (JSC::Bindings::CInstance::getMethod):
        * bridge/jni/jsc/JavaClassJSC.cpp:
        (JavaClass::methodsNamed):
        (JavaClass::fieldNamed):
        * bridge/jni/jsc/JavaInstanceJSC.cpp:
        * bridge/objc/objc_class.mm:
        (JSC::Bindings::ObjcClass::methodsNamed):
        (JSC::Bindings::ObjcClass::fieldNamed):
        (JSC::Bindings::ObjcClass::fallbackObject):
        * bridge/objc/objc_instance.mm:
        (ObjcInstance::setValueOfUndefinedField):
        (ObjcInstance::getValueOfUndefinedField):
            - Removed PropertyName::impl(), call publicName() to get the string associated with a name.

2012-05-21  Tim Horton  <timothy_horton@apple.com>

        GeneratorGeneratedImage should cache intermediate images
        https://bugs.webkit.org/show_bug.cgi?id=86906
        <rdar://problem/11484852>

        Reviewed by Dean Jackson.

        Cache generated images in GeneratorGeneratedImage. The cache is invalidated:
            a) if the Generator's hash changes.
            b) if the rendered size changes.
            c) if the cached image is incompatible with the destination context (acceleration state or CTM scale).
            d) after one second of disuse.

        Add a hash() function to Generator, which should be implemented in subclasses
        to provide a straightforward way to determine if Generators have been mutated
        in a way that will affect the resultant rendering.

        No new tests, performance optimization. Correctness is covered by the multitude of existing gradient tests.

        * platform/graphics/Generator.h:
        (Generator):
        * platform/graphics/GeneratorGeneratedImage.cpp:
        (WebCore::GeneratorGeneratedImage::drawPattern):
        * platform/graphics/GeneratorGeneratedImage.h:
        (WebCore):
        (GeneratorGeneratedImage):
        (WebCore::GeneratorGeneratedImage::~GeneratorGeneratedImage):
        (WebCore::GeneratorGeneratedImage::GeneratorGeneratedImage):
        (GeneratedImageCacheTimer):
        (WebCore::GeneratorGeneratedImage::GeneratedImageCacheTimer::GeneratedImageCacheTimer):
        (WebCore::GeneratorGeneratedImage::GeneratedImageCacheTimer::restart):
        * platform/graphics/Gradient.cpp:
        (WebCore::Gradient::Gradient):
        (WebCore::Gradient::addColorStop):
        (WebCore::Gradient::sortStopsIfNecessary):
        (WebCore::Gradient::setSpreadMethod):
        (WebCore::Gradient::setGradientSpaceTransform):
        (WebCore::Gradient::hash):
        * platform/graphics/Gradient.h:
        (WebCore::Gradient::setP0):
        (WebCore::Gradient::setP1):
        (WebCore::Gradient::setStartRadius):
        (WebCore::Gradient::setEndRadius):
        (Gradient):
        (WebCore::Gradient::clearHashCache):
        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::isCompatibleWithBuffer):
        (WebCore):
        * platform/graphics/GraphicsContext.h:
        (GraphicsContext):

2012-05-21  Emil A Eklund  <eae@chromium.org>

        Fix bug in paintNinePieceImage exposed by subpixel change
        https://bugs.webkit.org/show_bug.cgi?id=87060

        Reviewed by Levi Weintraub.

        Fix rounding in paintNinePieceImage where the left/right images where
        drawn on subpixel bounds.

        Covered by existing tests.

        * rendering/RenderBoxModelObject.cpp:
        (WebCore::RenderBoxModelObject::paintNinePieceImage):

2012-05-21  Emil A Eklund  <eae@chromium.org>

        Move padding/margin/offset writing mode logic from RenderStyle to LengthBox
        https://bugs.webkit.org/show_bug.cgi?id=86970

        Reviewed by Eric Seidel.

        Move writing mode and bidi logic for paddings, margins and offsets from
        RenderStyle to LengthBox. This way the same logic can be used for all
        three removing unnecessary code duplication.

        No new tests, no change in functionality.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/LengthBox.cpp: Added.
        * platform/LengthBox.h:
        * rendering/style/RenderStyle.cpp:
        * rendering/style/RenderStyle.h:

2012-05-21  Mike West  <mkwst@chromium.org>

        Improving console error for CSP-blocked  `setTimeout` and `setInterval` evaluation.
        https://bugs.webkit.org/show_bug.cgi?id=86943

        Reviewed by Adam Barth.

        If the inspector is open, a stack trace is generated before calling
        ContentSecurityPolicy::allowEval, and passed through to
        ContentSecurityPolicy::reportViolation for use in the console message.

        Test: http/tests/inspector-enabled/contentSecurityPolicy-blocks-setInterval.html
              http/tests/inspector-enabled/contentSecurityPolicy-blocks-setTimeout.html

        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::create):
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::WindowSetTimeoutImpl):
        * page/ContentSecurityPolicy.cpp:
        (CSPDirectiveList):
        (WebCore::CSPDirectiveList::reportViolation):
        (WebCore::CSPDirectiveList::checkEvalAndReportViolation):
        (WebCore::CSPDirectiveList::allowEval):
        (WebCore):
        (WebCore::isAllowedByAllWithCallStack):
        (WebCore::isAllowedByAllWithURL):
        (WebCore::ContentSecurityPolicy::allowEval):
        (WebCore::ContentSecurityPolicy::allowScriptFromSource):
        (WebCore::ContentSecurityPolicy::allowObjectFromSource):
        (WebCore::ContentSecurityPolicy::allowChildFrameFromSource):
        (WebCore::ContentSecurityPolicy::allowImageFromSource):
        (WebCore::ContentSecurityPolicy::allowStyleFromSource):
        (WebCore::ContentSecurityPolicy::allowFontFromSource):
        (WebCore::ContentSecurityPolicy::allowMediaFromSource):
        (WebCore::ContentSecurityPolicy::allowConnectToSource):
        * page/ContentSecurityPolicy.h:
        (WebCore):

2012-05-21  Antoine Labour  <piman@chromium.org>

        Don't force rendering in finishAllRendering
        https://bugs.webkit.org/show_bug.cgi?id=86919

        Reviewed by James Robinson.

        After we acquire the texture layers on the main thread, we can't draw.
        In particular if we destroyed the texture ids used previously by
        TextureLayerChromium, drawing before a commit would cause a
        bind-after-destroy.

        Tested by CCLayerTreeHostTestFinishAllRendering.

        * platform/graphics/chromium/cc/CCThreadProxy.cpp:
        (WebCore::CCThreadProxy::CCThreadProxy):
        (WebCore::CCThreadProxy::finishAllRenderingOnImplThread):
        (WebCore::CCThreadProxy::scheduledActionDrawAndSwapInternal):

2012-05-21  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Store key paths in IDBKeyPath type instead of String
        https://bugs.webkit.org/show_bug.cgi?id=85298

        Reviewed by Tony Chang, Kentaro Hara and James Robinson.

        Migrate from storing key paths as (nullable) Strings to a dedicated IDBKeyPath
        type. Prep work for supporting array-type key paths: http://webkit.org/b/84207

        Only functional change is handling of null/undefined parameters for key paths,
        to align with IDB spec, covered by layout test.

        Test: storage/indexeddb/keypath-basics.html
        Test: WebKit/chromium/IDBLevelDBCodingTest.cpp

        * Modules/indexeddb/IDBAny.cpp: Allow IDBAny to yield DOMStrings.
        (WebCore::IDBAny::createString):
        (WebCore):
        (WebCore::IDBAny::string):
        (WebCore::IDBAny::set):
        * Modules/indexeddb/IDBAny.h:
        (IDBAny):
        * Modules/indexeddb/IDBBackingStore.h: Switch from String to IDBKeyPath.
        (IDBBackingStore):
        * Modules/indexeddb/IDBDatabase.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBDatabase::createObjectStore):
        * Modules/indexeddb/IDBDatabaseBackendImpl.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBDatabaseBackendImpl::createObjectStore):
        (WebCore::IDBDatabaseBackendImpl::loadObjectStores):
        * Modules/indexeddb/IDBDatabaseBackendImpl.h: Switch from String to IDBKeyPath.
        (IDBDatabaseBackendImpl):
        * Modules/indexeddb/IDBDatabaseBackendInterface.h: Switch from String to IDBKeyPath.
        (WebCore):
        (IDBDatabaseBackendInterface):
        * Modules/indexeddb/IDBIndex.h: Switch from String to IDBAny (via IDBKeyPath).
        (WebCore::IDBIndex::keyPath):
        * Modules/indexeddb/IDBIndex.idl: Switch from DOMString? to IDBAny.
        * Modules/indexeddb/IDBIndexBackendImpl.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBIndexBackendImpl::IDBIndexBackendImpl):
        * Modules/indexeddb/IDBIndexBackendImpl.h: Switch from String to IDBKeyPath.
        (WebCore::IDBIndexBackendImpl::create):
        (WebCore::IDBIndexBackendImpl::keyPath):
        (IDBIndexBackendImpl):
        * Modules/indexeddb/IDBIndexBackendInterface.h: Switch from String to IDBKeyPath.
        (WebCore):
        (IDBIndexBackendInterface):
        * Modules/indexeddb/IDBKeyPath.cpp: Non-trivial method implementations.
        (WebCore::IDBKeyPath::isValid):
        (WebCore):
        (WebCore::IDBKeyPath::operator PassRefPtr<IDBAny>):
        * Modules/indexeddb/IDBKeyPath.h: Introduce IDBKeyPath type.
        (IDBKeyPath):
        (WebCore::IDBKeyPath::IDBKeyPath):
        (WebCore::IDBKeyPath::type):
        (WebCore::IDBKeyPath::array):
        (WebCore::IDBKeyPath::string):
        (WebCore::IDBKeyPath::isNull):
        (WebCore):
        * Modules/indexeddb/IDBKeyPathBackendImpl.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBKeyPathBackendImpl::createIDBKeysFromSerializedValuesAndKeyPath):
        (WebCore::IDBKeyPathBackendImpl::injectIDBKeyIntoSerializedValue):
        * Modules/indexeddb/IDBKeyPathBackendImpl.h: Switch from String to IDBKeyPath.
        (WebCore):
        (IDBKeyPathBackendImpl):
        * Modules/indexeddb/IDBLevelDBBackingStore.cpp: Switch from String to IDBKeyPath, with back-compat.
        (WebCore):
        (WebCore::putIDBKeyPath):
        (WebCore::IDBLevelDBBackingStore::getObjectStores):
        (WebCore::IDBLevelDBBackingStore::createObjectStore):
        (WebCore::IDBLevelDBBackingStore::getIndexes):
        (WebCore::IDBLevelDBBackingStore::createIndex):
        * Modules/indexeddb/IDBLevelDBBackingStore.h:
        (IDBLevelDBBackingStore):
        * Modules/indexeddb/IDBLevelDBCoding.cpp: New coding scheme for key paths (with back-compat).
        (IDBLevelDBCoding):
        (WebCore::IDBLevelDBCoding::encodeIDBKeyPath):
        (WebCore::IDBLevelDBCoding::decodeIDBKeyPath):
        * Modules/indexeddb/IDBLevelDBCoding.h: Add key-path-specific methods.
        (WebCore):
        (IDBLevelDBCoding):
        * Modules/indexeddb/IDBObjectStore.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBObjectStore::keyPath):
        (WebCore::IDBObjectStore::createIndex):
        (WebCore):
        * Modules/indexeddb/IDBObjectStore.h: Switch from String to IDBAny (via IDBKeyPath).
        (IDBObjectStore):
        * Modules/indexeddb/IDBObjectStore.idl: Switch from DOMString? to IDBAny.
        * Modules/indexeddb/IDBObjectStoreBackendImpl.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBObjectStoreBackendImpl::IDBObjectStoreBackendImpl):
        (WebCore::fetchKeyFromKeyPath):
        (WebCore::injectKeyIntoKeyPath):
        (WebCore::IDBObjectStoreBackendImpl::createIndex):
        (WebCore::IDBObjectStoreBackendImpl::loadIndexes):
        * Modules/indexeddb/IDBObjectStoreBackendImpl.h: Switch from String to IDBKeyPath.
        (WebCore::IDBObjectStoreBackendImpl::create):
        (WebCore::IDBObjectStoreBackendImpl::keyPath):
        (IDBObjectStoreBackendImpl):
        * Modules/indexeddb/IDBObjectStoreBackendInterface.h: Switch from String to IDBKeyPath.
        (WebCore):
        (IDBObjectStoreBackendInterface):
        * bindings/v8/Dictionary.cpp: Add getter for DOMString[] (i.e. Vector<String>)
        (WebCore):
        (WebCore::Dictionary::get):
        * bindings/v8/Dictionary.h:
        (Dictionary):
        * bindings/v8/IDBBindingUtilities.cpp: Switch from String to IDBKeyPath.
        (WebCore::createIDBKeyFromSerializedValueAndKeyPath):
        (WebCore::injectIDBKeyIntoSerializedValue):
        * bindings/v8/IDBBindingUtilities.h: Switch from String to IDBKeyPath.
        (WebCore):
        * bindings/v8/custom/V8IDBAnyCustom.cpp: Support String/DOMString.
        (WebCore::toV8):
        * dom/DOMStringList.h: Allow easy (const) access to strings.
        (WebCore::DOMStringList::operator const Vector<String>&):
        (DOMStringList):
        * inspector/InspectorIndexedDBAgent.cpp: Temporary shim for non-strings: see http://webkit.org/b/84303
        (WebCore):
        * platform/chromium/PlatformSupport.h: Switch from String to IDBKeyPath.
        (WebCore):
        (PlatformSupport):
        * storage/chromium/IDBKeyPathBackendImpl.cpp: Switch from String to IDBKeyPath.
        (WebCore::IDBKeyPathBackendImpl::createIDBKeysFromSerializedValuesAndKeyPath):
        (WebCore::IDBKeyPathBackendImpl::injectIDBKeyIntoSerializedValue):

2012-05-21  Zhenyao Mo  <zmo@google.com>

        Restore WebGL's framebuffer binding after DrawingBuffer's prepareBackBuffer()
        https://bugs.webkit.org/show_bug.cgi?id=87032

        Reviewed by James Robinson.

        * platform/graphics/chromium/DrawingBufferChromium.cpp:
        (WebCore::DrawingBuffer::prepareBackBuffer): restore the user's framebuffer binding if there is one.

2012-05-21  Ryosuke Niwa  <rniwa@webkit.org>

        isStartOfDocument and isEndOfDocument are poorly named
        https://bugs.webkit.org/show_bug.cgi?id=86649

        Reviewed by Levi Weintraub.

        Renamed isEndOfDocument to isEndOfEditableOrNonEditableContent because that's what this function checks.

        Also added new versions of isStartOfDocument and isEndOfDocument that correctly cross editing boundaries
        to be used in selectFrameElementInParentIfFullySelected.

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::moveParagraphContentsToNewBlockIfNecessary):
        * editing/Editor.cpp:
        (WebCore::Editor::insertLineBreak):
        (WebCore::Editor::insertParagraphSeparator):
        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplaceSelectionCommand::doApply):
        * editing/VisibleSelection.cpp:
        (WebCore::VisibleSelection::setStartAndEndFromBaseAndExtentRespectingGranularity):
        * editing/visible_units.cpp:
        (WebCore::isEndOfEditableOrNonEditableContent):
        * editing/visible_units.h:

2012-05-21 Anna Cavender  <annacc@chromium.org>

        Only render text track cues if kind=captions or kind=subtitles.
        https://bugs.webkit.org/show_bug.cgi?id=83321

        Reviewed by Eric Carlson.

        No new tests. Modification to media/track/track-kind.html

        * html/HTMLMediaElement.cpp:
        (WebCore::HTMLMediaElement::textTrackKindChanged):
           If the kind changes from a 'visible' kind to a 'non-visible' kind,
           update the track's mode to HIDDEN.

        * html/shadow/MediaControlElements.cpp:
        (WebCore::MediaControlTextTrackContainerElement::updateDisplay):
            Do not render cues from tracks that are not captions or subtitles.

        * html/track/TextTrack.cpp:
        (WebCore::TextTrack::setMode):
            If the track's mode changes from SHOWING to HIDDEN or DISABLED,
            ensure any currently visible cues will no longer be rendered.

        * html/track/TextTrackCue.cpp:
        (WebCore::TextTrackCue::removeDisplayTree): New method.
        * html/track/TextTrackCue.h:
        (TextTrackCue):
 
2012-05-21  Andreas Kling  <kling@webkit.org>

        CSS: Move duplicate property elimination to parser.
        <http://webkit.org/b/86948>

        Reviewed by Antti Koivisto.

        Remove the StylePropertySet constructor that handled elimination of duplicate
        properties and move that to a new parser method, CSSParser::filteredProperties().
        Call sites are converted to using StylePropertySet(const Vector<CSSProperty>&).

        Instead of building a hashmap of seen properties, use the new WTF::BitArray class
        to track whether a given property ID has been seen, and whether we have an
        !important entry for a given ID.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        (WebCore::CSSParser::parseDeclaration):
        (WebCore::CSSParser::filteredProperties):
        (WebCore::CSSParser::createStyleRule):
        (WebCore::CSSParser::createFontFaceRule):
        (WebCore::CSSParser::createPageRule):
        (WebCore::CSSParser::createKeyframe):
        * css/CSSParser.h:
        * css/StylePropertySet.cpp:
        (WebCore::StylePropertySet::StylePropertySet):
        (WebCore::StylePropertySet::addParsedProperties):
        * css/StylePropertySet.h:
        (WebCore::StylePropertySet::create):
        (StylePropertySet):
        * svg/SVGFontFaceElement.cpp:
        (WebCore::SVGFontFaceElement::rebuildFontFace):

2012-05-21  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Index key paths that yield invalid keys should not fail an add/put
        https://bugs.webkit.org/show_bug.cgi?id=86122

        Reviewed by Tony Chang.

        A clause was removed from the IDB spec. Previously, on add/put, if evaluating an
        index's key path yielded a value that was not a valid key, an exception would be
        raised. Now, it is treated the same as if no value was yielded.

        Test: storage/indexeddb/index-basics.html
        Test: storage/indexeddb/index-basics-workers.html
        Test: storage/indexeddb/objectstore-basics.html
        Test: storage/indexeddb/objectstore-basics-workers.html

        * Modules/indexeddb/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::put): Preconditions removed
        (WebCore::IDBObjectStoreBackendImpl::putInternal): Treat invalid keys the same as missing keys.

2012-05-21  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: refactor revision history to not include resource itself.
        https://bugs.webkit.org/show_bug.cgi?id=87026

        Reviewed by Vsevolod Vlasov.

        This change makes resource contain pure revisions, it stops updating Resources upon free flow editing.

        * inspector/front-end/JavaScriptSource.js:
        (WebInspector.JavaScriptSource.prototype.setFormatted.didGetContent.didFormatContent):
        (WebInspector.JavaScriptSource.prototype.setFormatted.didGetContent):
        (WebInspector.JavaScriptSource.prototype.setFormatted):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        (WebInspector.JavaScriptSourceFrame.prototype._onContentChanged):
        (WebInspector.JavaScriptSourceFrame.prototype._didEditContent):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.addRevision):
        (WebInspector.Resource.prototype._innerRequestContent.callback):
        (WebInspector.Resource.prototype._innerRequestContent):
        (WebInspector.Resource.prototype.revertToOriginal):
        (WebInspector.ResourceRevision.prototype.revertToThis):
        (WebInspector.ResourceRevision.prototype.requestContent):
        (WebInspector.ResourceRevision.prototype.searchInContent):
        (WebInspector.ResourceRevision.prototype._persistRevision):
        * inspector/front-end/RevisionHistoryView.js:
        (WebInspector.RevisionHistoryView):
        (WebInspector.RevisionHistoryView.prototype._revisionAdded):
        (WebInspector.RevisionHistoryTreeElement):
        * inspector/front-end/ScriptSnippetModel.js:
        (WebInspector.ScriptSnippetModel.prototype.setScriptSnippetContent):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSourceFrame.prototype.commitEditing):
        (WebInspector.StyleSourceFrame.prototype._didEditContent):
        (WebInspector.StyleSourceFrame.prototype._onContentChanged):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype._revisionAdded):
        (WebInspector.UISourceCode.prototype.contentChanged):
        (WebInspector.UISourceCode.prototype.commitWorkingCopy):
        * inspector/front-end/inspector.js:
        (WebInspector._doLoadedDoneWithCapabilities.get if):

2012-05-21  Allan Sandfeld Jensen  <allan.jensen@nokia.com>

        GCC 4.7 and C++11
        https://bugs.webkit.org/show_bug.cgi?id=86465

        Reviewed by Darin Adler.

        Avoid triggering C++11 string literals and use nullptr for correct type casting.

        * bindings/js/JSNodeFilterCondition.cpp:
        (WebCore::JSNodeFilterCondition::JSNodeFilterCondition):
        * platform/sql/SQLiteFileSystem.cpp:
        (WebCore::SQLiteFileSystem::getFileNameForNewDatabase):

2012-05-18  Michael Nordman  <michaeln@google.com>

        [chromium] DomStorage events handling needs TLC (2)
        https://bugs.webkit.org/show_bug.cgi?id=85221
        Alter the StorageArea virtual interface such that the mutators no longer
        return old values. This is to allow implementations of the interface to operate
        more asynchronously.

        Reviewed by Adam Barth.

        No new tests. Existing tests cover this.

        * storage/StorageArea.h: Alter the interface so the mutators no longer return previous values
        * storage/StorageAreaImpl.cpp:
        (WebCore::StorageAreaImpl::disabledByPrivateBrowsingInFrame):  removed an unneeded PLATFORM(CHROMIUM) guard
        (WebCore::StorageAreaImpl::setItem): no longer return the old value
        (WebCore::StorageAreaImpl::removeItem): no longer return the old value
        (WebCore::StorageAreaImpl::clear): no longer return whether something was cleared
        * storage/StorageAreaImpl.h: match StorageArea's virtual interface


2012-05-21  MORITA Hajime  <morrita@google.com>

        [Refactoring] Node should have youngestShadowRoot.
        https://bugs.webkit.org/show_bug.cgi?id=86427

        Reviewed by Dimitri Glazkov.

        This change adds Node::youngestShadowRoot() and replaced
        ElementShadow::youngestShadowRoot() with it if appropriate.

        By introducing this, traversal across node and its shadow tree can
        look more fluent and idiomatic. There are a few non-trivial traversal
        remaining like ElementShadow::recalcStyle() and attach().
        But they should be flattened out eventually.

        No new tests. Refactoring.

        * dom/ContainerNodeAlgorithms.cpp:
        (WebCore::ChildNodeInsertionNotifier::notifyDescendantInsertedIntoTree):
        * dom/Document.cpp:
        (WebCore::Document::buildAccessKeyMap):
        * dom/ElementShadow.cpp:
        * dom/ElementShadow.h:
        (ElementShadow):
        (WebCore::Node::youngestShadowRoot):
        (WebCore):
        * dom/Node.h:
        (Node):
        * dom/TreeScopeAdopter.cpp:
        (WebCore::TreeScopeAdopter::moveTreeToNewScope):
        (WebCore::TreeScopeAdopter::moveTreeToNewDocument):
        * dom/TreeScopeAdopter.h:
        (TreeScopeAdopter):
        * html/shadow/TextFieldDecorationElement.cpp:
        (WebCore::getDecorationRootAndDecoratedRoot):

2012-05-21  Christophe Dumez  <christophe.dumez@intel.com>

        Add support for MessagePortArray type to JSC
        https://bugs.webkit.org/show_bug.cgi?id=84093

        Reviewed by Adam Barth.

        Add support for MessagePortArray type to JSC code generator similarly
        to what was done for the V8 generator in r114319.

        Update bindings test results to reflect to change to the bindings
        generator.

        * CMakeLists.txt: Add new DeliveredIntent files to CMake.
        * bindings/js/JSDOMBinding.h:
        (WebCore):
        (WebCore::jsArray): Tweak jsArray() so that it accepts MessagePortArray as argument.
        * bindings/scripts/CodeGeneratorJS.pm:
        (JSValueToNative):
        (NativeToJSValue):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::jsTestObjPrototypeFunctionSerializedValue):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::JSTestSerializedScriptValueInterfaceConstructor::constructJSTestSerializedScriptValueInterface):
        (WebCore::jsTestSerializedScriptValueInterfacePorts):
        (WebCore::setJSTestSerializedScriptValueInterfaceValue):
        (WebCore::setJSTestSerializedScriptValueInterfaceCachedValue):
        (WebCore::jsTestSerializedScriptValueInterfacePrototypeFunctionAcceptTransferList):
        (WebCore::jsTestSerializedScriptValueInterfacePrototypeFunctionMultiTransferList):

2012-05-21  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: [Styles] Cannot tab from selector of inherited rule, which in turn has leading inherited properties
        https://bugs.webkit.org/show_bug.cgi?id=87014

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertiesSection.prototype._moveEditorFromSelector):

2012-05-21  Greg Billock  <gbillock@google.com>

        Add suggestions field to web intents API.
        https://bugs.webkit.org/show_bug.cgi?id=86791

        Reviewed by Adam Barth.

        The |suggestions| field is used by the client to avoid an empty
        web intents selection window (picker). The UA can add the given
        suggestions to the picker if it would otherwise be empty. See
        http://dvcs.w3.org/hg/web-intents/raw-file/tip/spec/Overview.html#intent-parameters-dictionary

        * Modules/intents/DeliveredIntent.cpp:
        (WebCore::DeliveredIntent::DeliveredIntent):
        * Modules/intents/Intent.cpp:
        (WebCore::Intent::create):
        (WebCore::Intent::Intent):
        * Modules/intents/Intent.h:
        (WebCore::Intent::suggestions):
        (Intent):

2012-05-21  Stephen Chenney  <schenney@chromium.org>

        SVGAnimatedPropertyTearOff does not clear a self pointer on deletion
        https://bugs.webkit.org/show_bug.cgi?id=86119

        Reviewed by Nikolas Zimmermann.

        SVGAnimatedPropertyTearOff contains two SVGPropertyTearOff objects
        that have a pointer back to the SVGAnimatedPropertyTearOff. JS may
        also have a reference to these SVGPropertyTearOff objects. When the
        SVGAnimatedPropertyTearOff is deleted, the SVGPropertyTearOff objects
        may live on, but the pointer back to the deleted animated property
        tear off is left invalid. This patch clears the pointers on destruction
        of the SVGAnimatedPropertyTearOff.

        Test: svg/custom/bug86119.html

        * svg/properties/SVGAnimatedPropertyTearOff.h:
        (WebCore::SVGAnimatedPropertyTearOff::~SVGAnimatedPropertyTearOff):
        (SVGAnimatedPropertyTearOff):

2012-05-21  Stephen Chenney  <schenney@chromium.org>

        [Chromium] REGRESSION: Assertion failure on svg/custom/acid3-test-77.html
        https://bugs.webkit.org/show_bug.cgi?id=86715

        Reviewed by Nikolas Zimmermann.

        Calls to clear the text positioning elements in RenderSVGText must be
        protected with a FontCachePurgeProtector so that fonts are not removed
        before the SVG metrics are rebuilt. The protection must cover both the
        cache clearing and the reconstruction calls.

        Patch fixes existing tests.

        * rendering/svg/RenderSVGText.cpp:
        (WebCore::RenderSVGText::subtreeChildWasAdded):
        (WebCore::RenderSVGText::subtreeChildWasRemoved):
        (WebCore::RenderSVGText::subtreeTextDidChange):
        (WebCore::RenderSVGText::removeChild):

2012-05-21  Stephen Chenney  <schenney@chromium.org>

        SVGTextRunRenderingContext can return null font, calling code asserts not null
        https://bugs.webkit.org/show_bug.cgi?id=86738

        Reviewed by Nikolas Zimmermann.

        SVGTextRunRenderingContext::glyphDataForCharacter was returning a glyph with
        null font data for numerous code paths. It seems that it was doing so
        whenever it detected null fontData, rather than try to continue.
        Calling code would then immediately assert on this null fontData.

        This patch refactors SVGTextRunRenderingContext::glyphDataForCharacter
        so that it never returns null font data, adding an assertion to that
        effect. In particular, when the font data is null the code will reach
        the fallback glyph calculations.

        Refactoring covered by existing tests. A previously crashing test, svg/custom/acid3-test-77.html, no longer crashes.

        * rendering/svg/SVGTextRunRenderingContext.cpp:
        (WebCore::SVGTextRunRenderingContext::glyphDataForCharacter):

2012-05-21  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: switch buildDominatedNodes function to front-end calculated _dominatorsTree
        https://bugs.webkit.org/show_bug.cgi?id=87022

        The new version is using _dominatorsTree array that was build at front-end.

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype._buildDominatedNodes):

2012-05-21  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: change WebCore/English.lproj/locallizedStrings encoding from UTF-16 to UTF-8.
        https://bugs.webkit.org/show_bug.cgi?id=86822

        Reviewed by Yury Semikhatsky.

        * English.lproj/localizedStrings.js:

2012-05-21  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Move working copy support to UISourceCode and use it for both styles and scripts.
        https://bugs.webkit.org/show_bug.cgi?id=87021

        Reviewed by Pavel Feldman.

        UISourceCode now listens for RevisionAdded event.
        Virtual methods workingCopyChanged and workingCopyCommitted added to UISourceCode and implemented in descendants.
        DebuggerResourceBinding does not call contentChanged on UISourceCode explicitly anymore.

        * inspector/front-end/DebuggerResourceBinding.js:
        (WebInspector.DebuggerResourceBinding.setScriptSource.didEditScriptSource):
        (WebInspector.DebuggerResourceBinding.setScriptSource):
        * inspector/front-end/JavaScriptSource.js:
        (WebInspector.JavaScriptSource.prototype.workingCopyCommitted):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        * inspector/front-end/ScriptSnippetModel.js:
        (WebInspector.SnippetJavaScriptSource.prototype.workingCopyCommitted):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSource.prototype.workingCopyCommitted):
        (WebInspector.StyleSource.prototype.workingCopyChanged):
        (WebInspector.StyleSourceFrame):
        (WebInspector.StyleSourceFrame.prototype.commitEditing):
        (WebInspector.StyleSourceFrame.prototype.afterTextChanged):
        (WebInspector.StyleSourceFrame.prototype._didEditContent):
        (WebInspector.StyleSourceFrame.prototype._onContentChanged):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode):
        (WebInspector.UISourceCode.prototype._revisionAdded):
        (WebInspector.UISourceCode.prototype.contentChanged):
        (WebInspector.UISourceCode.prototype.workingCopy):
        (WebInspector.UISourceCode.prototype.setWorkingCopy):
        (WebInspector.UISourceCode.prototype.workingCopyChanged):
        (WebInspector.UISourceCode.prototype.commitWorkingCopy):
        (WebInspector.UISourceCode.prototype.workingCopyCommitted):

2012-05-21  Andrey Kosyakov  <caseq@chromium.org>

        Web Inspector: [refactoring] promote fill/border colors used by timeline's frame overview to TimelineCategory
        https://bugs.webkit.org/show_bug.cgi?id=87016

        Reviewed by Pavel Feldman.

        - drop unused 'color' field from TimelineCategory;
        - add borderColor and fillColorStop[0-1] to TimelineCategory;
        - fix style in a handful of places.

        Note we store textual values for color stops, not premade gradients so we can build gradients with different
        orientations rather than transforming a gradient.

        * inspector/front-end/TimelineOverviewPane.js:
        (WebInspector.HeapGraph):
        (WebInspector.HeapGraph.prototype.get element):
        (WebInspector.HeapGraph.prototype.get visible):
        (WebInspector.HeapGraph.prototype.show):
        (WebInspector.HeapGraph.prototype.hide):
        (WebInspector.HeapGraph.prototype._clear):
        (WebInspector.TimelineCategoryStrips):
        (WebInspector.TimelineVerticalOverview):
        (WebInspector.TimelineVerticalOverview.prototype._renderBar):
        * inspector/front-end/TimelinePresentationModel.js:
        (WebInspector.TimelinePresentationModel.categories):
        (WebInspector.TimelinePresentationModel.recordStyle):
        (WebInspector.TimelineCategory):

2012-05-21  'Pavel Feldman'  <pfeldman@chromium.org>

        Web Inspector: declare setFormatted on UISourceCode (otherwise fails for styles).

        Not reviewed: front-end fix as a follow up to r117751.

        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype.consoleMessagesCleared):
        (WebInspector.UISourceCode.prototype.setFormatted):

2012-05-21  Yury Semikhatsky  <yurys@chromium.org>

        Unreviewed. Fix Closure compiler error after r117753.

        * inspector/front-end/HeapSnapshotGridNodes.js:
        (WebInspector.HeapSnapshotConstructorNode.prototype.revealNodeBySnapshotObjectId.didGetNodePosition):

2012-05-21  Caio Marcelo de Oliveira Filho  <caio.oliveira@openbossa.org>

        Move setEditingBehavior() from layoutTestController to window.internals
        https://bugs.webkit.org/show_bug.cgi?id=42689

        Reviewed by Hajime Morita and Kenneth Rohde Christiansen.

        Add setEditingBehavior() to window.internals.settings. No new tests, but this
        change will allow more tests to run in WebKitTestRunner.

        * testing/InternalSettings.cpp:
        (WebCore::InternalSettings::InternalSettings):
        (WebCore::InternalSettings::restoreTo):
        (WebCore::InternalSettings::setEditingBehavior):
        (WebCore):
        * testing/InternalSettings.h:
        (InternalSettings):
        * testing/InternalSettings.idl:

2012-05-21  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Temporary UISourceCode should be replaced each time another inline script is added in RawSourceCode with pending request.
        https://bugs.webkit.org/show_bug.cgi?id=87003

        Reviewed by Pavel Feldman.

        This is needed to correctly show document content when debugger stops on several breakpoints in different scripts during page load.

        * inspector/front-end/RawSourceCode.js:
        (WebInspector.RawSourceCode.prototype.addScript):
        (WebInspector.RawSourceCode.prototype._finishedLoading):

2012-05-20  Kinuko Yasuda  <kinuko@chromium.org>

        Cleanup: Remove WebCore::revealFolderInOS() which is no longer used anywhere
        https://bugs.webkit.org/show_bug.cgi?id=86993

        Reviewed by Adam Barth.

        No new tests as this must be just removing dead code.

        * platform/FileSystem.h:
        * platform/chromium/FileSystemChromium.cpp:
        * platform/chromium/PlatformSupport.h:
        (PlatformSupport):

2012-05-21  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: Annotate CSSStyleModel.js for the closure compiler
        https://bugs.webkit.org/show_bug.cgi?id=86858

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/CSSStyleModel.js:
        (WebInspector.CSSStyleDeclaration.parseComputedStylePayload):
        (WebInspector.CSSStyleDeclaration.prototype.newBlankProperty):
        (WebInspector.CSSStyleDeclaration.prototype.insertPropertyAt):
        (WebInspector.CSSProperty.parsePayload):
        (WebInspector.CSSProperty.prototype.setText):
        (WebInspector.CSSProperty.prototype.setDisabled):
        (WebInspector.CSSStyleSheet.prototype.setText):
        (WebInspector.CSSStyleModelResourceBinding.prototype._innerSetContent.callbackWrapper):
        (WebInspector.CSSStyleModelResourceBinding.prototype._innerSetContent):
        (WebInspector.CSSStyleModelResourceBinding.prototype._loadStyleSheetHeaders):

2012-05-21  Rakesh KN  <rakesh.kn@motorola.com>

        [Forms] Refactor HTMLFormCollection
        https://bugs.webkit.org/show_bug.cgi?id=86602

        Reviewed by Kent Tamura.

        Modify HTMLFormCollection to be independent of HTMLFormElement which is needed
        for implementing HTMLFieldSetElement's element attribute.

        Covered by existing tests.

        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::HTMLFormCollection):
        Modified to take more generic HTMLElement* instead of HTMLFormElement* so that
        HTMLFormCollection for HTMLFieldSetElement can also be created.
        (WebCore::HTMLFormCollection::create): Ditto.
        (WebCore::HTMLFormCollection::formControlElements):
        Helper function for getting the array of FormAssociatedElements for this form.
        (WebCore::HTMLFormCollection::formImageElements):
        Helper function for getting the array of image elements for this form.
        (WebCore::HTMLFormCollection::numberOfFormControlElements):
        Helper function for getting the number of elements in this form.
        (WebCore::HTMLFormCollection::calcLength):
        Modified to use new helper functions defined for getting the FormAssociatedElements
        and image elements array instead of static_cast to HTMLFormElement.
        (WebCore::HTMLFormCollection::item): Ditto.
        (WebCore::HTMLFormCollection::getNamedFormItem): Ditto.
        (WebCore::HTMLFormCollection::updateNameCache): Ditto.
        * html/HTMLFormCollection.h:
        (WebCore):
        (HTMLFormCollection):
        * html/HTMLFormElement.h:
        (WebCore::HTMLFormElement::imageElements):
        New accessor for image elements array of form element.
        Also HTMLFormCollection is not needed to be friend of HTMLFormElement as collection
        does not access the form element memebers directly now.

2012-05-21  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: expand only neighbors of the highlighted node when revealing it in heap snapshot
        https://bugs.webkit.org/show_bug.cgi?id=86998

        Reviewed by Pavel Feldman.

        Only nearest nodes are expanded when a node is revealed in heap snapshot
        summary view.

        * inspector/front-end/HeapSnapshotDataGrids.js:
        (WebInspector.HeapSnapshotSortableDataGrid.prototype.highlightNode):
        (WebInspector.HeapSnapshotViewportDataGrid.prototype.highlightNode):
        (WebInspector.HeapSnapshotViewportDataGrid.prototype._isScrolledIntoView):
        * inspector/front-end/HeapSnapshotGridNodes.js:
        (WebInspector.HeapSnapshotConstructorNode.prototype.revealNodeBySnapshotObjectId):
        (WebInspector.HeapSnapshotConstructorNode.prototype.revealNodeBySnapshotObjectId.didGetNodePosition):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfilesPanel.prototype.showProfile):

2012-05-21  Mikhail Pozdnyakov  <mikhail.pozdnyakov@intel.com>

        [EFL] PlatformKeyboardEventEfl is missing ESC key handling.
        https://bugs.webkit.org/show_bug.cgi?id=86837

        Reviewed by Kenneth Rohde Christiansen.

        Added ESC key handling.

        * platform/efl/EflKeyboardUtilities.cpp:
        (WebCore::createKeyMap):
        (WebCore::singleCharacterString):

2012-05-21  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: move sources panel out of experimental.
        https://bugs.webkit.org/show_bug.cgi?id=86997

        Reviewed by Yury Semikhatsky.

        This change moves sources panel out of experimental, removes revision support from the resources panel.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype._onContentChanged):
        (WebInspector.JavaScriptSourceFrame.prototype._continueToLine):
        * inspector/front-end/ResourceView.js:
        * inspector/front-end/ResourcesPanel.js:
        (WebInspector.ResourcesPanel.prototype._showResourceView):
        (WebInspector.FrameTreeElement.prototype.appendResource):
        (WebInspector.FrameResourceTreeElement):
        (WebInspector.FrameResourceTreeElement.prototype.sourceView):
        * inspector/front-end/ScriptsNavigator.js:
        (WebInspector.ScriptsNavigator):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.get toolbarItemLabel):
        (WebInspector.ScriptsPanel.prototype.appendApplicableItems):
        * inspector/front-end/Settings.js:
        (WebInspector.ExperimentsSettings):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame.prototype._setTextViewerDecorations):
        * inspector/front-end/textViewer.css:
        * inspector/front-end/utilities.js:

2012-05-21  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: implement revision history view.
        https://bugs.webkit.org/show_bug.cgi?id=86966

        Reviewed by Yury Semikhatsky.

        Added revision view into the drawer. It now lists all the revisions
        along with the inline diffs. Once source panel is enabled by default,
        this view will completely substitute the one in the resources panel.
        See the screenshot attached. View is updated when revisions are added
        and when editor view is switched.

        * English.lproj/localizedStrings.js:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * inspector/compile-front-end.py:
        * inspector/front-end/AdvancedSearchController.js:
        (WebInspector.FileBasedSearchResultsPane.prototype._appendSearchMatches):
        * inspector/front-end/ContextMenu.js:
        (WebInspector.ContextMenu.prototype._itemSelected):
        (WebInspector.ContextMenu.prototype.appendApplicableItems):
        (WebInspector.ContextMenu.Provider.prototype.appendApplicableItems):
        (WebInspector.ContextMenu.registerProvider):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.populateTextAreaContextMenu):
        * inspector/front-end/Resource.js:
        (WebInspector.ResourceRevision.prototype.revertToThis):
        * inspector/front-end/RevisionHistoryView.js: Added.
        (WebInspector.RevisionHistoryView):
        (WebInspector.RevisionHistoryView.showHistory):
        (WebInspector.RevisionHistoryView.uiSourceCodeSelected):
        (WebInspector.RevisionHistoryView.prototype._revisionAdded):
        (WebInspector.RevisionHistoryView.prototype._onclose):
        (WebInspector.RevisionHistoryTreeElement.else.revert):
        (WebInspector.RevisionHistoryTreeElement):
        (WebInspector.RevisionHistoryTreeElement.prototype.onexpand.step1):
        (WebInspector.RevisionHistoryTreeElement.prototype.onexpand.step2):
        (WebInspector.RevisionHistoryTreeElement.prototype.onexpand):
        (WebInspector.RevisionHistoryTreeElement.prototype._createLine):
        (WebInspector.RevisionHistoryTreeElement.prototype._diff.popsym):
        (WebInspector.RevisionHistoryTreeElement.prototype._diff):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._editorSelected):
        (WebInspector.ScriptsPanel.prototype.registerUISourceCodeProvider):
        (WebInspector.ScriptsPanel.prototype._showLocalHistory):
        (WebInspector.ScriptsPanel.prototype.appendApplicableItems):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSourceFrame.prototype._contentChanged):
        (WebInspector.StyleSourceFrame.prototype.populateTextAreaContextMenu):
        * inspector/front-end/WebKit.qrc:
        * inspector/front-end/inspector.css:
        (#search-results-pane-file-based .search-result):
        (#search-results-pane-file-based .search-result:hover):
        (#search-results-pane-file-based .search-match:hover):
        (#search-results-pane-file-based .search-match .search-match-content):
        * inspector/front-end/inspector.html:
        * inspector/front-end/scriptsPanel.css:
        (.outline-disclosure.revision-history-drawer):
        (.outline-disclosure.revision-history-drawer ol):
        (.outline-disclosure.revision-history-drawer > ol):
        (.outline-disclosure.revision-history-drawer li):
        (.outline-disclosure.revision-history-drawer li.parent):
        (.revision-history-link):
        (.outline-disclosure.revision-history-drawer .revision-history-line):
        (.revision-history-drawer .webkit-line-number):
        (.revision-history-line-added):
        (.revision-history-line-removed):
        * inspector/front-end/textViewer.css:
        (.webkit-added-line.webkit-line-number):
        (.webkit-removed-line.webkit-line-number):
        (.webkit-changed-line.webkit-line-number):

2012-05-18  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: upstream build dominators tree procedure from v8.
        https://bugs.webkit.org/show_bug.cgi?id=86640

        The idea is to reduce transfer size and move all the post-processing steps to the front-end.
        The JS implementation is ~1.5 times slower.

        Reviewed by Yury Semikhatsky.

        Covered by existing tests and performance tests.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype._init):
        (WebInspector.HeapSnapshot.prototype._buildAggregates):
        (WebInspector.HeapSnapshot.prototype._buildPostOrderIndex):
        (WebInspector.HeapSnapshot.prototype._buildDominatorTree):
        (WebInspector.HeapSnapshot.prototype._markPageOwnedNodes):
        (WebInspector.HeapSnapshot.prototype._markQueriableHeapObjects):
        (WebInspector.HeapSnapshot.prototype._calculateFlags):

2012-05-21  Mike Lawther  <mikelawther@chromium.org>

        Crash in -webkit-calc
        https://bugs.webkit.org/show_bug.cgi?id=86954

        Reviewed by Abhishek Arya.

        Ensure that both ends of a blend are checked for being Calculated. The current
        check did not cover the case where the 'from' end was Calculated and nonzero,
        and the 'to' end was zero and not Calculated. 

        Blending doesn't work with calculated expressions and is being tracked in
        bug http://webkit.org/b/86160

        Tests: css3/calc/transition-crash3.html
               css3/calc/transition-crash4.html

        * platform/Length.h:
        (WebCore::Length::blend):

2012-05-21  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: make search results view more dense
        https://bugs.webkit.org/show_bug.cgi?id=86937

        Reviewed by Yury Semikhatsky.

        - moved search field to the 'drawer status bar'
        - search view is now shown on scripts panel only
        - switching from the scripts panel closes the search view
        - beautified the looks (see the screenshot)

        * English.lproj/localizedStrings.js:
        * inspector/front-end/AdvancedSearchController.js:
        (WebInspector.AdvancedSearchController.prototype.handleShortcut):
        (WebInspector.AdvancedSearchController.prototype.show):
        (WebInspector.AdvancedSearchController.prototype.close):
        (WebInspector.SearchView):
        (WebInspector.FileBasedSearchResultsPane):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.willHide):
        * inspector/front-end/externs.js:
        (WebInspector.showViewInDrawer):
        (WebInspector.closeViewInDrawer):
        * inspector/front-end/inspector.css:
        (.search-drawer-header input[type="search"].search-config-search):
        (.search-drawer-header label.search-config-label):
        (.search-drawer-header input[type="checkbox"].search-config-checkbox):
        (body:not(.platform-mac) .search-drawer-header input[type="checkbox"].search-config-checkbox):
        (body.platform-mac .search-drawer-header input[type="checkbox"].search-config-checkbox):
        (.drawer-header):
        (.drawer-header-close-button):
        (.drawer-header-close-button:hover):
        (.drawer-header-close-button:active):
        (.search-view .search-results):
        (#search-results-pane-file-based li):
        (#search-results-pane-file-based ol):
        (#search-results-pane-file-based ol.children):
        (#search-results-pane-file-based ol.children.expanded):
        (#search-results-pane-file-based li.parent::before):
        (#search-results-pane-file-based li.parent.expanded::before):
        (#search-results-pane-file-based .search-result):
        (#search-results-pane-file-based .show-more-matches):
        * inspector/front-end/inspector.js:
        (WebInspector.showViewInDrawer.closeButtonPressed):
        (WebInspector.showViewInDrawer):
        (WebInspector.closeViewInDrawer):
        (WebInspector.postDocumentKeyDown):

2012-05-18  Andreas Kling  <kling@webkit.org>

        REGRESSION(r117501): IconDatabase asserts on startup in synchronousIconForPageURL().
        <http://webkit.org/b/86935>
        <rdar://problem/11480012>

        Reviewed by Anders Carlsson.

        - Correctly set m_retainOrReleaseIconRequested to true in retainIconForPageURL().
          This was causing the assertions, as we would end up doing nothing until the first
          icon release request came in.

        - Require that m_urlsToRetainOrReleaseLock be held when accessing m_retainOrReleaseIconRequested.
          This removes a possible race condition in double checked locking.

        - Swap over the retain/release work queues while holding m_urlsToRetainOrReleaseLock
          and release it right away to avoid sitting on the lock while updating the database.

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::synchronousIconForPageURL):
        (WebCore::IconDatabase::retainIconForPageURL):
        (WebCore::IconDatabase::releaseIconForPageURL):
        (WebCore::IconDatabase::retainedPageURLCount):
        (WebCore::IconDatabase::performURLImport):
        (WebCore::IconDatabase::syncThreadMainLoop):
        (WebCore::IconDatabase::performPendingRetainAndReleaseOperations):
        * loader/icon/IconDatabase.h:
        (IconDatabase):

2012-05-21  Kent Tamura  <tkent@chromium.org>

        Unreviewed, build fix.

        * html/StepRange.cpp:
        (WebCore::StepRange::parseStep): Remove bogus asssetions.

2012-05-21  Kent Tamura  <tkent@chromium.org>

        Unreviewed, build fix.

        * html/StepRange.cpp:
        (WebCore::StepRange::StepRange): Remove another ASSERT_NOT_REACHED.

2012-05-21  Kent Tamura  <tkent@chromium.org>

        Unreviewed, build fix.

        * html/StepRange.h:
        (WebCore::StepRange::StepDescription::StepDescription):
        Remove ASSERT_NOT_REACHED.

2012-05-21  Yoshifumi Inoue  <yosin@chromium.org>

        [Forms] Move numeric related methods in HTMLInputElement class to another place
        https://bugs.webkit.org/show_bug.cgi?id=82034

        Reviewed by Kent Tamura.

        This patch moves step and range related methods into StepRange class
        for ease of using step calculation other than double floating point
        number arithmetic, e.g. decimal, long double, and so on.

        New class StepRange::StepDescription holds values for calculating
        stepped value, defaultStep, defaultStepBase, integer rounding flags,
        step scale factor instead of virtual methods in InputType class.

        No new tests because of this patch doesn't change behavior.

        * WebCore.xcodeproj/project.pbxproj: Set attribute of StepRange.h to "Private" for including it in HTMLInputElement.cpp.
        * html/BaseDateAndTimeInputType.cpp:
        (WebCore::InputType::rangeOverflow): Moved to use InputType class.
        (WebCore::InputType::rangeUnderflow): Moved to use InputType class.
        (WebCore::BaseDateAndTimeInputType::stepMismatch): Moved to use stepRange.
        * html/BaseDateAndTimeInputType.h:
        (BaseDateAndTimeInputType): Removed method declaration for stepBase.
        * html/DateInputType.cpp:
        (WebCore::DateInputType::setupStepRange): Added.
        * html/DateInputType.h:
        (DateInputType): Removed method declarations.
        * html/DateTimeInputType.cpp:
        (WebCore::DateTimeInputType::defaultStep): Removed.
        (WebCore::DateTimeInputType::maximum): Removed.
        (WebCore::DateTimeInputType::minimum): Removed.
        (WebCore::DateTimeInputType::setupStepRange): Added
        (WebCore::DateTimeInputType::stepScaleFactor): Removed.
        * html/DateTimeInputType.h:
        (DateTimeInputType): Removed deprecated method declarations.
        * html/DateTimeLocalInputType.cpp:
        (WebCore::DateTimeLocalInputType::defaultStep): Removed.
        (WebCore::DateTimeLocalInputType::maximum): Removed.
        (WebCore::DateTimeLocalInputType::minimum): Removed.
        (WebCore::DateTimeLocalInputType::setupStepRange): Added.
        (WebCore::DateTimeLocalInputType::stepScaleFactor): Removed.
        * html/DateTimeLocalInputType.h:
        (DateTimeLocalInputType):
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::isInRange): Changed to call InputType::isInRange.
        (WebCore::HTMLInputElement::isOutOfRange): Changed to call InputType::isOutOfRange.
        (WebCore::HTMLInputElement::setupStepRange): Added.
        * html/HTMLInputElement.h:
        (HTMLInputElement):
        * html/InputType.cpp:
        (WebCore::InputType::acceptableError): Moved to StepRange class.
        (WebCore::InputType::alignValueForStep): Moved to StepRange class.
        (WebCore::InputType::minimum): Changed to use StepRange class.
        (WebCore::InputType::maximum): Changed to use StepRange class.
        (WebCore::InputType::parseToDouble): Changed to have ASSERT_NOT_REACHED.
        (WebCore::InputType::stepBaseWithDecimalPlaces): Changed to use StepRange class.
        (WebCore::InputType::validationMessage):  Changed to use StepRange class.
        (WebCore::InputType::applyStep):  Changed to use StepRange class.
        (WebCore::InputType::getAllowedValueStep):  Changed to use StepRange class.
        (WebCore::InputType::isInRange): Added.
        (WebCore::InputType::isOutOfRange): Added.
        (WebCore::InputType::rangeOverflow): Changed to use StepRange class.
        (WebCore::InputType::rangeUnderflow): Changed to use StepRange class.
        (WebCore::InputType::setupStepRange): Added.
        (WebCore::InputType::stepUpFromRenderer):  Changed to use StepRange class.
        (WebCore::InputType::stepMismatch): Changed to use StepRange class.
        * html/InputType.h:
        (InputType):
        * html/MonthInputType.cpp:
        (WebCore::MonthInputType::defaultStep): Removed.
        (WebCore::MonthInputType::maximum): Removed.
        (WebCore::MonthInputType::minimum): Removed.
        (WebCore::MonthInputType::setupStepRange): Added.
        (WebCore::MonthInputType::stepScaleFactor): Removed.
        * html/MonthInputType.h:
        (MonthInputType):
        * html/NumberInputType.cpp:
        (WebCore):
        (WebCore::NumberInputType::defaultStep): Removed.
        (WebCore::NumberInputType::maximum): Removed.
        (WebCore::NumberInputType::minimum): Removed.
        (WebCore::NumberInputType::rangeOverflow): Moved to InputType class.
        (WebCore::NumberInputType::rangeUnderflow): Moved to InputType class.
        (WebCore::NumberInputType::setupStepRange): Added.
        (WebCore::NumberInputType::stepMismatch): Moved to InputType class.
        (WebCore::NumberInputType::stepBaseWithDecimalPlaces): Changed to use StepRange class.
        (WebCore::NumberInputType::stepScaleFactor): Removed.
        * html/NumberInputType.h:
        (NumberInputType):
        * html/RangeInputType.cpp:
        (WebCore::RangeInputType::defaultStep): Removed.
        (WebCore::RangeInputType::maximum): Removed.
        (WebCore::RangeInputType::minimum): Removed.
        (WebCore::RangeInputType::setupStepRange): Added.
        (WebCore::RangeInputType::stepScaleFactor): Removed.
        (WebCore::RangeInputType::handleKeydownEvent): Changed to use StepRange class.
        (WebCore::RangeInputType::fallbackValue): Changed to use StepRange class.
        (WebCore::RangeInputType::sanitizeValue): Changed to use StepRange class.
        * html/RangeInputType.h:
        (RangeInputType):
        * html/StepRange.cpp:
        (WebCore::StepRange::StepRange): Added.
        (WebCore::StepRange::clampValue): Changed for member variable name changes.
        (WebCore::StepRange::hasStep): Added.
        (WebCore::StepRange::maximum): Added.
        (WebCore::StepRange::minimum): Added.
        (WebCore::StepRange::step): Added.
        (WebCore::StepRange::stepBase): Added.
        (WebCore::StepRange::stepDecimalPlaces): Added.
        (WebCore::StepRange::stepScaleFactor): Added.
        (WebCore::StepRange::setHasStep): Added.
        (WebCore::StepRange::setup): Added.
        (WebCore::StepRange::parse): Added.
        * html/StepRange.h:
        (StepDescription): Added
        (WebCore::StepRange::StepDescription::StepDescription):
        (WebCore::StepRange::acceptableError): Moved from InputType class.
        (WebCore::StepRange::alignValueForStep): Moved from InputType class.
        (WebCore::StepRange::defaultValue): Changed for member variable name changes.
        (WebCore::StepRange::proportionFromValue): Changed for member variable name changes.
        (WebCore::StepRange::valueFromProportion): Changed for member variable name changes.
        * html/TimeInputType.cpp:
        (WebCore::TimeInputType::defaultStep): Removed.
        (WebCore::TimeInputType::maximum): Removed.
        (WebCore::TimeInputType::minimum): Removed.
        (WebCore::TimeInputType::setupStepRange): Added.
        (WebCore::TimeInputType::stepScaleFactor): Removed.
        * html/TimeInputType.h:
        (TimeInputType):
        * html/WeekInputType.cpp:
        (WebCore):
        (WebCore::WeekInputType::defaultStep): Removed.
        (WebCore::WeekInputType::maximum): Removed.
        (WebCore::WeekInputType::minimum): Removed.
        (WebCore::WeekInputType::setupStepRange): Added.
        (WebCore::WeekInputType::stepScaleFactor): Removed.
        * html/WeekInputType.h:
        (WeekInputType):
        * html/shadow/SliderThumbElement.cpp:
        (WebCore::sliderPosition): Changed to use StepRange class.
        (WebCore::SliderThumbElement::setPositionFromPoint): Changed to use StepRange class.

2012-05-21  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to throwNotEnoughArgumentsError()
        https://bugs.webkit.org/show_bug.cgi?id=86983

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to throwNotEnoughArgumentsError().

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateArgumentsCountCheck):
        (GenerateEventConstructorCallback):
        * bindings/scripts/test/V8/V8Float64Array.cpp:
        (WebCore::Float64ArrayV8Internal::fooCallback):
        * bindings/scripts/test/V8/V8TestActiveDOMObject.cpp:
        (WebCore::TestActiveDOMObjectV8Internal::excitingFunctionCallback):
        (WebCore::TestActiveDOMObjectV8Internal::postMessageCallback):
        * bindings/scripts/test/V8/V8TestCustomNamedGetter.cpp:
        (WebCore::TestCustomNamedGetterV8Internal::anotherFunctionCallback):
        * bindings/scripts/test/V8/V8TestEventConstructor.cpp:
        (WebCore::V8TestEventConstructor::constructorCallback):
        * bindings/scripts/test/V8/V8TestEventTarget.cpp:
        (WebCore::TestEventTargetV8Internal::itemCallback):
        (WebCore::TestEventTargetV8Internal::dispatchEventCallback):
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        (WebCore::TestInterfaceV8Internal::supplementalMethod2Callback):
        (WebCore::V8TestInterface::constructorCallback):
        * bindings/scripts/test/V8/V8TestMediaQueryListListener.cpp:
        (WebCore::TestMediaQueryListListenerV8Internal::methodCallback):
        * bindings/scripts/test/V8/V8TestNamedConstructor.cpp:
        (WebCore::V8TestNamedConstructorConstructorCallback):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::voidMethodWithArgsCallback):
        (WebCore::TestObjV8Internal::intMethodWithArgsCallback):
        (WebCore::TestObjV8Internal::objMethodWithArgsCallback):
        (WebCore::TestObjV8Internal::methodWithSequenceArgCallback):
        (WebCore::TestObjV8Internal::methodReturningSequenceCallback):
        (WebCore::TestObjV8Internal::methodThatRequiresAllArgsAndThrowsCallback):
        (WebCore::TestObjV8Internal::serializedValueCallback):
        (WebCore::TestObjV8Internal::idbKeyCallback):
        (WebCore::TestObjV8Internal::optionsObjectCallback):
        (WebCore::TestObjV8Internal::methodWithNonOptionalArgAndOptionalArgCallback):
        (WebCore::TestObjV8Internal::methodWithNonOptionalArgAndTwoOptionalArgsCallback):
        (WebCore::TestObjV8Internal::methodWithCallbackArgCallback):
        (WebCore::TestObjV8Internal::methodWithNonCallbackArgAndCallbackArgCallback):
        (WebCore::TestObjV8Internal::overloadedMethod1Callback):
        (WebCore::TestObjV8Internal::overloadedMethod2Callback):
        (WebCore::TestObjV8Internal::overloadedMethod3Callback):
        (WebCore::TestObjV8Internal::overloadedMethod4Callback):
        (WebCore::TestObjV8Internal::overloadedMethod5Callback):
        (WebCore::TestObjV8Internal::overloadedMethod6Callback):
        (WebCore::TestObjV8Internal::overloadedMethod7Callback):
        (WebCore::TestObjV8Internal::overloadedMethod11Callback):
        (WebCore::TestObjV8Internal::overloadedMethod12Callback):
        (WebCore::TestObjV8Internal::enabledAtRuntimeMethod1Callback):
        (WebCore::TestObjV8Internal::enabledAtRuntimeMethod2Callback):
        (WebCore::TestObjV8Internal::convert1Callback):
        (WebCore::TestObjV8Internal::convert2Callback):
        (WebCore::TestObjV8Internal::convert3Callback):
        (WebCore::TestObjV8Internal::convert4Callback):
        (WebCore::TestObjV8Internal::convert5Callback):
        (WebCore::TestObjV8Internal::strictFunctionCallback):
        (WebCore::V8TestObj::constructorCallback):
        * bindings/scripts/test/V8/V8TestSerializedScriptValueInterface.cpp:
        (WebCore::TestSerializedScriptValueInterfaceV8Internal::acceptTransferListCallback):
        (WebCore::V8TestSerializedScriptValueInterface::constructorCallback):
        * bindings/v8/ScriptController.cpp:
        (WebCore::setValueAndClosePopupCallback):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::throwNotEnoughArgumentsError):
        * bindings/v8/V8Proxy.h:
        (V8Proxy):
        * bindings/v8/custom/V8AudioContextCustom.cpp:
        (WebCore::V8AudioContext::constructorCallback):
        * bindings/v8/custom/V8DataViewCustom.cpp:
        (WebCore::V8DataView::getInt8Callback):
        (WebCore::V8DataView::getUint8Callback):
        (WebCore::V8DataView::setInt8Callback):
        (WebCore::V8DataView::setUint8Callback):
        * bindings/v8/custom/V8DirectoryEntryCustom.cpp:
        (WebCore::V8DirectoryEntry::getDirectoryCallback):
        (WebCore::V8DirectoryEntry::getFileCallback):
        * bindings/v8/custom/V8IntentConstructor.cpp:
        (WebCore::V8Intent::constructorCallback):
        * bindings/v8/custom/V8SVGLengthCustom.cpp:
        (WebCore::V8SVGLength::convertToSpecifiedUnitsCallback):
        * bindings/v8/custom/V8WebGLRenderingContextCustom.cpp:
        (WebCore::getObjectParameter):
        (WebCore::V8WebGLRenderingContext::getAttachedShadersCallback):
        (WebCore::V8WebGLRenderingContext::getExtensionCallback):
        (WebCore::V8WebGLRenderingContext::getFramebufferAttachmentParameterCallback):
        (WebCore::V8WebGLRenderingContext::getParameterCallback):
        (WebCore::V8WebGLRenderingContext::getProgramParameterCallback):
        (WebCore::V8WebGLRenderingContext::getShaderParameterCallback):
        (WebCore::V8WebGLRenderingContext::getUniformCallback):
        (WebCore::vertexAttribAndUniformHelperf):
        (WebCore::uniformHelperi):
        (WebCore::uniformMatrixHelper):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp:
        (WebCore::V8WebKitMutationObserver::constructorCallback):
        (WebCore::V8WebKitMutationObserver::observeCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):
        (WebCore::V8WebSocket::sendCallback):
        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::V8XMLHttpRequest::openCallback):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to throwError()s in V8 custom bindings (Part 2)
        https://bugs.webkit.org/show_bug.cgi?id=86981

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to throwError()s in V8 custom bindings.

        No tests. No change in behavior.

        * bindings/v8/custom/V8HTMLImageElementConstructor.cpp:
        (WebCore::v8HTMLImageElementConstructorCallback):
        * bindings/v8/custom/V8HistoryCustom.cpp:
        (WebCore::V8History::pushStateCallback):
        (WebCore::V8History::replaceStateCallback):
        * bindings/v8/custom/V8IntentConstructor.cpp:
        (WebCore::V8Intent::constructorCallback):
        * bindings/v8/custom/V8MessagePortCustom.cpp:
        (WebCore::handlePostMessageCallback):
        * bindings/v8/custom/V8NotificationCenterCustom.cpp:
        (WebCore::V8NotificationCenter::createHTMLNotificationCallback):
        (WebCore::V8NotificationCenter::createNotificationCallback):
        (WebCore::V8NotificationCenter::requestPermissionCallback):
        * bindings/v8/custom/V8SQLResultSetRowListCustom.cpp:
        (WebCore::V8SQLResultSetRowList::itemCallback):
        * bindings/v8/custom/V8SQLTransactionCustom.cpp:
        (WebCore::V8SQLTransaction::executeSqlCallback):
        * bindings/v8/custom/V8SQLTransactionSyncCustom.cpp:
        (WebCore::V8SQLTransactionSync::executeSqlCallback):
        * bindings/v8/custom/V8StorageCustom.cpp:
        (WebCore::storageSetter):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp:
        (WebCore::V8WebKitMutationObserver::constructorCallback):
        (WebCore::V8WebKitMutationObserver::observeCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):
        (WebCore::V8WebSocket::sendCallback):
        (WebCore::V8WebSocket::closeCallback):
        * bindings/v8/custom/V8WorkerContextCustom.cpp:
        (WebCore::V8WorkerContext::importScriptsCallback):
        * bindings/v8/custom/V8WorkerCustom.cpp:
        (WebCore::handlePostMessageCallback):
        * bindings/v8/custom/V8XMLHttpRequestConstructor.cpp:
        (WebCore::V8XMLHttpRequest::constructorCallback):
        * bindings/v8/custom/V8XMLHttpRequestCustom.cpp:
        (WebCore::V8XMLHttpRequest::responseTextAccessorGetter):
        (WebCore::V8XMLHttpRequest::openCallback):
        (WebCore::V8XMLHttpRequest::sendCallback):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to throwError()s in V8 custom bindings (Part 1)
        https://bugs.webkit.org/show_bug.cgi?id=86980

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to throwError()s in V8 custom bindings.

        No tests. No change in behavior.

        * bindings/v8/custom/V8ArrayBufferCustom.cpp:
        (WebCore::V8ArrayBuffer::constructorCallback):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArrayWithArrayBufferArgument):
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8AudioContextCustom.cpp:
        (WebCore::V8AudioContext::constructorCallback):
        * bindings/v8/custom/V8BlobCustom.cpp:
        (WebCore::V8Blob::constructorCallback):
        * bindings/v8/custom/V8CSSStyleDeclarationCustom.cpp:
        (WebCore::V8CSSStyleDeclaration::namedPropertySetter):
        * bindings/v8/custom/V8ClipboardCustom.cpp:
        (WebCore::V8Clipboard::clearDataCallback):
        (WebCore::V8Clipboard::setDragImageCallback):
        * bindings/v8/custom/V8DOMFormDataCustom.cpp:
        (WebCore::V8DOMFormData::appendCallback):
        * bindings/v8/custom/V8DOMStringMapCustom.cpp:
        (WebCore::V8DOMStringMap::namedPropertySetter):
        * bindings/v8/custom/V8DOMWindowCustom.cpp:
        (WebCore::handlePostMessageCallback):
        * bindings/v8/custom/V8DedicatedWorkerContextCustom.cpp:
        (WebCore::handlePostMessageCallback):
        * bindings/v8/custom/V8DirectoryEntryCustom.cpp:
        (WebCore::V8DirectoryEntry::getDirectoryCallback):
        (WebCore::V8DirectoryEntry::getFileCallback):
        * bindings/v8/custom/V8DocumentCustom.cpp:
        (WebCore::V8Document::evaluateCallback):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to V8NPObject::npObjectGetProperty() and V8NPObject::npObjectSetProperty()
        https://bugs.webkit.org/show_bug.cgi?id=86979

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to V8NPObject::npObjectGetProperty()
        and V8NPObject::npObjectSetProperty().

        No tests. No change in behavior.

        * bindings/v8/V8NPObject.cpp:
        (WebCore::npObjectGetProperty):
        (WebCore::npObjectNamedPropertyGetter):
        (WebCore::npObjectIndexedPropertyGetter):
        (WebCore::npObjectGetNamedProperty):
        (WebCore::npObjectGetIndexedProperty):
        (WebCore::npObjectQueryProperty):
        (WebCore::npObjectSetProperty):
        (WebCore::npObjectNamedPropertySetter):
        (WebCore::npObjectIndexedPropertySetter):
        (WebCore::npObjectSetNamedProperty):
        (WebCore::npObjectSetIndexedProperty):
        * bindings/v8/V8NPObject.h:
        (WebCore):
        * bindings/v8/custom/V8HTMLPlugInElementCustom.cpp:
        (WebCore::npObjectNamedGetter):
        (WebCore::npObjectNamedSetter):
        (WebCore::npObjectIndexedGetter):
        (WebCore::npObjectIndexedSetter):

2012-05-20  Ryosuke Niwa  <rniwa@webkit.org>

        Using createContextualFragment to insert a <script> does not cause the script to execute
        https://bugs.webkit.org/show_bug.cgi?id=12234

        Reviewed by Adam Barth.

        Renamed FragmentScriptingAllowed and FragmentScriptingNotAllowed to DisallowScriptingContent
        and AllowScriptingContent as these two flags are used in code for non-fragment cases and they
        indicate whether attributes and elements that can invoke scripting should be removed or not.

        To fix the bug, added a new value AllowScriptingContentAndDoNotMarkAlreadyStarted unset
        already-started and parser-inserted flags [1] on script elements in addition to allowing
        scripting contents.

        While the HTML5 specification and the DOM Parsing and Serialization specification [2] state that
        we should set these flags in the parser and later unset them, doing so would require traversing
        the parsed fragment to find relevant script elements. We short circuit this logic by simply not
        setting parser-inserted and already-started flags in createContextualFragment.

        [1] http://www.whatwg.org/specs/web-apps/current-work/multipage/scripting-1.html#already-started
        [2] http://html5.org/specs/dom-parsing.html#dom-range-createcontextualfragment

        Tests: fast/dom/Range/create-contextual-fragment-script-not-ran.html
               fast/dom/Range/create-contextual-fragment-script-unmark-already-started.html

        * dom/DocumentFragment.h:
        (DocumentFragment):
        * dom/Element.cpp:
        (WebCore::Element::parserSetAttributes):
        (WebCore::Element::setAttributeNS):
        * dom/Element.h:
        (Element):
        * dom/FragmentScriptingPermission.h:
        * dom/Range.cpp:
        (WebCore::Range::createContextualFragment): Removed FragmentScriptingPermission from the argument
        list since no one uses it. Always use AllowScriptingContentAndDoNotMarkAlreadyStarted instead.
        * dom/Range.h:
        * editing/markup.h:
        * html/parser/HTMLConstructionSite.cpp:
        (WebCore::HTMLConstructionSite::HTMLConstructionSite):
        (WebCore::HTMLConstructionSite::insertScriptElement): Pass false to both parserInserted and
        alreadyStarted when the scripting permission is AllowScriptingContentAndDoNotMarkAlreadyStarted.
        Also call parserSetAttributes when the scripting permission is either AllowScriptingContent or
        AllowScriptingContentAndDoNotMarkAlreadyStarted.
        * html/parser/HTMLDocumentParser.h:
        (HTMLDocumentParser):
        * html/parser/HTMLTreeBuilder.cpp:
        (WebCore::HTMLTreeBuilder::FragmentParsingContext::FragmentParsingContext):
        (WebCore::HTMLTreeBuilder::processEndTag):
        * html/parser/HTMLTreeBuilder.h:
        (FragmentParsingContext):
        * platform/blackberry/PasteboardBlackBerry.cpp:
        (WebCore::Pasteboard::documentFragment):
        * platform/chromium/DragDataChromium.cpp:
        (WebCore::DragData::asFragment):
        * platform/chromium/PasteboardChromium.cpp:
        (WebCore::Pasteboard::documentFragment):
        * platform/gtk/PasteboardGtk.cpp:
        (WebCore::Pasteboard::documentFragment):
        * platform/mac/PasteboardMac.mm:
        (WebCore::Pasteboard::documentFragment):
        * platform/qt/DragDataQt.cpp:
        (WebCore::DragData::asFragment):
        * platform/qt/PasteboardQt.cpp:
        (WebCore::Pasteboard::documentFragment):
        * platform/win/ClipboardUtilitiesWin.cpp:
        (WebCore::fragmentFromCFHTML):
        (WebCore::fragmentFromHTML):
        * xml/XMLErrors.cpp:
        (WebCore::createXHTMLParserErrorHeader):
        (WebCore::XMLErrors::insertErrorMessageBlock):
        * xml/parser/NewXMLDocumentParser.h:
        (NewXMLDocumentParser):
        * xml/parser/XMLDocumentParser.h:
        (XMLDocumentParser):
        * xml/parser/XMLDocumentParserLibxml2.cpp:
        (WebCore::XMLDocumentParser::XMLDocumentParser):
        (WebCore::XMLDocumentParser::endElementNs):
        * xml/parser/XMLDocumentParserQt.cpp:
        (WebCore::XMLDocumentParser::XMLDocumentParser):
        (WebCore::XMLDocumentParser::parseEndElement):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to V8Utilities::createFunctionCallback()
        https://bugs.webkit.org/show_bug.cgi?id=86978

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to V8Utilities::createFunctionCallback().

        No tests. No change in behavior.

        * bindings/v8/V8Utilities.cpp:
        (WebCore::throwTypeMismatchException):
        * bindings/v8/V8Utilities.h:
        (WebCore):
        (WebCore::createFunctionOnlyCallback):
        * bindings/v8/custom/V8GeolocationCustom.cpp:
        (WebCore::V8Geolocation::getCurrentPositionCallback):
        (WebCore::V8Geolocation::watchPositionCallback):
        * bindings/v8/custom/V8NotificationCustom.cpp:
        (WebCore::V8Notification::requestPermissionCallback):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to throwError()s in bindings/v8/*.{h,cpp}
        https://bugs.webkit.org/show_bug.cgi?id=86977

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to throwError()s in bindings/v8/*.{h,cpp}
        except for a couple of non-trivial cases. I'll upload a follow-up patch
        for the non-trivial cases.

        No tests. No change in behavior.

        * bindings/v8/DateExtension.cpp:
        (WebCore::DateExtension::OnSleepDetected):
        * bindings/v8/SerializedScriptValue.cpp:
        (WebCore::SerializedScriptValue::transferArrayBuffers):
        (WebCore::SerializedScriptValue::SerializedScriptValue):
        * bindings/v8/SerializedScriptValue.h:
        * bindings/v8/V8NPObject.cpp:
        (WebCore::npObjectInvokeImpl):
        (WebCore::npObjectPropertyEnumerator):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::checkNewLegal):

2012-05-20  Keishi Hattori  <keishi@webkit.org>

        [Chromium] Enable datalist for input type email
        https://bugs.webkit.org/show_bug.cgi?id=85356

        Reviewed by Kent Tamura.

        No new tests. Covered in fast/forms/datalist/input-list.html

        * rendering/RenderThemeChromiumCommon.cpp:
        (WebCore::RenderThemeChromiumCommon::supportsDataListUI):

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to throwError()s in CodeGeneratorV8.pm
        https://bugs.webkit.org/show_bug.cgi?id=86976

        Reviewed by Adam Barth.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to throwError()s in CodeGeneratorV8.pm.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateNormalAttrGetter):
        (GenerateNormalAttrSetter):
        (GenerateParametersCheck):
        (GenerateConstructorCallback):
        (GenerateNamedConstructorCallback):
        (GenerateFunctionCallString):
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        (WebCore::V8TestInterface::constructorCallback):
        * bindings/scripts/test/V8/V8TestNamedConstructor.cpp:
        (WebCore::V8TestNamedConstructorConstructorCallback):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::withScriptStateAttributeAttrSetter):
        (WebCore::TestObjV8Internal::withScriptStateAttributeRaisesAttrGetter):
        (WebCore::TestObjV8Internal::withScriptStateAttributeRaisesAttrSetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateAttributeAttrSetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateAttributeRaisesAttrGetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateAttributeRaisesAttrSetter):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateWithSpacesAttributeAttrSetter):
        (WebCore::TestObjV8Internal::withScriptStateVoidCallback):
        (WebCore::TestObjV8Internal::withScriptStateObjCallback):
        (WebCore::TestObjV8Internal::withScriptStateVoidExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptStateObjExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateCallback):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateObjExceptionCallback):
        (WebCore::TestObjV8Internal::withScriptExecutionContextAndScriptStateWithSpacesCallback):
        (WebCore::TestObjV8Internal::methodWithCallbackArgCallback):
        (WebCore::TestObjV8Internal::methodWithNonCallbackArgAndCallbackArgCallback):
        (WebCore::TestObjV8Internal::methodWithCallbackAndOptionalArgCallback):
        (WebCore::TestObjV8Internal::overloadedMethod5Callback):
        (WebCore::V8TestObj::constructorCallback):

2012-05-20  George Staikos  <staikos@webkit.org>

        [BlackBerry] Implement the Screen functions to get DPI.
        https://bugs.webkit.org/show_bug.cgi?id=86967

        Reviewed by Antonio Gomes.

        * platform/blackberry/PlatformScreenBlackBerry.cpp:
        (WebCore::screenHorizontalDPI):
        (WebCore::screenVerticalDPI):

2012-05-20  Shinya Kawanaka  <shinyak@chromium.org>

        [Refactoring] Node::shadowHost() and Node::setShadowHost() can be moved to ShadowRoot.
        https://bugs.webkit.org/show_bug.cgi?id=86585

        Reviewed by Hajime Morita.

        Since Node::shadowHost() and Node::setShadowHost() are valid only if Node is ShadowRoot,
        they should be moved to ShadowRoot.

        However, Node::setParent cannot be called from ShadowRoot, we add Node::setParentOrHostNode
        to call it as Node::parentOrHostNode() calls Node::parent(). Node::setParent() is now private.
        We also add SVGElementInstance::setParentOrHostNode() to share ContainerNodeAlgorithm.

        No new tests, no change in behavior.

        * dom/Attr.cpp:
        (WebCore::Attr::createTextChild):
        * dom/ContainerNode.cpp:
        (WebCore::ContainerNode::insertBeforeCommon):
        (WebCore::ContainerNode::removeBetween):
        (WebCore::ContainerNode::removeChildren):
        * dom/ContainerNodeAlgorithms.h:
        (WebCore::appendChildToContainer):
        (WebCore::Private::addChildNodesToDeletionQueue):
        * dom/ElementShadow.cpp:
        (WebCore::validateShadowRoot):
        (WebCore::ElementShadow::addShadowRoot):
        (WebCore::ElementShadow::removeAllShadowRoots):
        * dom/EventDispatcher.cpp:
        (WebCore::eventTargetRespectingSVGTargetRules):
        (WebCore::EventDispatcher::ensureEventAncestors):
        (WebCore::EventDispatcher::determineDispatchBehavior):
        * dom/EventDispatcher.h:
        (WebCore):
        (EventDispatcher):
        * dom/Node.cpp:
        (WebCore::Node::parentOrHostElement):
        * dom/Node.h:
        (Node):
        (WebCore::Node::setParentOrHostNode):
        (WebCore):
        * dom/NodeRenderingContext.cpp:
        (WebCore::NodeRenderingContext::NodeRenderingContext):
        * dom/ShadowRoot.h:
        (WebCore::ShadowRoot::host):
        (WebCore):
        (WebCore::ShadowRoot::setHost):
        * dom/TreeScope.cpp:
        (WebCore::TreeScope::focusedNode):
        * html/shadow/ContentSelectorQuery.cpp:
        (WebCore::ContentSelectorQuery::matches):
        * page/DragController.cpp:
        (WebCore::asFileInput):
        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleMousePressEvent):
        (WebCore::instanceAssociatedWithShadowTreeElement):
        (WebCore::EventHandler::dispatchMouseEvent):
        * page/FocusController.cpp:
        (WebCore::FocusScope::owner):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::hasLineIfEmpty):
        * svg/SVGElementInstance.h:
        (WebCore::SVGElementInstance::setParentOrHostNode):
        (SVGElementInstance):
        * svg/SVGStyledElement.cpp:
        (WebCore::SVGStyledElement::title):
        * svg/SVGTRefElement.cpp:
        (WebCore::SVGShadowText::willRecalcTextStyle):

2012-05-20  Joe Thomas  <joethomas@motorola.com>

        Unsupported commands should have queryCommandValue() = "", not false
        https://bugs.webkit.org/show_bug.cgi?id=86964

        Reviewed by Ryosuke Niwa.

        queryCommandValue for unsupported commands should return empty string.
        The specification related to this can be located at http://dvcs.w3.org/hg/editing/raw-file/tip/editing.html#methods-to-query-and-execute-commands

        Test: editing/execCommand/queryCommandValue-unsupported-commands.html

        * dom/Document.idl:

2012-05-20  Kentaro Hara  <haraken@chromium.org>

        Unreviewed. Rebaselined run-bindings-tests results.

        * bindings/scripts/test/JS/JSTestInterface.cpp:
        (WebCore::setJSTestInterfaceSupplementalStr2):
        (WebCore::setJSTestInterfaceSupplementalStr3):
        (WebCore::setJSTestInterfaceSupplementalNode):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::setJSTestObjShortAttr):
        (WebCore::setJSTestObjUnsignedShortAttr):
        (WebCore::setJSTestObjIntAttr):
        (WebCore::setJSTestObjLongLongAttr):
        (WebCore::setJSTestObjUnsignedLongLongAttr):
        (WebCore::setJSTestObjStringAttr):
        (WebCore::setJSTestObjTestObjAttr):
        (WebCore::setJSTestObjSequenceAttr):
        (WebCore::setJSTestObjIntSequenceAttr):
        (WebCore::setJSTestObjShortSequenceAttr):
        (WebCore::setJSTestObjLongSequenceAttr):
        (WebCore::setJSTestObjLongLongSequenceAttr):
        (WebCore::setJSTestObjUnsignedIntSequenceAttr):
        (WebCore::setJSTestObjUnsignedShortSequenceAttr):
        (WebCore::setJSTestObjUnsignedLongSequenceAttr):
        (WebCore::setJSTestObjUnsignedLongLongSequenceAttr):
        (WebCore::setJSTestObjFloatSequenceAttr):
        (WebCore::setJSTestObjDoubleSequenceAttr):
        (WebCore::setJSTestObjBooleanSequenceAttr):
        (WebCore::setJSTestObjVoidSequenceAttr):
        (WebCore::setJSTestObjDateSequenceAttr):
        (WebCore::setJSTestObjXMLObjAttr):
        (WebCore::setJSTestObjCreate):
        (WebCore::setJSTestObjReflectedStringAttr):
        (WebCore::setJSTestObjReflectedIntegralAttr):
        (WebCore::setJSTestObjReflectedUnsignedIntegralAttr):
        (WebCore::setJSTestObjReflectedBooleanAttr):
        (WebCore::setJSTestObjReflectedURLAttr):
        (WebCore::setJSTestObjReflectedCustomIntegralAttr):
        (WebCore::setJSTestObjReflectedCustomBooleanAttr):
        (WebCore::setJSTestObjReflectedCustomURLAttr):
        (WebCore::setJSTestObjAttrWithGetterException):
        (WebCore::setJSTestObjAttrWithSetterException):
        (WebCore::setJSTestObjStringAttrWithGetterException):
        (WebCore::setJSTestObjStringAttrWithSetterException):
        (WebCore::setJSTestObjCustomAttr):
        (WebCore::setJSTestObjWithScriptStateAttribute):
        (WebCore::setJSTestObjWithScriptExecutionContextAttribute):
        (WebCore::setJSTestObjWithScriptStateAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateAttribute):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateAttributeRaises):
        (WebCore::setJSTestObjWithScriptExecutionContextAndScriptStateWithSpacesAttribute):
        (WebCore::setJSTestObjWithScriptArgumentsAndCallStackAttribute):
        (WebCore::setJSTestObjConditionalAttr1):
        (WebCore::setJSTestObjConditionalAttr2):
        (WebCore::setJSTestObjConditionalAttr3):
        (WebCore::setJSTestObjConditionalAttr4Constructor):
        (WebCore::setJSTestObjConditionalAttr5Constructor):
        (WebCore::setJSTestObjConditionalAttr6Constructor):
        (WebCore::setJSTestObjMutablePoint):
        (WebCore::setJSTestObjImmutablePoint):
        (WebCore::setJSTestObjStrawberry):
        (WebCore::setJSTestObjStrictFloat):
        (WebCore::setJSTestObjId):
        * bindings/scripts/test/JS/JSTestSerializedScriptValueInterface.cpp:
        (WebCore::setJSTestSerializedScriptValueInterfaceValue):
        (WebCore::setJSTestSerializedScriptValueInterfaceCachedValue):

2012-05-20  George Staikos  <staikos@webkit.org>

        Use reinterpret_cast_ptr<> to fix an alignment warning.
        https://bugs.webkit.org/show_bug.cgi?id=80790

        Reviewed by Rob Buis.

        * platform/image-decoders/jpeg/JPEGImageDecoder.cpp:
        (WebCore::error_exit):

2012-05-20  Takashi Sakamoto  <tasak@google.com>

        Needs style recalculation by changing applyAuthorStyles dynamically
        https://bugs.webkit.org/show_bug.cgi?id=84251

        Modifying setApplyAuthorStyles to invoke owner()'s
        setNeedsRedistributing if applyAuthorStyles changes.

        Reviewed by Hajime Morita.

        No new tests. Adding new tests to existing
        fast/dom/shadow/shadow-root-applyAuthorStyles.html to test this
        feature.

        * dom/ShadowRoot.cpp:
        (WebCore::ShadowRoot::setApplyAuthorStyles):
        If applyAuthorStyles changes, invoke owner's setNeedsRedistributing to
        recalculate styles of the shadow root's child elements.

2012-05-20  Philip Rogers  <pdr@google.com>

        Accumulate SVG animations into first contributing element
        https://bugs.webkit.org/show_bug.cgi?id=86385

        Reviewed by Nikolas Zimmermann.

        Previously we were accumulating animations into the first animation element when
        there were multiple animations for a single element. This crashed if the first
        animation ended first because the first animation was prematurely cleaned up.
        This change accumulates animations into the first _contributing_ animation element.

        Tests: svg/animations/multiple-animations-ending.html
               svg/animations/svg-two-animate-elements-crash-expected.svg
               svg/animations/svg-two-animate-elements-crash.svg

        * svg/animation/SMILTimeContainer.cpp:
        (WebCore::SMILTimeContainer::updateAnimations):
        * svg/animation/SVGSMILElement.cpp:
        (WebCore::SVGSMILElement::progress):

2012-05-20  Philip Rogers  <pdr@google.com>

        Fix hit testing on non-scaling strokes
        https://bugs.webkit.org/show_bug.cgi?id=82628

        Reviewed by Nikolas Zimmermann.

        This change fixes hit testing on non-scaling strokes. It contains fixes for 3 bugs:
        1) RenderSVGRect::shapeDependentStrokeContains was not falling back to shape-based hit testing.
        2) m_strokeAndMarkerBoundingBox did not account for non-scaling strokes.
        3) RenderSVGShape::shapeDependentStrokeContains did not have any support for non-scaling strokes.

        This change also contains some refactoring/cleanup of the non-scale-stroke codepaths.

        Test: svg/hittest/svg-shapes-non-scale-stroke.html

        * rendering/svg/RenderSVGEllipse.cpp:
        (WebCore::RenderSVGEllipse::createShape):
        * rendering/svg/RenderSVGRect.cpp:
        (WebCore::RenderSVGRect::createShape):
        (WebCore::RenderSVGRect::shapeDependentStrokeContains):
        * rendering/svg/RenderSVGShape.cpp:
        (WebCore::RenderSVGShape::shapeDependentStrokeContains):
        (WebCore::RenderSVGShape::shapeDependentFillContains):
        (WebCore::RenderSVGShape::nonScalingStrokePath):
        (WebCore):
        (WebCore::RenderSVGShape::setupNonScalingStrokeContext):
        (WebCore::RenderSVGShape::nonScalingStrokeTransform):
        (WebCore::RenderSVGShape::strokePath):
        (WebCore::RenderSVGShape::fillAndStrokePath):
        (WebCore::RenderSVGShape::updateCachedBoundaries):
        (WebCore::RenderSVGShape::inflateWithStrokeAndMarkerBounds):
        * rendering/svg/RenderSVGShape.h:
        (WebCore::RenderSVGShape::hasNonScalingStroke):
        (RenderSVGShape):

2012-05-19  Emil A Eklund  <eae@chromium.org>

        Simplify RenderOverflow by using Rects
        https://bugs.webkit.org/show_bug.cgi?id=86894

        Reviewed by Eric Seidel.

        Simplify the RenderOverflow class and the uses of it by storing the
        overflow values in rects and using the rects instead of the individual
        values where it makes sense.

        No new tests, no change in functionality.

        * page/FrameView.cpp:
        (WebCore::FrameView::adjustPageHeightDeprecated):
        Change to use layoutOverflowRect().maxX() and replace C style casts with
        C++ style to comply with style guide.
        
        * rendering/InlineFlowBox.h:
        (WebCore::InlineFlowBox::logicalLeftLayoutOverflow):
        (WebCore::InlineFlowBox::logicalRightLayoutOverflow):
        (WebCore::InlineFlowBox::logicalTopLayoutOverflow):
        (WebCore::InlineFlowBox::logicalBottomLayoutOverflow):
        (WebCore::InlineFlowBox::logicalLeftVisualOverflow):
        (WebCore::InlineFlowBox::logicalRightVisualOverflow):
        (WebCore::InlineFlowBox::logicalTopVisualOverflow):
        (WebCore::InlineFlowBox::logicalBottomVisualOverflow):
        Change methods to use layoutOverflowRect() and visualOverflowRect().
        
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::scrollWidth):
        (WebCore::RenderBox::scrollHeight):
        Change methods to use visualOverflowRect().
        
        (WebCore::RenderBox::clearLayoutOverflow):
        Use setLayoutOverflow instead of resetLayoutOverflow (which has been
        removed as it did exactly the same thing as the set method).
        
        * rendering/RenderBox.h:
        (WebCore::RenderBox::maxLayoutOverflow):
        (WebCore::RenderBox::logicalLeftLayoutOverflow):
        (WebCore::RenderBox::logicalRightLayoutOverflow):
        (WebCore::RenderBox::logicalLeftVisualOverflow):
        (WebCore::RenderBox::logicalRightVisualOverflow):
        Remove minYLayoutOverflow, maxYLayoutOverflow, minXLayoutOverflow and
        maxXLayoutOverflow and update the remaining methods to use
        layoutOverflowRect().
        
        * rendering/RenderMarquee.cpp:
        (WebCore::RenderMarquee::computePosition):
        Change to use layoutOverflowRect().
        
        * rendering/RenderOverflow.h:
        (WebCore::RenderOverflow::RenderOverflow):
        (WebCore::RenderOverflow::layoutOverflowRect):
        (WebCore::RenderOverflow::visualOverflowRect):
        (RenderOverflow):
        (WebCore::RenderOverflow::setMinYLayoutOverflow):
        (WebCore::RenderOverflow::setMaxYLayoutOverflow):
        (WebCore::RenderOverflow::setMinXLayoutOverflow):
        (WebCore::RenderOverflow::setMaxXLayoutOverflow):
        (WebCore::RenderOverflow::setMinYVisualOverflow):
        (WebCore::RenderOverflow::setMaxYVisualOverflow):
        (WebCore::RenderOverflow::setMinXVisualOverflow):
        (WebCore::RenderOverflow::setMaxXVisualOverflow):
        (WebCore):
        (WebCore::RenderOverflow::move):
        (WebCore::RenderOverflow::addLayoutOverflow):
        (WebCore::RenderOverflow::addVisualOverflow):
        (WebCore::RenderOverflow::setLayoutOverflow):
        (WebCore::RenderOverflow::setVisualOverflow):
        Change RenderOverflow to use two rects instead of two sets of four
        values. Remove [min|max][Layout|Visual]Overflow getters and change the
        layoutOverflowRect and visualOverflowRect methods to return the rects.
        
        * rendering/RenderReplaced.cpp:
        (WebCore::RenderReplaced::shouldPaint):
        Change to use visualOverflowRect().
        
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::layout):
        Change to use visualOverflowRect().
        
        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::clippedOverflowRectForRepaint):
        Change to use visualOverflowRect().
        
        * rendering/RenderTreeAsText.cpp:
        (WebCore::writeLayers):
        Change to use layoutOverflowRect().

2012-05-19  Rob Buis  <rbuis@rim.com>

        Remove bbox caching from SVGPathElement
        https://bugs.webkit.org/show_bug.cgi?id=86233

        Reviewed by Nikolas Zimmermann.

        Remove caching of path bounding box, since SVGLocatable::getBBox is not used much at all.
        This saves 200k of memory for worldcup.svg on 64-bit machine.

        * svg/SVGPathElement.cpp:
        (WebCore::SVGPathElement::SVGPathElement):
        (WebCore::SVGPathElement::svgAttributeChanged):
        (WebCore::SVGPathElement::pathSegListChanged):
        (WebCore::SVGPathElement::getBBox):
        * svg/SVGPathElement.h:
        (SVGPathElement):

2012-05-19  Andy Estes  <aestes@apple.com>

        Fix build errors found when disabling ENABLE_DRAG_SUPPORT
        https://bugs.webkit.org/show_bug.cgi?id=86947

        Reviewed by Jon Honeycutt.

        * page/mac/EventHandlerMac.mm:
        (WebCore::EventHandler::passMouseMoveEventToSubframe):
        * platform/mac/ClipboardMac.mm:
        (WebCore):

2012-05-19  Joe Thomas  <joethomas@motorola.com>

        The order of CSS properties is wrong in background shorthand
        https://bugs.webkit.org/show_bug.cgi?id=86152

        Reviewed by Ryosuke Niwa.

        Corrected the order of properties returned in StylePropertySet::getPropertyValue for background shorthand property to match the specification  
        http://www.w3.org/TR/css3-background/#background.

        * css/StylePropertyShorthand.cpp:
        (WebCore::backgroundShorthand):

2012-05-19  Ryosuke Niwa  <rniwa@webkit.org>

        Touch Internals.* in an attempt to fix Windows builds after r117646.

        * testing/Internals.cpp:
        * testing/Internals.h:
        * testing/Internals.idl:

2012-05-18  Ryosuke Niwa  <rniwa@webkit.org>

        WebKit erroneously add 1px padding in input elements
        https://bugs.webkit.org/show_bug.cgi?id=86784

        Reviewed by Kent Tamura.

        Fixed the bug by removing the code that added left and right paddings in input elements.
        The code was added in r13567 to match a very old version of Internet Explorer but this quirk
        does not seem to exists in IE9 (both in quirks and standard modes).

        A lot of tests need to be rebaselined due to 1px difference inside input elements, and 2px
        differences for the width of input elements. (In some extreme cases, line breaking changed
        due to the width change).

        Test: fast/forms/input-textarea-padding-match.html

        * css/html.css:
        (input::-webkit-input-placeholder, isindex::-webkit-input-placeholder):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::createInnerTextStyle):

2012-05-18  Adrienne Walker  <enne@google.com>

        [chromium] Add diagnostic CRASH calls for tiler crashes
        https://bugs.webkit.org/show_bug.cgi?id=86930

        Reviewed by James Robinson.

        These lines would normally crash on their own due to null pointers,
        but having an explicit CRASH call will help us differentiate what the
        real problem might be in the crash report.

        * platform/graphics/chromium/TiledLayerChromium.cpp:
        (WebCore::TiledLayerChromium::createTile):
        (WebCore::TiledLayerChromium::updateTiles):

2012-05-18  Aaron Colwell  <acolwell@chromium.org>

        Update Media Source implementation to reflect changes in 0.5 spec.
        https://bugs.webkit.org/show_bug.cgi?id=83607

        Reviewed by Darin Fisher.

        Tests: http/tests/media/media-source/video-media-source-event-attributes.html
               http/tests/media/media-source/webm/video-media-source-abort.html
               http/tests/media/media-source/webm/video-media-source-add-and-remove-ids.html

        * html/HTMLAttributeNames.in: Add onwebkitsourcexxx event attribute names.
        * html/HTMLMediaElement.cpp: 
        (WebCore::HTMLMediaElement::parseAttribute): Add code to register event listeners for the onwebkitsourcexxx attributes.
        (WebCore::HTMLMediaElement::pauseInternal):
        (WebCore):
        (WebCore::HTMLMediaElement::webkitSourceAddId): Changed code to pass the parsed type & codecs to m_player instead of the whole MIME-type string. This was done to allow some simple parsing & validation code to be shared in WebKit instead of reimplemented in every port.
        (WebCore::HTMLMediaElement::webkitSourceBuffered): New method in the v0.5 spec. It validates the parameters & that it is being called in the correct state. If so it forwards the call to m_player.
        (WebCore::HTMLMediaElement::webkitSourceAppend): Adds id parameter to match v0.5 signature. Minor logic changes that avoid calling m_player for 0 byte arrays and fixes exceptions reported for a null array and a parse error so they match the spec text.
        (WebCore::HTMLMediaElement::webkitSourceAbort): New method in the v0.5 spec. It validates the parameter & that it is being called in athe correct state. If so it forwards the call to m_player.
        * html/HTMLMediaElement.h:
        (HTMLMediaElement): Added new methods, signature updates, and onwebitsourcexxx event listener attributes.
        * html/HTMLMediaElement.idl: Added new methods, signature updates, and onwebitsourcexxx event listener attributes.
        * platform/ContentType.cpp:
        (WebCore::ContentType::codecs): A new method that parses the codecs parameter into a vector of codec strings.
        (WebCore):
        * platform/ContentType.h: 
        (ContentType):
        * platform/graphics/MediaPlayer.cpp:
        (WebCore::NullMediaPlayerPrivate::sourceAddId): Update the signature to take the parsed type and codecs vector.
        (WebCore::NullMediaPlayerPrivate::sourceBuffered): Add default implementation for this new method.
        (WebCore::NullMediaPlayerPrivate::sourceRemoveId): Remove id parameter name to match other methods.
        (WebCore::NullMediaPlayerPrivate::sourceAppend): Updated signature to include id parameter.
        (WebCore::NullMediaPlayerPrivate::sourceAbort): Add default implementation for this new method.
        (WebCore::NullMediaPlayerPrivate::sourceEndOfStream): Remove parameter name to match other methods.
        (WebCore::MediaPlayer::sourceAddId): Update the signature to take the parsed type and codecs vector.
        (WebCore):
        (WebCore::MediaPlayer::sourceBuffered): Add implementation for new method that forwards the call to the MediaPlayerPrivate interface.
        (WebCore::MediaPlayer::sourceAppend): Update method to forward the new id parameter in the signature.
        (WebCore::MediaPlayer::sourceAbort): Add implementation for new method that forwards the call to the MediaPlayerPrivate interface.
        * platform/graphics/MediaPlayer.h: Update interface to include new methods and updated signatures.
        * platform/graphics/MediaPlayerPrivate.h:
        (WebCore::MediaPlayerPrivateInterface::sourceAddId): Update the signature to take the parsed type and codecs vector.
        (WebCore::MediaPlayerPrivateInterface::sourceBuffered): Add default implementation for new method.
        (WebCore::MediaPlayerPrivateInterface::sourceAppend): Update method to forward the new id parameter in the signature.
        (WebCore::MediaPlayerPrivateInterface::sourceAbort): Add default implementation for new method.

2012-05-18  Levi Weintraub  <leviw@chromium.org>

        Revert to float method of selection rect alignment for line box tree
        https://bugs.webkit.org/show_bug.cgi?id=86904

        Reviewed by Eric Seidel.

        In r117491, we introduced a new method of alignment for the selection rect in the sub-pixel case.
        It turns out there is at least one case on Mac where this leaves a gap when painting selection rects
        originating in the line box tree. This patch reverts us to the float method for the line box tree,
        but retains the LayoutRect snapping for gap rects.

        No new tests. Covered by existing tests with sub-pixel layout enabled.

        * rendering/EllipsisBox.cpp:
        (WebCore::EllipsisBox::paintSelection): Re-enabling the FloatRect flavor of
        alignSelectionRectToDevicePixels for the line box tree.
        * rendering/InlineTextBox.cpp:
        (WebCore::alignSelectionRectToDevicePixels): Moving LayoutRect flavor to RenderBlock.
        (WebCore::InlineTextBox::paintSelection): Happily clearing up the bifurcation of algorithms for
        sub-pixel layout.
        * rendering/InlineTextBox.h: Re-enabling the FloatRect flavor of alignSelectionRectToDevicePixels
        for the line box tree.
        * rendering/RenderBlock.cpp:
        (WebCore::alignSelectionRectToDevicePixels): Re-seating the LayoutRect version of
        alignSelectionRectToDevicePixels for use with GapRects.

2012-05-18  Eric Seidel  <eric@webkit.org>

        Assertion failure in BidiResolver::commitExplicitEmbedding() (!inIsolate() || m_currentExplicitEmbeddingSequence.isEmpty()) at wikipedia.org
        https://bugs.webkit.org/show_bug.cgi?id=76574

        Reviewed by Levi Weintraub.

        Consider this example:
        <span style="unicode-bidi: embed"><span style="unicode-bidi: isolate">a</span></span>
        Before this patch, we would ASSERT when computing the text runs, as we would have encountered
        the "embed LTR" directive from the outer span, but not try to "commit" this embedding until
        we encountered the first charater (an optimization to avoid creating unnecessary bidi embedding contexts).
        The ASSERT we were hitting was to ensure that embedding directives inside an isolated span
        did not bleed out and effect the surrounding text.

        bidi "isolate" support uses a multi-pass Unicode Bidi Algorithm (UBA), which when encountering
        "isolated" sections of text ignores them in the first pass, and then goes back and runs
        a separate instance of the UBA on those isolated sections.

        Once we scan into an "isolate" section (during an outer UBA application) we should not respect
        any embedding directives inside that "isolate" section.

        However, in the above example, our "don't commit embeddings until we need them" and
        "assert we don't respect embeddings inside isolated spans" were conflicting.
        The fix is to make sure we always commit any pending embedding directives *before*
        we enter an isolate section.

        Luckly there was no functional bug here as we were still respecting
        the embedding directives we were belatedly committing. After this change we're commiting
        those directives at a more appropriate time, thus avoiding the ASSERT.

        Test: fast/text/bidi-isolate-embedding-crash.html

        * platform/text/BidiResolver.h:
        (WebCore::::commitExplicitEmbedding):
        * rendering/InlineIterator.h:
        (WebCore::notifyObserverEnteredObject):
        (WebCore::IsolateTracker::commitExplicitEmbedding):

2012-05-18  Pratik Solanki  <psolanki@apple.com>

        BitmapImage::BitmapImage(CGImageRef, ImageObserver*) needs to set m_sizeRespectingOrientation
        https://bugs.webkit.org/show_bug.cgi?id=86915

        Reviewed by Oliver Hunt.

        Set m_sizeRespectingOrientation to be the same as m_size. Otherwise it stays at 0x0 since
        this constructor also sets m_haveSize to true for the BitmapImage.

        * platform/graphics/cg/ImageCG.cpp:
        (WebCore::BitmapImage::BitmapImage):

2012-05-18  Dan Bernstein  <mitz@apple.com>

        Build fix after r117607.

        * platform/mac/WebCoreNSCellExtras.m:

2012-05-18  Caio Marcelo de Oliveira Filho  <caio.oliveira@openbossa.org>

        Fix remaining uses of JSValue::toBoolean()
        https://bugs.webkit.org/show_bug.cgi?id=86912

        Reviewed by Filip Pizlo.

        And unbreak Qt build.

        * bindings/scripts/test/JS/JSTestEventTarget.cpp:
        (WebCore::jsTestEventTargetPrototypeFunctionAddEventListener):
        (WebCore::jsTestEventTargetPrototypeFunctionRemoveEventListener):
        * bindings/scripts/test/JS/JSTestObj.cpp:
        (WebCore::setJSTestObjCreate):
        (WebCore::setJSTestObjReflectedBooleanAttr):
        (WebCore::setJSTestObjReflectedCustomBooleanAttr):
        (WebCore::jsTestObjPrototypeFunctionAddEventListener):
        (WebCore::jsTestObjPrototypeFunctionRemoveEventListener):
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertValueToQVariant):
        * bridge/qt/qt_runtime_qt4.cpp:
        (JSC::Bindings::convertValueToQVariant):

2012-04-27  Filip Pizlo  <fpizlo@apple.com>

        DFG should have control flow graph simplification
        https://bugs.webkit.org/show_bug.cgi?id=84553

        Reviewed by Oliver Hunt.

        Merged r115512 from dfgopt.

        JSValue::toBoolean(ExecState*) -> JSValue::toBoolean()
        
        No new tests, because no new behavior.

        * bindings/js/JSCustomSQLStatementErrorCallback.cpp:
        (WebCore::JSSQLStatementErrorCallback::handleEvent):
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::addEventListener):
        (WebCore::JSDOMWindow::removeEventListener):
        * bindings/js/JSDataViewCustom.cpp:
        (WebCore::getDataViewMember):
        * bindings/js/JSDeviceMotionEventCustom.cpp:
        (WebCore::JSDeviceMotionEvent::initDeviceMotionEvent):
        * bindings/js/JSDeviceOrientationEventCustom.cpp:
        (WebCore::JSDeviceOrientationEvent::initDeviceOrientationEvent):
        * bindings/js/JSDictionary.cpp:
        (WebCore::JSDictionary::convertValue):
        * bindings/js/JSDirectoryEntryCustom.cpp:
        (WebCore::JSDirectoryEntry::getFile):
        (WebCore::JSDirectoryEntry::getDirectory):
        * bindings/js/JSDirectoryEntrySyncCustom.cpp:
        (WebCore::getFlags):
        * bindings/js/JSHTMLCanvasElementCustom.cpp:
        (WebCore::JSHTMLCanvasElement::getContext):
        * bindings/js/JSInspectorFrontendHostCustom.cpp:
        (WebCore::JSInspectorFrontendHost::showContextMenu):
        * bindings/js/JSMessageEventCustom.cpp:
        (WebCore::handleInitMessageEvent):
        * bindings/js/JSWebGLRenderingContextCustom.cpp:
        (WebCore::dataFunctionMatrix):
        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::open):
        * bindings/js/ScriptDebugServer.cpp:
        (WebCore::ScriptDebugServer::hasBreakpoint):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateEventListenerCall):
        (GenerateImplementation):
        (JSValueToNative):
        * bridge/c/c_utility.cpp:
        (JSC::Bindings::convertValueToNPVariant):
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::convertValueToJObject):

2012-05-18  Shawn Singh  <shawnsingh@chromium.org>

        [chromium] add back-face visibility check for renderSurfaces
        https://bugs.webkit.org/show_bug.cgi?id=86870

        Reviewed by Adrienne Walker.

        Test added CCLayerTreeHostCommonTest::verifyBackFaceCullingWithPreserves3dForFlatteningSurface

        Chromium was not checking back-face visibility for renderSurfaces
        that needed it. This patch adds that check and the appropriate
        unit test.

        * platform/graphics/chromium/cc/CCLayerTreeHostCommon.cpp:
        (WebCore::layerIsInExisting3DRenderingContext):
        (WebCore):
        (WebCore::subtreeShouldRenderToSeparateSurface):
        (WebCore::calculateDrawTransformsAndVisibilityInternal):

2012-05-18  Levi Weintraub  <leviw@chromium.org>

        Standalone table-columns should be wrapped in anonymous tables
        https://bugs.webkit.org/show_bug.cgi?id=86671

        Reviewed by Julien Chaffraix.

        The CSS2 spec specifies that table-columns misparented outside of a table or
        table-column-group should be wrapped in an anonymous table. Updating 
        RenderObject::addChild to follow the spec.
        see http://www.w3.org/TR/CSS2/tables.html#anonymous-boxes for details.

        Tests: fast/table/table-column-generates-anonymous-table.html
               fast/table/table-column-group-generates-anonymous-table.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::addChild):

2012-05-18  Keyar Hood  <keyar@chromium.org>

        Support imageSmoothingEnabled
        https://bugs.webkit.org/show_bug.cgi?id=82804

        Reviewed by Stephen White.

        Test: fast/canvas/canvas-imageSmoothingEnabled.html

        Added the imageSmoothingEnabled parameter to the
        CanvasRenderingContext2D object. When it is set to false, it sets
        InterpolationQuality to InterpolationNone. When set to true, it sets
        the InterpolationQuality to DefaultInterpolationQuality (as that is the
        only other value used).

        * html/canvas/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::CanvasRenderingContext2D):
        (WebCore::CanvasRenderingContext2D::webkitImageSmoothingEnabled):
        (WebCore):
        (WebCore::CanvasRenderingContext2D::setWebkitImageSmoothingEnabled):
        * html/canvas/CanvasRenderingContext2D.h:
        (CanvasRenderingContext2D):
        * html/canvas/CanvasRenderingContext2D.idl:

2012-05-18  Terry Anderson  <tdanderson@chromium.org>

        Percentage height replaced elements sometimes cause overflow of table contents
        https://bugs.webkit.org/show_bug.cgi?id=85581

        Reviewed by Eric Seidel.

        Test: fast/replaced/table-replaced-element.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::computeReplacedLogicalHeightUsing):
        This change guarantees that the containing block of a replaced element with percentage
        height will be marked as having a percentage height descendant.

2012-05-18  Viatcheslav Ostapenko  <ostapenko.viatcheslav@nokia.com>

        [Qt] REGRESSION(r117501): It made almost all tests assert in debug mode
        https://bugs.webkit.org/show_bug.cgi?id=86854

        Reviewed by Andreas Kling.

        Initialize boolean flag in constructor and recheck the flag which can be 
        modified by another thread under mutex.

        No new tests, fixes regression that caused layout test crash.

        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::IconDatabase):
        (WebCore::IconDatabase::syncThreadMainLoop):

2012-05-18  Christophe Dumez  <christophe.dumez@intel.com>

        [EFL] Web Intents code is not compiling
        https://bugs.webkit.org/show_bug.cgi?id=85364

        Reviewed by Adam Barth.

        Add missing implementation for
        JSIntentConstructor::constructJSIntent() in JS bindings.

        * CMakeLists.txt:
        * UseJSC.cmake:
        * bindings/js/JSIntentConstructor.cpp: Added.
        (WebCore):
        (WebCore::JSIntentConstructor::constructJSIntent):

2012-05-18  Joe Thomas  <joethomas@motorola.com>

        background-size specified by a single value in background shorthand fails to parse.
        https://bugs.webkit.org/show_bug.cgi?id=86739

        Reviewed by Tony Chang.

        While parsing the background shorthand property, if the second parsedValue is not a valid unit,
        parseFillSize should return the first parsedValue instead of failing.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseFillSize):

2012-05-18  Tony Chang  <tony@chromium.org>

        remove the CSS_GRID_LAYOUT compiler define, but default grid layout to off
        https://bugs.webkit.org/show_bug.cgi?id=86767

        Reviewed by Ojan Vafai.

        We disable grid by ignoring the display type at CSS parse time.

        Test: fast/css-grid-layout/grid-disabled-by-default.html

        * Configurations/FeatureDefines.xcconfig:
        * css/CSSComputedStyleDeclaration.cpp: Remove compile checks.
        (WebCore):
        (WebCore::valueForGridPosition):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParserContext::CSSParserContext):
        (WebCore::operator==):
        (WebCore::isValidKeywordPropertyAndValue): Move display into parseValue.
        (WebCore::isKeywordPropertyID):
        (WebCore::CSSParser::parseValue): Ignore while parsing if not enabled.
        (WebCore::CSSParser::parseGridTrackList):
        (WebCore::CSSParser::cssGridLayoutEnabled):
        (WebCore):
        * css/CSSParser.h:
        * css/CSSParserMode.h:
        (CSSParserContext):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        * css/CSSProperty.cpp:
        (WebCore::CSSProperty::isInheritedProperty):
        * css/CSSPropertyNames.in:
        * css/CSSValueKeywords.in:
        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::collectMatchingRulesForList):
        * dom/Document.cpp:
        (WebCore::Document::cssGridLayoutEnabled): Added to keep track of whether grid is enabled or not.
        (WebCore):
        * dom/Document.h:
        * page/Settings.cpp:
        (WebCore::Settings::Settings):
        * page/Settings.h:
        (WebCore::Settings::setCSSGridLayoutEnabled): Added.
        (WebCore::Settings::cssGridLayoutEnabled): Added.
        (Settings):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::createObject):
        * rendering/style/RenderStyle.cpp:
        (WebCore::RenderStyle::RenderStyle):
        (WebCore::RenderStyle::diff):
        * rendering/style/RenderStyle.h:
        * rendering/style/RenderStyleConstants.h:
        * rendering/style/StyleGridData.cpp:
        * rendering/style/StyleGridData.h:
        * rendering/style/StyleGridItemData.cpp:
        * rendering/style/StyleGridItemData.h:
        * rendering/style/StyleRareNonInheritedData.cpp:
        (WebCore::StyleRareNonInheritedData::StyleRareNonInheritedData):
        (WebCore::StyleRareNonInheritedData::operator==):
        * rendering/style/StyleRareNonInheritedData.h:
        (WebCore):
        (StyleRareNonInheritedData):

2012-05-18  Martin Robinson  <mrobinson@igalia.com>

        OOM running webgl/sdk/tests/conformance/context/context-creation-and-destruction.html
        https://bugs.webkit.org/show_bug.cgi?id=80509

        Reviewed by Alejandro G. Castro.

        No new tests. This is covered by by context-creation-and-destruction.html
        Khronos conformance test which will be part of the WebKit repository once
        bug 44310 is closed.

        Rework the ownership of GLContexts. Instead of having them managed by the
        state of window mapping or removed by calling a static method, always have
        them owned by the callers. This makes all GLContext creators factory methods
        that return PassOwnPtr.

        This change also switches the sharing context for a WebView from the window
        context to a global shared context. This simplifies things greatly, allowing
        the removal of GLContextGtk and makes the factory change easier.

        * GNUmakefile.list.am: Remove GLContextGtk.cpp from the source list.
        * platform/graphics/cairo/GLContext.cpp:
        (WebCore::GLContext::sharingContext): Added, getter for the global sharing context.
        (WebCore::GLContext::createContextForWindow): Added, a factory method for creating
        window contexts.
        (WebCore::GLContext::createOffscreenContext): Allow passing a sharing context here.
        (WebCore::GLContext::makeContextCurrent): Assert that this is the main thread, to
        increase the guarantee that we are only using these contexts on the main thread.
        (WebCore::GLContext::getCurrent): Ditto.
        * platform/graphics/cairo/GLContext.h: Update the above method signatures and remove
        createOffscreenContext, which has just been subsumed into the other factory methods.
        * platform/graphics/cairo/GraphicsContext3DCairo.cpp: The HostWindow is no longer needed
        to get the sharing context, so we can simplify things quite a bit and make a platform
        independent implementation here.
        * platform/graphics/cairo/GraphicsContext3DPrivate.cpp: Ditto.
        * platform/graphics/glx/GLContextGLX.cpp: Modify all the factory methods to return PassOwnPtr.
        * platform/graphics/glx/GLContextGLX.h: Ditto.
        * platform/graphics/gtk/GLContextGtk.cpp: Removed.

2012-05-18  Pablo Flouret  <pablof@motorola.com>

        Script elements inserted while fragment parsing should have their "already started" flag set.
        https://bugs.webkit.org/show_bug.cgi?id=86376

        Reviewed by Ryosuke Niwa.

        Step 3 of:
        http://www.whatwg.org/specs/web-apps/current-work/multipage/tree-construction.html#scriptTag

        Test: fast/parser/script-already-started-flag-in-fragment-parsing-mode.html

        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::create):
        * html/HTMLScriptElement.h:
        (HTMLScriptElement):
        * html/parser/HTMLConstructionSite.cpp:
        (WebCore::HTMLConstructionSite::insertScriptElement):

2012-05-18  Shezan Baig  <shezbaig.wk@gmail.com>

        Expose FrameSelection::absoluteCaretBounds via window.internals
        https://bugs.webkit.org/show_bug.cgi?id=86390

        Reviewed by Ryosuke Niwa.

        Add 'absoluteCaretBounds' method to Internals, which returns the
        FrameSelection::absoluteCaretBounds.

        Test: editing/selection/internal-caret-rect.html

        * WebCore.exp.in: Export the necessary symbols.
        * testing/Internals.cpp:
        (WebCore::Internals::absoluteCaretBounds): Implementation of new method.
        (WebCore):
        * testing/Internals.h: Declare the new method.
        (Internals):
        * testing/Internals.idl: Declare the new method.

2012-05-18  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/11467250> No focus ring around popup buttons

        Reviewed by Anders Carlsson.

        The exact same issue was fixed for buttons drawn in ThemeMac.mm in <rdar://problem/10542095>.
        This change extends the fix to also cover buttons drawn in RenderThemeMac.mm.

        * WebCore.xcodeproj/project.pbxproj: Added WebCoreNSCellExtras.{h.m}.
        * platform/mac/ThemeMac.mm: Removed the definitions of BUTTON_CELL_DRAW_WITH_FRAME_DRAWS_FOCUS_RING
        and -[NSCell _web_drawFocusRingWithFrame:inView:] from here. They are now in WebCoreNSCellExtras.
        * platform/mac/WebCoreNSCellExtras.h: Added.
        * platform/mac/WebCoreNSCellExtras.m: Added.
        (-[NSCell _web_drawFocusRingWithFrame:inView:]): Moved from ThemeMac.mm here.
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintMenuList): Changed to use -_web_drawFocusRingWithFrame:inView:.
        (WebCore::RenderThemeMac::setPopupButtonCellState): Removed call to updateFocusedState() when
        the focus ring is drawn separately.

2012-05-18  Philippe Normand  <pnormand@igalia.com>

        [GStreamer] Fix early return of the mimeTypeCache function after r117207.

        Rubber-stamped by Martin Robinson.

        * platform/graphics/gstreamer/MediaPlayerPrivateGStreamer.cpp: Set
        typeListInitialized to true after the cache has been filled so
        that next call to the function goes through the early return path.

2012-05-18  Martin Robinson  <mrobinson@igalia.com>

        Get IndexedDB closer to building for GTK+.

        Reviewed by Philippe Normand.

        No new tests. This is only a build fix.

        * GNUmakefile.am: Add the appropriate option to enable LevelDB support.
        * GNUmakefile.list.am: Add missing indexed database files to the source list.

2012-05-18  Dan Bernstein  <mitz@apple.com>

        Removed stale references in the Xcode project after r117369.

        * WebCore.xcodeproj/project.pbxproj: Removed references to CSSStyleDeclaration.cpp.

2012-05-18  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Add resource to UISourceCode constructor.
        https://bugs.webkit.org/show_bug.cgi?id=86853

        Reviewed by Pavel Feldman.

        This is a first step of merging resource revision support into UISourceCode.

        * inspector/front-end/CompilerScriptMapping.js:
        * inspector/front-end/DebuggerResourceBinding.js:
        (WebInspector.DebuggerResourceBinding.setScriptSource.didEditScriptSource):
        (WebInspector.DebuggerResourceBinding.setScriptSource):
        * inspector/front-end/DebuggerScriptMapping.js:
        (WebInspector.DebuggerScriptMapping.prototype._debuggerReset):
        * inspector/front-end/JavaScriptSource.js:
        * inspector/front-end/RawSourceCode.js:
        (WebInspector.RawSourceCode.prototype._createUISourceCode):
        * inspector/front-end/ResourceScriptMapping.js:
        (WebInspector.ResourceScriptMapping.prototype.addScript):
        * inspector/front-end/Script.js:
        (WebInspector.Script.prototype.isAnonymousScript):
        * inspector/front-end/ScriptSnippetModel.js:
        (WebInspector.ScriptSnippetModel.prototype._createUISourceCodeForScript):
        (WebInspector.SnippetJavaScriptSource):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSource):
        (WebInspector.StyleSourceFrame):
        (WebInspector.StyleSourceFrame.prototype.commitEditing):
        (WebInspector.StyleSourceFrame.prototype.afterTextChanged):
        (WebInspector.StyleSourceFrame.prototype._contentChanged):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode):
        (WebInspector.UISourceCode.prototype.resource):

2012-05-18  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: error when expanding an HTMLAllCollection object in the console
        https://bugs.webkit.org/show_bug.cgi?id=86741

        Reviewed by Pavel Feldman.

        RuntimeAgent.callFunctionOn should work correcly with arguments of type HTMLAllCollection.

        * inspector/InjectedScriptSource.js:

2012-05-18  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: resource revision content is not rendered properly. Resource content is shown instead.
        https://bugs.webkit.org/show_bug.cgi?id=86856

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceRevisionSourceFrame):
        (WebInspector.ResourceRevisionSourceFrame.prototype.get resource):

2012-05-18  Yi Shen  <yi.4.shen@nokia.com>

        REGRESSION (r102553): Smart links do not work
        https://bugs.webkit.org/show_bug.cgi?id=85463

        Reviewed by NOBODY Ryosuke Niwa.

        To fix the regression of smart links, we need to check TextCheckingTypeLink option in
        Editor::markAndReplaceFor().

        Test: editing/inserting/typing-space-to-trigger-smart-link.html

        * editing/Editor.cpp:
        (WebCore::Editor::markAndReplaceFor):

2012-05-18  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: empty CSS Declaration is generated by clicking the left space of 'user agent stylesheet' on Styles sidebar of Elements panel
        https://bugs.webkit.org/show_bug.cgi?id=86850

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertiesSection.prototype._handleSelectorContainerClick):

2012-05-18  Yury Semikhatsky  <yurys@chromium.org>

        Unreviewed. Remove console.error() call committed by mistake.

        * inspector/front-end/View.js:
        (WebInspector.View._assert):

2012-05-18  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: live edit resets cursor to 0,0
        https://bugs.webkit.org/show_bug.cgi?id=86851

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/DebuggerResourceBinding.js:
        (WebInspector.DebuggerResourceBinding.setScriptSource.didEditScriptSource):
        (WebInspector.DebuggerResourceBinding.setScriptSource):

2012-05-18  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: exception in console when pressing % button in CPU profile view
        https://bugs.webkit.org/show_bug.cgi?id=86849

        Reviewed by Pavel Feldman.

        Use root node to get children, not DataGrid object.

        * inspector/front-end/CPUProfileView.js:
        (WebInspector.CPUProfileView.prototype.refreshVisibleData):

2012-05-18  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: remove unnecessary indirection from profile types
        https://bugs.webkit.org/show_bug.cgi?id=86845

        Reviewed by Pavel Feldman.

        Introduced CSSProfileHeader and CPUProfileHeader, moved view creation from
        the type to corresponding profile headers. Removed some inderection and
        private fields assigned in random places. Added type annotations.

        * inspector/front-end/CPUProfileView.js:
        (WebInspector.CPUProfileType.prototype.createTemporaryProfile):
        (WebInspector.CPUProfileType.prototype.createProfile):
        (WebInspector.CPUProfileHeader):
        (WebInspector.CPUProfileHeader.prototype.createSidebarTreeElement):
        (WebInspector.CPUProfileHeader.prototype.createView):
        * inspector/front-end/CSSSelectorProfileView.js:
        (WebInspector.CSSSelectorProfileType.prototype.stopRecordingProfile):
        (WebInspector.CSSSelectorProfileType.prototype.createTemporaryProfile):
        (WebInspector.CSSSelectorProfileType.prototype.createProfile):
        (WebInspector.CSSProfileHeader):
        (WebInspector.CSSProfileHeader.prototype.createSidebarTreeElement):
        (WebInspector.CSSProfileHeader.prototype.createView):
        * inspector/front-end/HeapSnapshotView.js:
        (WebInspector.HeapSnapshotProfileType.prototype.createTemporaryProfile):
        (WebInspector.HeapSnapshotProfileType.prototype.createProfile):
        (WebInspector.HeapProfileHeader):
        (WebInspector.HeapProfileHeader.prototype.createSidebarTreeElement):
        (WebInspector.HeapProfileHeader.prototype.createView):
        (WebInspector.HeapProfileHeader.prototype.load):
        (WebInspector.HeapProfileHeader.prototype.saveToFile):
        * inspector/front-end/ProfileLauncherView.js:
        (WebInspector.ProfileLauncherView):
        (WebInspector.ProfileLauncherView.prototype.addProfileType):
        (WebInspector.ProfileLauncherView.prototype._profileTypeChanged):
        * inspector/front-end/ProfilesPanel.js:
        (WebInspector.ProfileType):
        (WebInspector.ProfileHeader):
        (WebInspector.ProfileHeader.prototype.profileType):
        (WebInspector.ProfileHeader.prototype.createSidebarTreeElement):
        (WebInspector.ProfileHeader.prototype.existingView):
        (WebInspector.ProfileHeader.prototype.view):
        (WebInspector.ProfileHeader.prototype.createView):
        (WebInspector.ProfilesPanel.prototype._reset):
        (WebInspector.ProfilesPanel.prototype.addProfileHeader):
        (WebInspector.ProfilesPanel.prototype._removeProfileHeader):
        (WebInspector.ProfilesPanel.prototype.showProfile):
        (WebInspector.ProfilesPanel.prototype.getProfiles):
        (WebInspector.ProfilesPanel.prototype.findTemporaryProfile):
        (WebInspector.ProfilesPanel.prototype._searchableViews):
        * inspector/front-end/View.js:
        (WebInspector.View._assert):

2012-05-18  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Remove V8Proxy::throwError(const char*, ErrorType, v8::Isolate*=0)
        https://bugs.webkit.org/show_bug.cgi?id=86802

        Reviewed by Adam Barth.

        As commented here (https://bugs.webkit.org/show_bug.cgi?id=84074#c5),
        I am refactoring a series of confusing throwError()s. This would be
        the final patch for the refactoring.

        This patch removes V8Proxy::throwError(const char*, ErrorType, v8::Isolate*=0).
        Also this patch refactors up a couple of throwError()s that I've forgot to
        refactor in the previous patches.

        No tests. No change in behavior.

        * bindings/v8/V8NodeFilterCondition.cpp:
        (WebCore::V8NodeFilterCondition::acceptNode):
        * bindings/v8/V8Proxy.h:
        * bindings/v8/custom/V8ArrayBufferCustom.cpp:
        (WebCore::V8ArrayBuffer::constructorCallback):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8SQLResultSetRowListCustom.cpp:
        (WebCore::V8SQLResultSetRowList::itemCallback):

2012-05-18  MORITA Hajime <morrita@google.com>

        Unreviewed attempt to fix build breakage on r117572

        * editing/Editor.cpp:
        (WebCore::Editor::willDetachPage):

2012-05-18  MORITA Hajime  <morrita@google.com>

        https://bugs.webkit.org/show_bug.cgi?id=85515
        Stale frame in WebCore::SpellChecker::didCheckSucceeded

        Reviewed by Ryosuke Niwa.

        Added EditorClient::frameWillDetachPage() notification to give a
        change to invalidate pending spellcheck requests on the client.

        Test: editing/spelling/spellcheck-async-remove-frame.html

        * editing/Editor.cpp:
        (WebCore::Editor::Editor):
        * editing/Editor.h:
        (Editor):
        * loader/EmptyClients.h:
        (WebCore::EmptyEditorClient::frameWillDetachPage):
        * page/EditorClient.h:
        (EditorClient):

2012-05-18  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: add ContentProvider::contentType and use it when rendering navigator tree.
        https://bugs.webkit.org/show_bug.cgi?id=86833

        Reviewed by Vsevolod Vlasov.

        Added ContentProvider::contentType, regactored NavigatorView to use the icon defined by the content type.

        * inspector/front-end/CompilerScriptMapping.js:
        * inspector/front-end/ContentProvider.js:
        (WebInspector.ContentProvider.prototype.contentType):
        * inspector/front-end/ContentProviders.js:
        (WebInspector.ConcatenatedScriptsContentProvider.prototype.contentType):
        (WebInspector.CompilerSourceMappingContentProvider):
        (WebInspector.CompilerSourceMappingContentProvider.prototype.contentType):
        (WebInspector.CompilerSourceMappingContentProvider.prototype.requestContent):
        (WebInspector.StaticContentProvider):
        (WebInspector.StaticContentProvider.prototype.contentType):
        (WebInspector.StaticContentProvider.prototype.requestContent):
        * inspector/front-end/NavigatorView.js:
        (WebInspector.NavigatorTreeOutline.prototype.scriptTreeElements):
        (WebInspector.NavigatorSourceTreeElement):
        * inspector/front-end/NetworkRequest.js:
        (WebInspector.NetworkRequest.prototype.contentType):
        * inspector/front-end/Resource.js:
        (WebInspector.Resource.prototype.contentType):
        (WebInspector.Resource.prototype.canonicalMimeType):
        (WebInspector.ResourceRevision.prototype.contentType):
        * inspector/front-end/ResourceType.js:
        (WebInspector.ResourceType.prototype.toString):
        (WebInspector.ResourceType.prototype.canonicalMimeType):
        * inspector/front-end/Script.js:
        (WebInspector.Script.prototype.contentType):
        * inspector/front-end/ScriptSnippetModel.js:
        (WebInspector.SnippetContentProvider):
        * inspector/front-end/StylesPanel.js:
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype.contentType):
        * inspector/front-end/navigatorView.css:
        (.navigator-stylesheet-tree-item .icon):
        (.navigator-document-tree-item .icon):

2012-05-18  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r117556.
        http://trac.webkit.org/changeset/117556
        https://bugs.webkit.org/show_bug.cgi?id=86825

        Wrong fix. IE still adds 1px padding. We're missing that in
        textarea (Requested by rniwa on #webkit).

        * css/html.css:
        (input::-webkit-input-placeholder, isindex::-webkit-input-placeholder):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::createInnerTextStyle):

2012-05-17  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: remove File abstraction from the AdvancedSearchController, migrate it to UISourceCode.
        https://bugs.webkit.org/show_bug.cgi?id=86809

        Reviewed by Yury Semikhatsky.

        This change migrates AdvancedSearchController from "Object" to "UISourceCode".
        I don't see why we need this abstraction and as a side effect, it makes search
        across scripts work for styles.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/AdvancedSearchController.js:
        (WebInspector.SearchResult):
        (WebInspector.FileBasedSearchResultsPane.prototype._createAnchor):
        (WebInspector.FileBasedSearchResultsPane.prototype.addSearchResult):
        (WebInspector.FileBasedSearchResultsPane.prototype._appendSearchMatches):
        (WebInspector.FileBasedSearchResultsPane.prototype._regexMatchRanges):
        (WebInspector.FileBasedSearchResultsPane.SearchResult):
        * inspector/front-end/ScriptsSearchScope.js:
        (WebInspector.ScriptsSearchScope.prototype.createSearchResultsPane):
        * inspector/front-end/inspector.js:
        (WebInspector._registerShortcuts):

2012-05-17  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: add an option to show last N hidden children of node in heap profiler
        https://bugs.webkit.org/show_bug.cgi?id=86757

        Reviewed by Pavel Feldman.

        Renamed "Show next N" to "Show N before" and added "Show N after" button. Also
        when all 3 buttons would have equal effect there is now only "Show all N" button.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/ShowMoreDataGridNode.js:
        (WebInspector.ShowMoreDataGridNode):
        (WebInspector.ShowMoreDataGridNode.prototype._showLastChunk):
        (WebInspector.ShowMoreDataGridNode.prototype._updateLabels):
        (WebInspector.ShowMoreDataGridNode.prototype.createCells):

2012-05-17  Ryosuke Niwa  <rniwa@webkit.org>

        WebKit erroneously add 1px padding in input elements
        https://bugs.webkit.org/show_bug.cgi?id=86784

        Reviewed by Kent Tamura.

        Fixed the bug by removing the code that added left and right paddings in input elements.
        The code was added in r13567 to match a very old version of Internet Explorer but this quirk
        does not seem to exists in IE9 (both in quirks and standard modes).

        A lot of tests need to be rebaselined due to 1px difference inside input elements, and 2px
        differences for the width of input elements. (In some extreme cases, line breaking changed
        due to the width change).

        Test: fast/forms/input-textarea-padding-match.html

        * css/html.css:
        (input::-webkit-input-placeholder, isindex::-webkit-input-placeholder):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::createInnerTextStyle):

2012-05-18  Zalan Bujtas  <zbujtas@gmail.com>

        [Qt] Gesture tap highlighter needs to take overflow clip into account.
        https://bugs.webkit.org/show_bug.cgi?id=84989

        Reviewed by Kenneth Rohde Christiansen.

        Apply overflow clip on the focus ring if needed.

        Follow up patches are needed to address the following cases.

        [Qt] Gesture tap highlighter should take parent iframe's transform into account.
        https://bugs.webkit.org/show_bug.cgi?id=86645

        [Qt] Gesture tap highlighter needs to take frame clipping into account.
        https://bugs.webkit.org/show_bug.cgi?id=86646

        [Qt] Gesture tap highlighter's overflow clip is not always correct when
        nested enclosing containers have transforms.
        https://bugs.webkit.org/show_bug.cgi?id=86641

        Manual test: ManualTests/qt/tap-highlighting-overflow-hidden.html

        * page/GestureTapHighlighter.cpp:
        (WebCore::GestureTapHighlighter::pathForNodeHighlight):

2012-05-17  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] KURL::fileSystemPath() should strip the query of the uri
        https://bugs.webkit.org/show_bug.cgi?id=86721

        Reviewed by Martin Robinson.

        * platform/gtk/KURLGtk.cpp:
        (WebCore::KURL::fileSystemPath): Use the already parsed path to
        create the GFile instead of the whole URL string. The parsed path
        doesn't include neither the fragment (#) nor the query (?) parts.

2012-05-17  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Remove V8Proxy::deletionNotHandledByInterceptor()
        https://bugs.webkit.org/show_bug.cgi?id=86803

        Reviewed by Dimitri Glazkov.

        V8Proxy::deletionNotHandledByInterceptor() is used by V8StorageCustom.cpp
        only, just in order to return v8::Handle<v8::Boolean>(). In such cases,
        other custom bindings are hard-coding 'return v8::Handle<v8::Boolean>()'.
        Thus we can hard-code 'return v8::Handle<v8::Boolean>()' in V8StorageCustom.cpp
        too, and remove V8Proxy::deletionNotHandledByInterceptor().

        No tests. No change in behavior.

        * bindings/v8/V8Proxy.h:
        * bindings/v8/custom/V8StorageCustom.cpp:
        (WebCore::storageDeleter):

2012-05-17  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: speed-up markQueriableHeapObjects function.
        https://bugs.webkit.org/show_bug.cgi?id=86732

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype._flagsOfNode):
        (WebInspector.HeapSnapshot.prototype._markDetachedDOMTreeNodes):
        (WebInspector.HeapSnapshot.prototype._markQueriableHeapObjects):
        (WebInspector.HeapSnapshot.prototype._calculateFlags):

2012-05-15  Kinuko Yasuda  <kinuko@chromium.org>

        Some Spelling Mistakes Result in Compile Errors with ENABLE(FILE_SYSTEM) in LocalFileSystem.cpp
        https://bugs.webkit.org/show_bug.cgi?id=86103

        Reviewed by Rob Buis.

        Added build fixes and some (limited) common implementation for non-chromium ports.

        No new tests as this should have no functionality changes.

        * Modules/filesystem/DOMFileSystemBase.cpp:
        (WebCore::DOMFileSystemBase::isValidType): Added common implementation for non-chromium ports.
        (WebCore::DOMFileSystemBase::crackFileSystemURL): Ditto.
        (WebCore::DOMFileSystemBase::supportsToURL): Ditto.
        (WebCore::DOMFileSystemBase::createFileSystemURL): Ditto.
        * Modules/filesystem/LocalFileSystem.cpp:
        (WebCore::LocalFileSystem::readFileSystem): Fixed.
        (WebCore::LocalFileSystem::requestFileSystem): Fixed.
        * platform/blackberry/AsyncFileSystemBlackBerry.cpp:
        (WebCore::AsyncFileSystem::openFileSystem): Fixed.
        * platform/gtk/AsyncFileSystemGtk.cpp:
        (WebCore::AsyncFileSystem::openFileSystem): Fixed.

2012-05-17  Wei James  <james.wei@intel.com>

        AudioBufferSourceNode and MediaElementAudioSourceNode should support multi-channel > stereo
        https://bugs.webkit.org/show_bug.cgi?id=75119

        Reviewed by Chris Rogers.

        As multiple channel support in AudioBus and other places is already
        implemented, the check can be removed here.  

        * Modules/webaudio/MediaElementAudioSourceNode.cpp:
        (WebCore::MediaElementAudioSourceNode::setFormat):

2012-05-17  Dan Bernstein  <mitz@apple.com>

        <rdar://problem/11419933> Problems with flipped writing modes and compositing
        https://bugs.webkit.org/show_bug.cgi?id=86032

        Reviewed by Anders Carlsson.

        Test: compositing/bounds-in-flipped-writing-mode.html

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::calculateLayerBounds): Apply a writing-mode flip to the bounding box
        if needed.

2012-05-17  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Remove V8Proxy::throwError(const char*, v8::Isolate* = 0)
        https://bugs.webkit.org/show_bug.cgi?id=86794

        Reviewed by Adam Barth.

        As commented here (https://bugs.webkit.org/show_bug.cgi?id=84074#c5),
        I am refactoring a series of confusing throwError()s.
        This patch removes V8Proxy::throwError(const char*, v8::Isolate* = 0).

        No tests. No change in behavior.

        * bindings/v8/V8Utilities.cpp:
        (WebCore::extractTransferables):
        (WebCore::getMessagePortArray):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArrayWithArrayBufferArgument):
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8AudioBufferSourceNodeCustom.cpp:
        (WebCore::V8AudioBufferSourceNode::bufferAccessorSetter):
        * bindings/v8/custom/V8ClipboardCustom.cpp:
        (WebCore::V8Clipboard::setDragImageCallback):
        * bindings/v8/custom/V8HTMLDocumentCustom.cpp:
        (WebCore::V8HTMLDocument::openCallback):
        * bindings/v8/custom/V8HTMLInputElementCustom.cpp:
        (WebCore::V8HTMLInputElement::selectionStartAccessorGetter):
        (WebCore::V8HTMLInputElement::selectionStartAccessorSetter):
        (WebCore::V8HTMLInputElement::selectionEndAccessorGetter):
        (WebCore::V8HTMLInputElement::selectionEndAccessorSetter):
        (WebCore::V8HTMLInputElement::selectionDirectionAccessorGetter):
        (WebCore::V8HTMLInputElement::selectionDirectionAccessorSetter):
        (WebCore::V8HTMLInputElement::setSelectionRangeCallback):
        * bindings/v8/custom/V8HTMLMediaElementCustom.cpp:
        (WebCore::V8HTMLMediaElement::controllerAccessorSetter):
        * bindings/v8/custom/V8InjectedScriptHostCustom.cpp:
        (WebCore::V8InjectedScriptHost::inspectedObjectCallback):

2012-05-17  Dana Jansens  <danakj@chromium.org>

        [chromium] Scale all compositor output by the defaultDeviceScaleFactor
        https://bugs.webkit.org/show_bug.cgi?id=86051

        Reviewed by James Robinson.

        On initialization, give the defaultDeviceScaleFactor to the compositor
        to have it scale all output from WebCore's layout size to physical
        pixels. This allows us to scale up to high-dpi devices without using
        fixed-layout, so we can leave the WebCore frame size in layout pixels,
        while drawing the frame into a larger physical pixel size.

        CCLayerTreeHost becomes aware of the deviceScaleFactor and scales all
        output by this factor by scaling the viewport and all drawing
        transforms.

        Anything that works in physical pixels (content space), uses the
        deviceViewportSize() in place of the viewportSize(), since when
        deviceScaleFactor != 1 in CCLayerTreeHost, the WebCore viewport
        is no longer physical pixels.

        Scroll positions are in layout pixels, and must be scaled to/from
        content space within the compositor.

        Unit tests: CCLayerTreeHostTestDeviceScaleFactorScalesViewportAndLayers

        * platform/graphics/chromium/LayerRendererChromium.h:
        (LayerRendererChromiumClient):
        (WebCore::LayerRendererChromium::viewportSize):
        (WebCore::LayerRendererChromium::viewportWidth):
        (WebCore::LayerRendererChromium::viewportHeight):
        (LayerRendererChromium):
        * platform/graphics/chromium/cc/CCLayerTreeHost.cpp:
        (WebCore::CCLayerTreeHost::initializeLayerRenderer):
        (WebCore::CCLayerTreeHost::setViewportSize):
        (WebCore::CCLayerTreeHost::updateLayers):
        (WebCore::CCLayerTreeHost::paintLayerContents):
        * platform/graphics/chromium/cc/CCLayerTreeHost.h:
        (WebCore::CCSettings::CCSettings):
        (CCSettings):
        (CCLayerTreeHost):
        (WebCore::CCLayerTreeHost::deviceViewportSize):
        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.cpp:
        (WebCore::CCLayerTreeHostImpl::calculateRenderSurfaceLayerList):
        (WebCore::CCLayerTreeHostImpl::calculateRenderPasses):
        (WebCore::CCLayerTreeHostImpl::setViewportSize):
        (WebCore::CCLayerTreeHostImpl::updateMaxScrollPosition):
        (WebCore::CCLayerTreeHostImpl::scrollBegin):
        (WebCore::CCLayerTreeHostImpl::computePinchZoomDeltas):
        * platform/graphics/chromium/cc/CCLayerTreeHostImpl.h:
        (WebCore::CCLayerTreeHostImpl::viewportSize):
        (CCLayerTreeHostImpl):

2012-05-17  Hayato Ito  <hayato@chromium.org>

        [Shadow DOM] Add an assertion to make sure a visited node is not an active insertion point.
        https://bugs.webkit.org/show_bug.cgi?id=86708

        Reviewed by Eric Seidel.

        Since InsertionPoint now has isActive() member function,
        we can add an assertion to ComposedShadowTreeWalker::assertPrecondition()
        using that function.

        No new tests, no change in behavior.

        * dom/ComposedShadowTreeWalker.h:
        (WebCore::ComposedShadowTreeWalker::assertPrecondition):

2012-05-17  Ami Fischman  <fischman@chromium.org>

        [Chromium] Store HTTP version in WebURLResponse
        https://bugs.webkit.org/show_bug.cgi?id=86522

        Reviewed by Adam Barth.

        No new tests; this isn't exposed to the web platform.

        * platform/chromium/support/WebURLResponse.cpp:
        (WebKit::WebURLResponse::httpVersion):
        (WebKit):
        (WebKit::WebURLResponse::setHTTPVersion):
        * platform/network/chromium/ResourceResponse.h:
        (ResourceResponse):
        (WebCore::ResourceResponse::ResourceResponse):
        (WebCore::ResourceResponse::httpVersion):
        (WebCore::ResourceResponse::setHTTPVersion):

2012-05-17  Levi Weintraub  <leviw@chromium.org>

        Floor y coordinate in Chromium's GraphicsContext::drawLineForText to avoid anti-aliasing
        https://bugs.webkit.org/show_bug.cgi?id=86775

        Reviewed by Eric Seidel.

        Despite operating in floats, we always want to draw lines for text aligned to pixel boundaries.
        There are similar functions to do this in other platforms, but to get proper results, we only
        need to floor the y value, as we always draw these lines horizontally.

        No tests. No change in behavior prior to sub-pixel change.

        * platform/graphics/skia/GraphicsContextSkia.cpp:
        (WebCore::GraphicsContext::drawLineForText):

2012-05-17  Michael Moss  <mmoss@chromium.org>

        Linux amd64 platform reported as i686
        https://bugs.webkit.org/show_bug.cgi?id=86778
        http://code.google.com/p/chromium/issues/detail?id=128167

        Remove the old hard-coded gyp define and allow the more recent (but
        still quite old) code in Source/WebCore/page/NavigatorBase.cpp to take
        precedence and detect this at runtime.

        Reviewed by Tony Chang.

        No new tests because it's hardware dependent.

        * WebCore.gyp/WebCore.gyp:

2012-05-17  Vangelis Kokkevis  <vangelis@chromium.org>

        [chromium] Expose layer tiling size options to WebSettings.
        https://bugs.webkit.org/show_bug.cgi?id=86425

        Removing hardcoded tile size and max untiled layer size from TiledLayerChromium
        and instead have the values passed in via the LTH CCSettings. This will allow
        different compositor instances to adjust tiling parameters as needed and makes
        it possible to set the values via command line arguments.

        Reviewed by Adrienne Walker.

        * platform/graphics/chromium/TiledLayerChromium.cpp:
        (WebCore::TiledLayerChromium::TiledLayerChromium):
        (WebCore::TiledLayerChromium::updateTileSizeAndTilingOption):
        Made some additional adjustments to the single-tile heuristic
        to make it work better with arbitrary sizes while still avoiding
        to create unreasonably large layers.
        * platform/graphics/chromium/cc/CCLayerTreeHost.cpp:
        (WebCore::CCLayerTreeHost::initializeLayerRenderer):
        * platform/graphics/chromium/cc/CCLayerTreeHost.h:
        (WebCore::CCSettings::CCSettings):
        (CCSettings):

2012-05-17  Sudarsana Nagineni  <sudarsana.nagineni@linux.intel.com>

        Memory leak in NetworkInfoClient
        https://bugs.webkit.org/show_bug.cgi?id=86603

        Reviewed by Adam Barth.

        Fix a memory leak in NetworkInfoClient by using OwnPtr and
        change the class not to inherite from RefCounted.

        * Modules/networkinfo/NetworkInfoClient.h:

2012-05-17  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Remove IDBIndex.storeName
        https://bugs.webkit.org/show_bug.cgi?id=86676

        Reviewed by Tony Chang.

        Older versions of the IDB spec exposed IDBIndex.storeName. While it's been removed
        from the IDL, the additional storage/plumbing are unnecessary clutter. Nuke it!

        No new tests - no functional changes.

        * Modules/indexeddb/IDBIndexBackendImpl.cpp:
        (WebCore::IDBIndexBackendImpl::IDBIndexBackendImpl): Remove storeName parameter, and
        const declaration on object store param. The former was used to get a non-const pointer
        via indirection in openCursorInternal.
        (WebCore::IDBIndexBackendImpl::openCursorInternal): Use store pointer directly, don't
        look it up by name in the transaction.
        * Modules/indexeddb/IDBIndexBackendImpl.h:
        (WebCore::IDBIndexBackendImpl::create): Remove storeName parameters.
        (IDBIndexBackendImpl): Remove storeName() method.
        * Modules/indexeddb/IDBIndexBackendInterface.h:
        (IDBIndexBackendInterface): Remove storeName parameter.
        * Modules/indexeddb/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::createIndex): Remove storeName parameter.
        (WebCore::IDBObjectStoreBackendImpl::loadIndexes): Remove storeName parameter.

2012-05-17  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Implement IDBObjectStore.autoIncrement
        https://bugs.webkit.org/show_bug.cgi?id=86662

        Reviewed by Dimitri Glazkov.

        Simple boolean accessor defined in the IDB spec, which reflects the
        object store's internal autoIncrement flag.

        Test: storage/indexeddb/objectstore-basics.html

        * Modules/indexeddb/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::autoIncrement): Forward call to back end.
        (WebCore):
        * Modules/indexeddb/IDBObjectStore.h: Expose attribute as method.
        (IDBObjectStore):
        * Modules/indexeddb/IDBObjectStore.idl: Define the attribute.
        * Modules/indexeddb/IDBObjectStoreBackendInterface.h: Expose in interface.
        (IDBObjectStoreBackendInterface):

2012-05-17  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Remove throwError("message", XXXError) from CodeGeneratorV8.pm
        https://bugs.webkit.org/show_bug.cgi?id=86744

        Reviewed by Adam Barth.

        As commented in https://bugs.webkit.org/show_bug.cgi?id=84074#c5,
        I am refactoring a series of confusing throwError()s.

        This patch removes throwError("message", XXXError) in CodeGeneratorV8.pm
        and replaces it with throwTypeError("message") or throwError(XXXError, "message").

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (GenerateParametersCheck):
        (GenerateConstructorCallback):
        (GenerateEventConstructorCallback):
        (GenerateNamedConstructorCallback):
        * bindings/scripts/test/V8/V8TestEventConstructor.cpp:
        (WebCore::V8TestEventConstructor::constructorCallback):
        * bindings/scripts/test/V8/V8TestInterface.cpp:
        (WebCore::V8TestInterface::constructorCallback):
        * bindings/scripts/test/V8/V8TestNamedConstructor.cpp:
        (WebCore::V8TestNamedConstructorConstructorCallback):
        * bindings/scripts/test/V8/V8TestNode.cpp:
        (WebCore::V8TestNode::constructorCallback):
        * bindings/scripts/test/V8/V8TestObj.cpp:
        (WebCore::TestObjV8Internal::optionsObjectCallback):
        (WebCore::V8TestObj::constructorCallback):
        * bindings/scripts/test/V8/V8TestSerializedScriptValueInterface.cpp:
        (WebCore::TestSerializedScriptValueInterfaceV8Internal::acceptTransferListCallback):
        (WebCore::TestSerializedScriptValueInterfaceV8Internal::multiTransferListCallback):
        (WebCore::V8TestSerializedScriptValueInterface::constructorCallback):

2012-05-17  Gregg Tavares  <gman@google.com>

        Add more descriptive warnings for framebuffer incomplete conditions
        https://bugs.webkit.org/show_bug.cgi?id=86774

        Reviewed by Kenneth Russell.

        No new tests as there is no new functionality

        * html/canvas/WebGLFramebuffer.cpp:
        (WebCore::WebGLFramebuffer::checkStatus):
        (WebCore::WebGLFramebuffer::onAccess):
        (WebCore::WebGLFramebuffer::initializeRenderbuffers):
        * html/canvas/WebGLFramebuffer.h:
        (WebGLFramebuffer):
        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore):
        (WebCore::WebGLRenderingContext::checkFramebufferStatus):
        (WebCore::WebGLRenderingContext::clear):
        (WebCore::WebGLRenderingContext::copyTexImage2D):
        (WebCore::WebGLRenderingContext::copyTexSubImage2D):
        (WebCore::WebGLRenderingContext::drawArrays):
        (WebCore::WebGLRenderingContext::drawElements):
        (WebCore::WebGLRenderingContext::readPixels):
        (WebCore::WebGLRenderingContext::printGLWarningToConsole):
        * html/canvas/WebGLRenderingContext.h:

2012-05-17  Oliver Hunt  <oliver@apple.com>

        Endeavour to make the windows test bot actually able to run tests.
        https://bugs.webkit.org/show_bug.cgi?id=86772

        Reviewed by Sam Weinig.

        Use WEBKIT_EXPORT to get correct export behaviour on windows, rather than
        relying on the .def files.

        * bindings/js/JSDOMGlobalObject.h:
        (JSDOMGlobalObject):
        * bindings/scripts/CodeGeneratorJS.pm:
        (GenerateHeader):

2012-05-17  Beth Dakin  <bdakin@apple.com>

        https://bugs.webkit.org/show_bug.cgi?id=86266
        r112643/r116697 break Webview form input fields
        -and corresponding-
        <rdar://problem/11400430>

        Reviewed by Dan Bernstein.

        There is a recent history of changes in this are that seem worth documenting. 
        First was the change to switch to using NSTextFieldCell to draw text fields: 
        http://trac.webkit.org/changeset/104240

        That led to problems because of the clear background that I thought at the time 
        were specific to MountainLion. To fix that, I made this change:
        http://trac.webkit.org/changeset/110480

        But that change resulted in styled text fields getting an un-themed border, which 
        led to this change on the branch: http://trac.webkit.org/changeset/112643 and a 
        change on TOT that was identical for Lion and SnowLeopard but introduced new 
        behavior for MountainLion: http://trac.webkit.org/changeset/116697

        And that brings us to this bug, where it turns out the clear background is a 
        problem on Lion and SnowLeopard too. This patch fixes the bug by using the 
        original WebCoreSystemInterface function to paint all text fields on Lion and 
        SnowLeopard that are styled. This is what we used to paint all text fields before 
        r104240, which is the first change listed above. Un-styled text fields will still 
        use NSTextFieldCell on these platforms, but with a hardcoded white background. 
        * rendering/RenderThemeMac.h:
        (RenderThemeMac):
        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintTextField):
        (WebCore::RenderThemeMac::textField):

2012-05-15  Andreas Kling  <kling@webkit.org>

        IconDatabase: Move icon retain/release off of the main thread.
        <http://webkit.org/b/85799>
        <rdar://problem/9507113>

        Reviewed by Brady Eidson.

        Batch up the retain/release operations and execute them as part of the sync thread loop.
        The batch execution is guarded by a new mutex (m_urlsToRetainOrReleaseLock.)
        This avoids blocking the main thread on m_urlAndIconLock for basic retain/release.

        There is one exception; if there are pending retain/release operations in synchronousIconForPageURL,
        it will acquire the lock and flush the operations.

        There should be no behavior change, this is only meant to reduce lock contention.

        * loader/icon/PageURLRecord.h:
        (WebCore::PageURLRecord::retain):
        (WebCore::PageURLRecord::release):

            Added a 'count' argument to these so we can batch up the operations in IconDatabase.

        * loader/icon/IconDatabase.h:
        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::performScheduleOrDeferSyncTimer):
        (WebCore::IconDatabase::performScheduleOrDeferSyncTimerOnMainThread):
        (WebCore::IconDatabase::scheduleOrDeferSyncTimer):

            Perform the the timer scheduling on the main thread as it can be done on a different
            thread by way of retainIconForPageURL or releaseIconForPageURL.

        (WebCore::IconDatabase::synchronousIconForPageURL):
        (WebCore::IconDatabase::retainIconForPageURL):
        (WebCore::IconDatabase::performRetainIconForPageURL):
        (WebCore::IconDatabase::releaseIconForPageURL):
        (WebCore::IconDatabase::performReleaseIconForPageURL):
        (WebCore::IconDatabase::retainedPageURLCount):
        (WebCore::IconDatabase::IconDatabase):
        (WebCore::IconDatabase::performURLImport):
        (WebCore::IconDatabase::syncThreadMainLoop):
        (WebCore::IconDatabase::performPendingRetainAndReleaseOperations):

2012-05-17  Julien Chaffraix  <jchaffraix@webkit.org>

        Kill RenderLayer::relativePositionOffset(LayoutUnit& relX, LayoutUnit& relY) and cleanup RenderInline::clippedOverflowRectForRepaint
        https://bugs.webkit.org/show_bug.cgi?id=86551

        Reviewed by Abhishek Arya.

        No test since there is no expected change in behavior.

        * rendering/RenderInline.cpp:
        (WebCore::RenderInline::clippedOverflowRectForRepaint):
        Changed the function to use LayoutRect arithmetics instead of calculating
        top / left manually. While at it, improved the naming, removed some local
        variables and removed an unneeded style() NULL-check.

        * rendering/RenderLayer.h: Removed the function.

2012-05-17  Rob Buis  <rwlbuis@webkit.org>

        [BlackBerry] Fix linking errors
        https://bugs.webkit.org/show_bug.cgi?id=86768

        Reviewed by Antonio Gomes.

        Add some missing stubs so we can link again.

        * platform/blackberry/ContextMenuBlackBerry.cpp:
        (WebCore::ContextMenu::itemCount):
        (WebCore):
        * platform/blackberry/PlatformScreenBlackBerry.cpp:
        (WebCore::screenHorizontalDPI):
        (WebCore):
        (WebCore::screenVerticalDPI):

2012-05-17  Emil A Eklund  <eae@chromium.org>

        Fix rounding in paintSelection
        https://bugs.webkit.org/show_bug.cgi?id=86693

        Reviewed by Eric Seidel.

        Break out rounding logic from InlineTextBox::paintSelection into separate
        function and use it for all the EllipsisBox paintSelection implementation
        and selection gap calculation. This ensures that selections are painted
        without gaps and overlaps once we turn on subpixel layout.

        No new tests, covered by existing tests in editing/selection and
        editing/style.

        * rendering/EllipsisBox.cpp:
        (WebCore::EllipsisBox::paintSelection):
        * rendering/InlineTextBox.cpp:
        (WebCore::alignSelectionRectToDevicePixels):
        (WebCore):
        (WebCore::InlineTextBox::paintSelection):
        * rendering/InlineTextBox.h:
        (WebCore):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::logicalLeftSelectionGap):
        (WebCore::RenderBlock::logicalRightSelectionGap):

2012-05-17  Michal Mocny  <mmocny@google.com>

        [chromium] Limiting render surface texture manager memory to 0 when contentsMemoryUseBytes is large.
        https://bugs.webkit.org/show_bug.cgi?id=86764

        Reviewed by Adrienne Walker.

        * platform/graphics/chromium/LayerRendererChromium.cpp:
        (WebCore::LayerRendererChromium::beginDrawingFrame):

2012-05-17  Dan Bernstein  <mitz@apple.com>

        In vertical writing modes, pagination may split a line after a block shifts
        https://bugs.webkit.org/show_bug.cgi?id=86763

        Reviewed by Sam Weinig.

        Test: fast/multicol/pageLogicalOffset-vertical.html

        LayoutState::pageLogicalOffset() was returning bogus results in vertical writing modes,
        because it was always using physical heights. Changed it to take a RenderBox and use its
        writing mode to choose between heights and widths.

        * rendering/LayoutState.cpp:
        (WebCore::LayoutState::pageLogicalOffset):
        (WebCore::LayoutState::addForcedColumnBreak):
        * rendering/LayoutState.h:
        (LayoutState):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::layoutBlock):
        (WebCore::RenderBlock::markForPaginationRelayoutIfNeeded):
        (WebCore::RenderBlock::layoutColumns):
        (WebCore::RenderBlock::applyBeforeBreak):
        (WebCore::RenderBlock::applyAfterBreak):
        * rendering/RenderDeprecatedFlexibleBox.cpp:
        (WebCore::RenderDeprecatedFlexibleBox::layoutBlock):
        * rendering/RenderTable.cpp:
        (WebCore::RenderTable::layout):
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::layout):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::layoutRows):

2012-05-17  Abhishek Arya  <inferno@chromium.org>

        Move run-in handling to addChild, instead of in layout.
        https://bugs.webkit.org/show_bug.cgi?id=86387

        Reviewed by Julien Chaffraix.

        Tests: fast/runin/insert-before-run-in.html
               fast/runin/run-in-after-run-in.html
               fast/runin/run-in-parent-add-child.html
               fast/runin/run-in-parent-block-child-add-and-intrude.html
               fast/runin/run-in-parent-block-child-add.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::addChildIgnoringAnonymousColumnBlocks): handle run-ins here
        instead of layout. We do run-in handling when we see a new child with run-in display
        or add a new block whose previous sibling is run-in.
        (WebCore::RenderBlock::makeChildrenNonInline): if we will have block children, need
        to move run-in back to its original position.
        (WebCore::RenderBlock::handleSpecialChild): no longer need to handle run-ins during layout.
        (WebCore::destroyRunIn): helper to destroy a block or inline run-in.
        (WebCore):
        (WebCore::RenderBlock::createReplacementRunIn): helper to create the new replacement run-in.
        For moveRunInUnderSiblingBlockIfNeeded, it will be used to create a new inline run-in
        that goes into the next sibling block. For moveRunInToOriginalPosition, it creates a new
        block run-in that goes back to where it came from.
        (WebCore::RenderBlock::moveRunInUnderSiblingBlockIfNeeded): almost same as previous
        handleRunInChild function, but with the return type removed. Also, we don't allow
        a run-in to intrude into a block that already has a run-in.
        (WebCore::RenderBlock::moveRunInToOriginalPosition): moves run-in back to where it came from.
        * rendering/RenderBlock.h:
        (RenderBlock):
        * rendering/RenderBox.cpp:
        * rendering/RenderBox.h:
        (RenderBox):
        * rendering/RenderBoxModelObject.cpp: move all moveChild* functions from RenderBox, since
        they can now be used to move children of inlines.
        (WebCore::RenderBoxModelObject::moveChildTo): same.
        (WebCore):
        (WebCore::RenderBoxModelObject::moveChildrenTo): same.
        * rendering/RenderBoxModelObject.h:
        (RenderBoxModelObject):
        (WebCore::RenderBoxModelObject::moveChildTo): same.
        (WebCore::RenderBoxModelObject::moveAllChildrenTo): same.
        (WebCore::RenderBoxModelObject::moveChildrenTo): same.

2012-05-17  Mikhail Naganov  <mnaganov@chromium.org>

        Support Copy ... actions for the Web Inspector remote debugging mode.
        https://bugs.webkit.org/show_bug.cgi?id=86621

        Reviewed by Pavel Feldman.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/InspectorFrontendHostStub.js:
        (.WebInspector.InspectorFrontendHostStub):
        (.WebInspector.InspectorFrontendHostStub.prototype.documentCopy):
        (.WebInspector.InspectorFrontendHostStub.prototype.copyText):
        (.WebInspector.clipboardAccessDeniedMessage):
        (.WebInspector.ClipboardAccessDeniedScreen):
        * inspector/front-end/inspector.html:
        * inspector/front-end/inspector.js:
        (WebInspector.documentCopy):
        (WebInspector.documentCopyEventFired):

2012-05-02  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: table-height-algorithm-023 and -024 fail
        https://bugs.webkit.org/show_bug.cgi?id=85405

        Reviewed by Eric Seidel.

        Treat vertical-align: [length] the same as vertical-align: baseline.

        Tests: css2.1/20110323/table-height-algorithm-023.htm
               css2.1/20110323/table-height-algorithm-024.htm
               fast/table/mozilla-bug10296-vertical-align-1.html
               fast/table/mozilla-bug10296-vertical-align-2.html

        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::calcRowLogicalHeight):
        (WebCore::RenderTableSection::layoutRows):

2012-05-17  Emil A Eklund  <eae@chromium.org>

        Fix rounding in RenderFlowThread::paintIntoRegion
        https://bugs.webkit.org/show_bug.cgi?id=86695

        Reviewed by Eric Seidel.

        Fix rounding of offset in paintIntoRegion to ensure that we paint on
        device pixel boundaries.

        Covered by existing tests in fast/regions.

        * platform/graphics/FractionalLayoutPoint.h:
        (WebCore::roundedIntPoint):
        Add roundedIntPoint(FractionalLayoutSize) function.
        (WebCore):
        * rendering/RenderFlowThread.cpp:
        (WebCore::RenderFlowThread::paintIntoRegion):

2012-05-17  Andreas Kling  <kling@webkit.org>

        Parser: Avoid unnecessary ref count churn in token constructors.
        <http://webkit.org/b/86667>

        Reviewed by Antti Koivisto.

        Pass AtomicString by const reference to avoid useless ref count churn
        in AtomicHTMLToken() and AtomicXMLToken().

        * html/parser/HTMLToken.h:
        (WebCore::AtomicHTMLToken::AtomicHTMLToken):
        * xml/parser/MarkupTokenBase.h:
        (WebCore::AtomicMarkupTokenBase::AtomicMarkupTokenBase):
        * xml/parser/XMLToken.h:
        (WebCore::AtomicXMLToken::AtomicXMLToken):

2012-05-16  Andreas Kling  <kling@webkit.org>

        Make PluginInfoStore properly thread-safe.
        <http://webkit.org/b/86648>
        <rdar://problem/11451178>

        Reviewed by Darin Adler.

        * plugins/PluginData.h:
        (WebCore::MimeClassInfo::isolatedCopy):
        (WebCore::PluginInfo::isolatedCopy):

2012-05-17  Hironori Bono  <hbono@chromium.org>

        [Refactoring] Move platform-specific code in Editor::respondToChangedSelection to the WebKit layer
        https://bugs.webkit.org/show_bug.cgi?id=86591

        Reviewed by Ryosuke Niwa.

        This change adds a TextCheckerClient::shouldEraseMarkersAfterChangeSelection
        function to remove platform-specific code from Editor::respondToChangedSelection
        function.

        No new tests, no change in behavior.

        * editing/Editor.cpp:
        (WebCore::Editor::respondToChangedSelection):
        * loader/EmptyClients.h:
        (WebCore::EmptyTextCheckerClient::shouldEraseMarkersAfterChangeSelection):
        * platform/text/TextCheckerClient.h:
        (TextCheckerClient):

2012-05-11  James Robinson  <jamesr@chromium.org>

        [chromium] Convert GraphicsLayerChromium to use WebLayer types
        https://bugs.webkit.org/show_bug.cgi?id=86269

        Reviewed by Adrienne Walker.

        This converts GraphicsLayerChromium over to use WebLayer and WebContentLayer. The conversion is not completely
        as the Web*Layer APIs are not yet quite complete enough to use everywhere, and the PlatformLayer typedef is not
        changed in this patch. The places where we have to punch out through API layer are marked by
        unwrap<*LayerChromium>() calls and FIXME's in the Web*Layer.h files.  There aren't many.

        Refactor only, existing tests apply.

        * platform/chromium/support/WebTransformationMatrix.cpp:
        (WebKit):
        (WebKit::WebTransformationMatrix::reset):
        (WebKit::WebTransformationMatrix::projectPoint):
        * platform/graphics/chromium/GraphicsLayerChromium.cpp:
        (WebCore::GraphicsLayerChromium::GraphicsLayerChromium):
        (WebCore::GraphicsLayerChromium::willBeDestroyed):
        (WebCore::GraphicsLayerChromium::setName):
        (WebCore::GraphicsLayerChromium::updateNames):
        (WebCore::GraphicsLayerChromium::removeFromParent):
        (WebCore::GraphicsLayerChromium::setSize):
        (WebCore::GraphicsLayerChromium::setTransform):
        (WebCore::GraphicsLayerChromium::setBackgroundColor):
        (WebCore::GraphicsLayerChromium::clearBackgroundColor):
        (WebCore::GraphicsLayerChromium::setContentsOpaque):
        (WebCore::GraphicsLayerChromium::setFilters):
        (WebCore::GraphicsLayerChromium::setMaskLayer):
        (WebCore::GraphicsLayerChromium::setBackfaceVisibility):
        (WebCore::GraphicsLayerChromium::setOpacity):
        (WebCore::GraphicsLayerChromium::setReplicatedByLayer):
        (WebCore::GraphicsLayerChromium::setContentsNeedsDisplay):
        (WebCore::GraphicsLayerChromium::setNeedsDisplay):
        (WebCore::GraphicsLayerChromium::setNeedsDisplayInRect):
        (WebCore::GraphicsLayerChromium::setContentsToImage):
        (WebCore::GraphicsLayerChromium::setContentsToCanvas):
        (WebCore::GraphicsLayerChromium::addAnimation):
        (WebCore::GraphicsLayerChromium::pauseAnimation):
        (WebCore::GraphicsLayerChromium::removeAnimation):
        (WebCore::GraphicsLayerChromium::suspendAnimations):
        (WebCore::GraphicsLayerChromium::resumeAnimations):
        (WebCore::GraphicsLayerChromium::setContentsToMedia):
        (WebCore::GraphicsLayerChromium::hostLayerForChildren):
        (WebCore::GraphicsLayerChromium::layerForParent):
        (WebCore::GraphicsLayerChromium::platformLayer):
        (WebCore::GraphicsLayerChromium::setDebugBackgroundColor):
        (WebCore::GraphicsLayerChromium::setDebugBorder):
        (WebCore::GraphicsLayerChromium::updateChildList):
        (WebCore::GraphicsLayerChromium::updateLayerPosition):
        (WebCore::GraphicsLayerChromium::updateLayerSize):
        (WebCore::GraphicsLayerChromium::updateAnchorPoint):
        (WebCore::GraphicsLayerChromium::updateTransform):
        (WebCore::GraphicsLayerChromium::updateChildrenTransform):
        (WebCore::GraphicsLayerChromium::updateMasksToBounds):
        (WebCore::GraphicsLayerChromium::updateLayerPreserves3D):
        (WebCore::GraphicsLayerChromium::updateLayerIsDrawable):
        (WebCore::GraphicsLayerChromium::updateLayerBackgroundColor):
        (WebCore::GraphicsLayerChromium::updateContentsRect):
        (WebCore::GraphicsLayerChromium::updateContentsScale):
        (WebCore::GraphicsLayerChromium::setupContentsLayer):
        * platform/graphics/chromium/GraphicsLayerChromium.h:
        (WebCore::GraphicsLayerChromium::hasContentsLayer):
        (WebCore::GraphicsLayerChromium::contentsLayer):
        (WebCore::GraphicsLayerChromium::primaryLayer):
        (GraphicsLayerChromium):
        * platform/graphics/chromium/LayerChromium.h:
        (LayerChromium):

2012-05-17  Tony Chang  <tony@chromium.org>

        remove bit rotted comment about css properties
        https://bugs.webkit.org/show_bug.cgi?id=86750

        Reviewed by Alexis Menard.

        It's not clear to me what the first block was even referring to.
        Aural doesn't seem to exist anymore. It might be worth keeping,
        "All the CSS properties are not supported by the renderer at the
        moment.", but it seems obvious to me.

        No new tests, just removing a comment.

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):

2012-05-17  Adrienne Walker  <enne@google.com>

        Insert source file and line number for v8 function calls into tracing
        https://bugs.webkit.org/show_bug.cgi?id=84613

        Reviewed by Kentaro Hara.

        The trace for v8 function calls doesn't include any information about
        what function is being called. Pass this information along so it can
        be less opaque.

        * bindings/v8/V8Proxy.cpp:
        (WebCore::resourceInfo):
        (WebCore):
        (WebCore::resourceString):
        (WebCore::V8Proxy::instrumentedCallFunction):
        * platform/chromium/TraceEvent.h:
        (WebCore::TraceEvent::TraceStringWithCopy::TraceStringWithCopy):

2012-05-17  Caio Marcelo de Oliveira Filho  <caio.oliveira@openbossa.org>

        [Qt] REGRESSION(101967): It made editing/style/iframe-onload-crash-mac.html timeout
        https://bugs.webkit.org/show_bug.cgi?id=73802

        Reviewed by Ryosuke Niwa.

        Timeout was caused by an infinite in the outer loop of
        pushDownInlineStyleAroundNode(). The outer loop variable 'current' should point at the
        node containing 'targetNode'. The inner loop traverse the children of 'current'
        and discover the children that contains 'targetNode'.

        However, before the inner loop, we call removeInlineStyleFromElement() that can
        potentially remove the 'current' node from the tree, moving its children to
        'current' former parent. For that reason 'child' and 'lastChild' are collected
        before this call.

        The tricky part is that changing the 'current' children parent, we might trigger
        further side-effects, that can remove either 'child' or 'lastChild' from the tree
        too. The infinite loop was due to 'child' being off the document, so it's
        nextSibling() is 0, and we go another run of outer loop without changing
        'current' because the 'targetNode' wasn't in the first child that inner loop
        couldn't reach.

        When testing Qt on Mac, there was also a crash in RenderTextControl when the font
        family was empty, this patch fixes it as well.

        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::pushDownInlineStyleAroundNode): Use NodeVector
        instead of relying on first/last child being valid after
        removeInlineStyleFromElement() is called. Skip the child if it has no parent,
        this is an indication that it was removed from the tree.

        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::hasValidAvgCharWidth): Empty AtomicStrings aren't
        supported by HashSet, so we have to early return in this case.

2012-05-17  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: implement Go To selector for stylesheet files.
        https://bugs.webkit.org/show_bug.cgi?id=86751

        Reviewed by Yury Semikhatsky.

        StyleSheetOutlineDialog is introduced.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/FilteredItemSelectionDialog.js:
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._createDebugToolbar):
        (WebInspector.ScriptsPanel.prototype._createButtonAndRegisterShortcuts):
        (WebInspector.ScriptsPanel.prototype._showOutlineDialog):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSheetOutlineDialog):
        (WebInspector.StyleSheetOutlineDialog.show):
        (WebInspector.StyleSheetOutlineDialog.prototype.itemTitleAt):
        (WebInspector.StyleSheetOutlineDialog.prototype.itemKeyAt):
        (WebInspector.StyleSheetOutlineDialog.prototype.itemsCount):
        (WebInspector.StyleSheetOutlineDialog.prototype.requestItems):
        (WebInspector.StyleSheetOutlineDialog.prototype.requestItems.didGetStyleSheet):
        (WebInspector.StyleSheetOutlineDialog.prototype.selectItem):
        * inspector/front-end/TabbedEditorContainer.js:
        (WebInspector.TabbedEditorContainer.prototype._generateTabId):
        (WebInspector.TabbedEditorContainer.prototype.currentFile):

2012-05-17  Dan Bernstein  <mitz@apple.com>

        REGRESSION (r117428): WebKit API/SPI was removed
        https://bugs.webkit.org/show_bug.cgi?id=86748

        Reverted r117428.

        * testing/InternalSettings.cpp:
        (WebCore::InternalSettings::setMediaPlaybackRequiresUserGesture):
        * testing/InternalSettings.h:
        (InternalSettings):
        * testing/InternalSettings.idl:

2012-05-17  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: create SourceFrames with content providers.
        https://bugs.webkit.org/show_bug.cgi?id=86742

        Reviewed by Vsevolod Vlasov.

        Simple refactoring.

        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame):
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        (WebInspector.JavaScriptSourceFrame.prototype.afterTextChanged):
        (WebInspector.JavaScriptSourceFrame.prototype._didEditContent):
        * inspector/front-end/ResourceView.js:
        (WebInspector.ResourceSourceFrame):
        (WebInspector.ResourceSourceFrame.prototype.get resource):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._createSourceFrame):
        * inspector/front-end/SourceFrame.js:
        (WebInspector.SourceFrame):
        (WebInspector.SourceFrame.prototype._ensureContentLoaded):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StyleSourceFrame):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCode.prototype.contentURL):

2012-05-17  Yury Semikhatsky  <yurys@chromium.org>

        Web Inspector: error when expanding an HTMLAllCollection object in the console
        https://bugs.webkit.org/show_bug.cgi?id=86741

        Reviewed by Pavel Feldman.

        Test: inspector/console/inspect-html-all-collection.html

        * inspector/InjectedScriptSource.js: take into account that typeof HTMLAllCollection is "undefined"
        when checking if object resolved by id is valid.

2012-05-17  Kinuko Yasuda  <kinuko@chromium.org>

        Unreviewed build fix attempt. Changing class to struct in forward declaration.

        * fileapi/File.h:
        (WebCore):

2012-05-17  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: convert styles panel into UISourceCodeProvider in the scripts panel.
        https://bugs.webkit.org/show_bug.cgi?id=86734

        Reviewed by Vsevolod Vlasov.

        This change also makes Scripts render ans Source Code under that experiment.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/ScriptsNavigator.js:
        (WebInspector.ScriptsNavigator):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.get toolbarItemLabel):
        (WebInspector.ScriptsPanel.prototype.canShowAnchorLocation):
        (WebInspector.ScriptsPanel.prototype._createSourceFrame):
        * inspector/front-end/Settings.js:
        (WebInspector.ExperimentsSettings):
        * inspector/front-end/StylesPanel.js:
        (WebInspector.StylesUISourceCodeProvider):
        (WebInspector.StylesUISourceCodeProvider.prototype.uiSourceCodes):
        (WebInspector.StylesUISourceCodeProvider.prototype._initialize):
        (WebInspector.StylesUISourceCodeProvider.prototype._resourceAdded):
        (WebInspector.StylesUISourceCodeProvider.prototype._reset):
        (WebInspector.StyleSource):
        (WebInspector.StyleSourceFrame):
        (WebInspector.StyleSourceFrame.prototype.canEditSource):
        (WebInspector.StyleSourceFrame.prototype.requestContent):
        (WebInspector.StyleSourceFrame.prototype.commitEditing):
        (WebInspector.StyleSourceFrame.prototype.afterTextChanged):
        (WebInspector.StyleSourceFrame.prototype._clearIncrementalUpdateTimer):
        (WebInspector.StyleSourceFrame.prototype._contentChanged):
        * inspector/front-end/StylesSidebarPane.js:
        (WebInspector.StylePropertiesSection):
        (WebInspector.StylePropertiesSection.prototype._createRuleOriginNode):
        * inspector/front-end/UISourceCode.js:
        * inspector/front-end/inspector.js:
        (WebInspector._createPanels):

2012-05-17  Antti Koivisto  <antti@apple.com>

        Frame flattening should not expand tiny frames
        https://bugs.webkit.org/show_bug.cgi?id=86736

        Reviewed by Kenneth Rohde Christiansen.
        
        If a frame has so small fixed size that it is not usefully scrollable on desktop it is probably
        not meant to be scrolled. Displaying any otherwise invisible content by expanding the frame
        may end up looking like a rendering error.

        The patch prevents expansion of frames that have fixed width or height less than 8px.

        Test: fast/frames/flattening/iframe-tiny.html

        * rendering/RenderFrameBase.cpp:
        (WebCore::shouldExpandFrame):
        (WebCore):
        (WebCore::RenderFrameBase::layoutWithFlattening):

2012-05-17  Yury Semikhatsky  <yurys@chromium.org>

        [Chromium] Web Inspector: assertion failure when inspecting a shared worker in debug mode
        https://bugs.webkit.org/show_bug.cgi?id=86726

        Reviewed by Pavel Feldman.

        No need to keep RefPtr to WorkerThread in a task that will be executed on
        that thread, raw pointer can be used instead.

        * inspector/WorkerDebuggerAgent.cpp:

2012-05-17  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Support an optional 'message' argument for throwTypeError()
        https://bugs.webkit.org/show_bug.cgi?id=86576

        Reviewed by Adam Barth.

        As commented in https://bugs.webkit.org/show_bug.cgi?id=84074#c5,
        I am planning to refactor a series of confusing throwError()s into
        throwError() and throwTypeError().

        This patch supports an optional 'message' argument for V8Proxy::throwTypeError().
        Also this patch replaces throwError("message", V8Proxy::TypeError) in custom bindings
        with V8Proxy::throwTypeError("message").

        No tests. No change in behavior.

        * bindings/v8/V8Proxy.cpp:
        (WebCore::V8Proxy::throwTypeError):
        * bindings/v8/V8Proxy.h:
        (V8Proxy):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8AudioContextCustom.cpp:
        (WebCore::V8AudioContext::constructorCallback):
        * bindings/v8/custom/V8BlobCustom.cpp:
        (WebCore::V8Blob::constructorCallback):
        * bindings/v8/custom/V8DOMFormDataCustom.cpp:
        (WebCore::V8DOMFormData::constructorCallback):
        * bindings/v8/custom/V8DataViewCustom.cpp:
        (WebCore::V8DataView::constructorCallback):
        * bindings/v8/custom/V8HTMLImageElementConstructor.cpp:
        (WebCore::v8HTMLImageElementConstructorCallback):
        * bindings/v8/custom/V8IntentConstructor.cpp:
        (WebCore::V8Intent::constructorCallback):
        * bindings/v8/custom/V8MessageChannelConstructor.cpp:
        (WebCore::V8MessageChannel::constructorCallback):
        * bindings/v8/custom/V8NotificationCenterCustom.cpp:
        (WebCore::V8NotificationCenter::requestPermissionCallback):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp:
        (WebCore::V8WebKitMutationObserver::constructorCallback):
        * bindings/v8/custom/V8WebKitPointConstructor.cpp:
        (WebCore::V8WebKitPoint::constructorCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):
        * bindings/v8/custom/V8XMLHttpRequestConstructor.cpp:
        (WebCore::V8XMLHttpRequest::constructorCallback):

2012-05-16  Andrey Kosyakov  <caseq@chromium.org>

        Web Inspector: [Extensions API] pages shown in sidebar are limited in height to 150px
        https://bugs.webkit.org/show_bug.cgi?id=86659

        Reviewed by Vsevolod Vlasov.

        * inspector/front-end/ExtensionPanel.js:
        (WebInspector.ExtensionView):
        (WebInspector.ExtensionSidebarPane.prototype.setPage): set default iframe height to 150px, unless already set by user.
        * inspector/front-end/inspector.css: set extension view and iframe elements to "fill", iframe to 100% height.
        (iframe.extension):

2012-05-17  Sam D  <dsam2912@gmail.com>

        Web Inspector: Hover on a breakpoint in breakpoint-pane does not get differentiated.
        https://bugs.webkit.org/show_bug.cgi?id=86711

        Changed color values with background on hover over breakpoints.

        Reviewed by Yury Semikhatsky.

        UI change, No new tests.

        * inspector/front-end/inspector.css:
        (.breakpoint-list li:hover):

2012-05-17  Vivek Galatage  <vivekgalatage@gmail.com>

        Web Inspector: DOM Breakpoints Pane should allow to Remove All the breakpoints
        https://bugs.webkit.org/show_bug.cgi?id=86716

        Reviewed by Yury Semikhatsky.

        Added a new context menu to provide Remove All DOM breakpoint option.

        UI Feature. Tests not required.

        * English.lproj/localizedStrings.js:
        * inspector/front-end/DOMBreakpointsSidebarPane.js:
        (WebInspector.DOMBreakpointsSidebarPane.prototype._removeAllBreakpoints):
        (WebInspector.DOMBreakpointsSidebarPane.prototype._contextMenu):

2012-05-17  Ilya Tikhonovsky  <loislo@chromium.org>

        Web Inspector: HeapSnapshot: speed-up calculateObjectToWindowDistance
        https://bugs.webkit.org/show_bug.cgi?id=86718

        The idea is to switch from nodeIndex2distance array to nodeOrdinal2distance external array.
        Due to nature of nodeIndex values the original array was sparsed.

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshotNode.prototype.get distanceToWindow):
        (WebInspector.HeapSnapshot.prototype._calculateObjectToWindowDistance):
        (WebInspector.HeapSnapshot.prototype._bfs):
        (WebInspector.HeapSnapshot.prototype._buildAggregates):

2012-05-11  Kinuko Yasuda  <kinuko@chromium.org>

        Allow FileSystem API implementation to pass snapshot metadata at File creation time
        https://bugs.webkit.org/show_bug.cgi?id=78879

        Reviewed by Jian Li.

        We query File metadata (e.g. size and modifiedTime) when File.size,
        lastModifiedTime or webkitSlice() is accessed / called, but in some
        platform-specific filesystems it may not be feasible since synchronous
        metadata query could take very long time.

        This patch adds new File constructor which takes metadata argument
        to allow each FileSystem API implementation to pass snapshot metadata
        so that File object could cache the given metadata not to make
        synchronous query.

        We only call this constructor if the filesystem type is neither
        Temporary nor Persistent, therefore this patch should not affect
        existing code behavior.

        Test: fast/filesystem/file-read-after-write.html

        * Modules/filesystem/DOMFileSystem.cpp:
        (WebCore::DOMFileSystem::createFile):
        * Modules/filesystem/DOMFileSystemSync.cpp:
        * fileapi/Blob.cpp:
        (WebCore::Blob::webkitSlice): Updated implementation.
        * fileapi/Blob.h:
        * fileapi/File.cpp:
        (WebCore::File::File): Added new constructor.
        (WebCore::File::lastModifiedDate): Updated implementation.
        (WebCore::File::size): Updated implementation.
        (WebCore::File::captureSnapshot): Updated implementation.
        * fileapi/File.h:
        (WebCore::File::createForFileSystemFile): Added.
        * platform/AsyncFileSystem.h:
        (AsyncFileSystem): Updated comment.

2012-05-17  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Convert setDomainRelaxationForbiddenForURLScheme to use InternalSettings interface
        https://bugs.webkit.org/show_bug.cgi?id=86704

        Reviewed by Eric Seidel.

        Add setDomainRelaxationForbiddenForURLScheme functions, because it is able to work in the
        cross-port way by means of the InternalSettings interface.

        No new tests, since we are improving here the infra-structure for testing
        a specific method.

        * testing/InternalSettings.cpp:
        (WebCore):
        (WebCore::InternalSettings::setDomainRelaxationForbiddenForURLScheme):
        * testing/InternalSettings.h:
        (InternalSettings):
        * testing/InternalSettings.idl:

2012-05-17  Shinya Kawanaka  <shinyak@chromium.org>

        ShadowRoot.selection should be ShadowRoot.getSelection()
        https://bugs.webkit.org/show_bug.cgi?id=86598

        Reviewed by Hajime Morita.

        In the latest spec, ShadowRoot.selection is changed to ShadowRoot.getSelection().
        So update the implementation.

        * dom/ShadowRoot.cpp:
        * dom/ShadowRoot.h:
        (ShadowRoot):
        * dom/ShadowRoot.idl:

2012-05-17  Shinya Kawanaka  <shinyak@chromium.org>

        [Refactoring] Remove TreeScopeAdjuster
        https://bugs.webkit.org/show_bug.cgi?id=86599

        Reviewed by Hajime Morita.

        It seems the right place of the method of TreeScopeAdjuster are in VisibleSelection
        and TreeScope. So we can remove TreeScopeAdjuster.

        No new tests, no change in behavior.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/DOMAllInOne.cpp:
        * dom/TreeScope.cpp:
        (WebCore::TreeScope::ancestorInThisScope):
        (WebCore):
        * dom/TreeScope.h:
        (TreeScope):
        * dom/TreeScopeAdjuster.cpp: Removed.
        * dom/TreeScopeAdjuster.h: Removed.
        * editing/VisibleSelection.cpp:
        (WebCore::VisibleSelection::adjustPositionBefore):
        (WebCore):
        (WebCore::VisibleSelection::adjustPositionAfter):
        (WebCore::VisibleSelection::adjustSelectionToAvoidCrossingShadowBoundaries):
        * editing/VisibleSelection.h:
        (VisibleSelection):
        * page/DOMSelection.cpp:
        (WebCore::DOMSelection::shadowAdjustedNode):
        (WebCore::DOMSelection::shadowAdjustedOffset):

2012-05-17  Zoltan Herczeg  <zherczeg@webkit.org>

        NEON intrinsic should be used with arithmetic mode of composite filter
        https://bugs.webkit.org/show_bug.cgi?id=86622

        Reviewed by Nikolas Zimmermann.

        Rewrite hand written assembly code to increase portability and readibility
        of the code. Remove the unnecessary FECompositeArithmeticNEON.cpp from the
        project

        Existing tests cover this issue.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/filters/FEComposite.cpp:
        (WebCore):
        (WebCore::computeArithmeticPixels):
        (WebCore::arithmeticSoftware):
        (WebCore::FEComposite::platformArithmeticSoftware):
        * platform/graphics/filters/FEComposite.h:
        * platform/graphics/filters/arm/FECompositeArithmeticNEON.cpp: Removed.
        * platform/graphics/filters/arm/FECompositeArithmeticNEON.h:
        (WebCore):
        (WebCore::FEComposite::computeArithmeticPixelsNeon):
        (WebCore::FEComposite::platformArithmeticNeon):

2012-05-17  Takashi Sakamoto  <tasak@google.com>

        showNodePath will be useful for debugging purpose.
        https://bugs.webkit.org/show_bug.cgi?id=86450

        This patch implements showNodePath, which outputs node information in
        a xpath-like format, e.g. /HTML/BODY/DIV[@id="test" and position()=0]/P[0]

        Reviewed by Hajime Morita.

        No new tests, just adding debugging interface.

        * dom/Node.cpp:
        (WebCore::Node::showNodePathForThis):
        (WebCore):
        (showNodePath):
        * dom/Node.h:
        (Node):

2012-05-17  Pravin D  <pravind.2k4@gmail.com>

        REGRESSION (r116331): RSS Headlines/links are missing (-webkit-box-flex broken?)
        https://bugs.webkit.org/show_bug.cgi?id=85991

        Fix for regression failures on deprecated flex box test cases. 

        Reviewed by Eric Seidel.

        Test: fast/css/deprecated-flex-box-zero-width-intrinsic-max-width.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::computePreferredLogicalWidths):
        Fix to use intrinsic width when the fixed width:0 , for deprecated flex boxes.

2012-05-17  Uday Kiran  <udaykiran@motorola.com>

        CSS3 Multicolumn: Content in normal flow extending into column gaps should be clipped at middle of column-gap
        https://bugs.webkit.org/show_bug.cgi?id=86441

        Reviewed by Eric Seidel.

        Content in the normal flow that extends into column gaps (e.g., long words or images)
        is clipped in the middle of the column gap.
        http://www.w3.org/TR/css3-multicol/#overflow-inside-multicol-elements

        Test: fast/multicol/overflow-into-columngap.html

        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::paintColumnContents):

2012-05-16  Sheriff Bot  <webkit.review.bot@gmail.com>

        Unreviewed, rolling out r117372.
        http://trac.webkit.org/changeset/117372
        https://bugs.webkit.org/show_bug.cgi?id=86710

        "triggerring crashes" (Requested by morrita on #webkit).

        * Modules/webaudio/AudioParam.cpp:
        (WebCore::AudioParam::calculateSampleAccurateValues):
        (WebCore::AudioParam::calculateAudioRateSignalValues):
        (WebCore::AudioParam::connect):
        (WebCore::AudioParam::disconnect):
        * Modules/webaudio/AudioParam.h:
        (WebCore::AudioParam::context):
        (WebCore::AudioParam::hasSampleAccurateValues):
        (WebCore::AudioParam::AudioParam):
        (AudioParam):

2012-05-16  Hayato Ito  <hayato@chromium.org>

        Implement a Shadow DOM spec's section 6 'Events'.
        https://bugs.webkit.org/show_bug.cgi?id=78586

        Reviewed by Dimitri Glazkov.

        This implements a Shadow DOM spec's section 6 'Events', introducing a new
        algorithm so that event dispatching use a composed shadow DOM tree,
        instead of normal DOM tree, in dispatching events to each node.

        The spec is here: http://dvcs.w3.org/hg/webcomponents/raw-file/tip/spec/shadow/index.html#events

        Summary of changes:
        - Attaching shadow DOM does not affect an event dispatching
        behavior of enclosing DOM tree. This applies even if some nodes
        are distributed to insertion points. We keep a compatibility of
        existing event dispatching mechanism so that we won't break Web.
        - Event ancestors, which are used in dispatching events in capture (or
        bubble) phase, are now the result of traversing ancestors in composed
        shadow DOM tree order, instead of normal DOM tree order.
        - Event's target and related-target are correctly adjusted so that
        we don't leak any node which is inaccessible from the event's
        current-target node. We enforce both upper and lower boundary
        encapsulation of Shadow DOM in event dispatching

        Here is an example of event dispatching. Suppose we have the following DOM tree, which
        includes some nested shadow hosts and insertion points
        A
        `--B-----[SR-B]
           |-C     `--G--------------[SR-G]
           | `-D      |-<H select=C>    |--J---------------[SR-J]
           `-E        `-<I select=E>    |  `-<K select=H>    `-<N select=K>
             `-F                        |
                                        `--L---------------[SR-L]
                                           `-<M select=I>    `-<O select=M>

          Notation: [SR-X]: Shadow Root
                    <X select=Y>: Insertion Point, called X, which selects Y.

        If a mouse moves from node '#F' to node '#D', the following
        'mouseover' events are dispatched in each ancestor node:

        [currentTarget] [target] [related-target]
          #D             #D       #F
          #C             #D       #F
          #H             #H       #I
          #K             #K       #M
          #N             #N       #M
          #SR-J          #N       #M
          #J             #K       #M
          #SR-G          #K       #M
          #G             #H       #I
          #SR-B          #H       #I
          #B             #D       #F
          #A             #D       #F

        Details are:
        - Insertion points, such as <content> or <shadow>, are resolved correctly
        in calculating event ancestors. That means if a node is distributed to
        an insertion point, the insertion point is now an ancestor of the node in
        bubbling (or capturing) events.
        - Both insertion points and shadow roots now can receive events. We can add
        event listeners to insertion points and shadow roots.
        - Dispatched event's target is now adjusted correctly using the re-targeting
        algorithm. The algorithm is now fully aware of insertion points.
        - Dispatched event's related-target can now differ in each tree scope of
        event ancestors. We choose the most appropriate related-target using the
        related target resolution algorithm for each node.

        Performance consideration:
        This patch can achieve the competitive performance. The results of
        ./Tools/Scripts/run-perf-tests PerformanceTests/DOM/Events.html for
        before/after this patch are:

        Before applying this patch:
            Running DOM/Events.html (1 of 1)
            RESULT DOM: Events= 270.310714286 ms
            median= 269.75 ms, stdev= 2.0042397663 ms, min= 267.357142857 ms, max= 276.5 ms

        After applying this patch:
            Running DOM/Events.html (1 of 1)
            RESULT DOM: Events= 268.108333333 ms
            median= 267.5 ms, stdev= 2.41883157195 ms, min= 263.625 ms, max= 273.142857143 ms

        I've also conducted a micro benchmark using both
        Shadow-Free-DOM-Tree and DOM-Tree-With-Shadow-Host.
        See https://bugs.webkit.org/show_bug.cgi?id=78586#c40 for the results.
        It seems that the new implementation has more capabilities, but
        doesn't sacrifice a performance of event dispatching in either cases.

        Test: fast/dom/shadow/shadow-dom-event-dispatching.html

        * dom/ComposedShadowTreeWalker.cpp:
        (WebCore::ComposedShadowTreeWalker::parentIncludingInsertionPointAndShadowRoot):
        (WebCore):
        (WebCore::ComposedShadowTreeWalker::traverseParentIncludingInsertionPointAndShadowRoot):
        * dom/ComposedShadowTreeWalker.h:
        (ComposedShadowTreeWalker):
        * dom/EventContext.cpp:
        (WebCore::EventContext::EventContext):
        (WebCore::EventContext::handleLocalEvents):
        * dom/EventContext.h:
        (EventContext):
        (WebCore::EventContext::relatedTarget):
        (WebCore):
        (WebCore::EventContext::setRelatedTarget):
        * dom/EventDispatcher.cpp:
        (WebCore::EventRelatedTargetAdjuster::EventRelatedTargetAdjuster):
        (WebCore):
        (WebCore::EventRelatedTargetAdjuster::adjust):
        (WebCore::EventRelatedTargetAdjuster::findRelatedTarget):
        (WebCore::EventDispatcher::adjustRelatedTarget):
        (WebCore::EventDispatcher::ensureEventAncestors):
        (WebCore::EventDispatcher::dispatchEvent):
        (WebCore::EventDispatcher::determineDispatchBehavior):
        * dom/EventDispatcher.h:
        (WebCore):
        (EventRelatedTargetAdjuster):
        (EventDispatcher):
        * dom/MouseEvent.cpp:
        (WebCore::MouseEventDispatchMediator::dispatchEvent):
        * dom/MouseEvent.h:
        (WebCore::toMouseEvent):
        (WebCore):

2012-05-16  Ryosuke Niwa  <rniwa@webkit.org>

        Moving caret up or down skips lines when there's a non-editable line
        https://bugs.webkit.org/show_bug.cgi?id=81490

        Reviewed by Eric Seidel.

        The bug was caused by previousRootInlineBoxCandidatePosition and nextRootInlineBoxCandidatePosition
        skipping leaf nodes that constitute a new line and belong to the same editable region because block elements
        that separate lines are not editable so it looked as if all editable lines belong to a single line as far as
        those two functions are concerned.

        Fixed the bug by using the first leaf node that belongs to the same editable region but does not belong in
        the same as the start node.

        This patch is based on a patch authored by Yi Shen (Nokia).

        Test: editing/selection/move-between-lines-of-different-editabilities.html

        * editing/visible_units.cpp:
        (WebCore::previousRootInlineBoxCandidatePosition):
        (WebCore::nextRootInlineBoxCandidatePosition):

2012-05-16  MORITA Hajime <morrita@google.com>

        Unreviewed attempt to fix Mac SL build.

        * platform/graphics/opengl/GraphicsContext3DOpenGLCommon.cpp:

2012-05-16  Levi Weintraub  <leviw@chromium.org>

        Use pixelSnappedLogicalHeight for TableSection layout
        https://bugs.webkit.org/show_bug.cgi?id=86665

        Reviewed by Eric Seidel.

        We do table layout using integers to ensure we follow the spec (see
        https://trac.webkit.org/wiki/LayoutUnit for details), but were previously
        flooring the logical height used in layoutRows. This caused us to mis-
        calculate the intrinsic padding and grow cells beyond their proper height.

        No new tests. Fully covered by existing tests with sub-pixel enabled.

        * rendering/RenderBox.h:
        (WebCore::RenderBox::pixelSnappedLogicalHeight): Added these convenience
        methods.
        (WebCore::RenderBox::pixelSnappedLogicalWidth):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::layoutRows):

2012-05-16  Tony Chang  <tony@chromium.org>

        rename display:-webkit-flexbox to display:-webkit-flex
        https://bugs.webkit.org/show_bug.cgi?id=86529

        Reviewed by Eric Seidel.

        Also renames -webkit-inline-flexbox to -webkit-inline-flex.

        No new tests. Covered by existing tests.

        * css/CSSParser.cpp:
        (WebCore::isValidKeywordPropertyAndValue):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        * css/CSSValueKeywords.in: Update keyword values.
        * css/StyleResolver.cpp:
        (WebCore::StyleResolver::collectMatchingRulesForList):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::createObject):
        * rendering/RenderObject.h:
        (RenderObject):
        * rendering/style/RenderStyleConstants.h: Rename const values.

2012-05-16  Greg Billock  <gbillock@google.com>

        IDL and implementation for Web Intents delivery
        https://bugs.webkit.org/show_bug.cgi?id=83634

        Reviewed by Adam Barth.

        The delivered intent has some extra fields and methods (extras,
        postResult, postFailure) from the invocation intent. It is implemented
        as a subclass. Responses from the service JS are passed to an embedder
        client object provided when the intent is delivered.
        See http://dvcs.w3.org/hg/web-intents/raw-file/tip/spec/Overview.html
        Test: webintents/web-intents-delivery.html

        * Modules/intents/DOMWindowIntents.cpp: Copied from Source/WebCore/Modules/intents/DOMWindowIntents.idl.
        (WebCore):
        (WebCore::DOMWindowIntents::DOMWindowIntents):
        (WebCore::DOMWindowIntents::~DOMWindowIntents):
        (WebCore::DOMWindowIntents::from):
        (WebCore::DOMWindowIntents::webkitIntent):
        (WebCore::DOMWindowIntents::deliver):
        * Modules/intents/DOMWindowIntents.h: Copied from Source/WebCore/Modules/intents/DOMWindowIntents.idl.
        (WebCore):
        (DOMWindowIntents):
        * Modules/intents/DOMWindowIntents.idl:
        * Modules/intents/DeliveredIntent.cpp: Copied from Source/WebCore/Modules/intents/Intent.h.
        (WebCore):
        (WebCore::DeliveredIntent::create):
        (WebCore::DeliveredIntent::DeliveredIntent):
        (WebCore::DeliveredIntent::ports):
        (WebCore::DeliveredIntent::getExtra):
        (WebCore::DeliveredIntent::postResult):
        (WebCore::DeliveredIntent::postFailure):
        * Modules/intents/DeliveredIntent.h: Copied from Source/WebCore/Modules/intents/Intent.h.
        (WebCore):
        (DeliveredIntent):
        (WebCore::DeliveredIntent::~DeliveredIntent):
        * Modules/intents/DeliveredIntent.idl: Copied from Source/WebCore/Modules/intents/Intent.h.
        * Modules/intents/Intent.h:
        (WebCore::Intent::~Intent):
        (Intent):
        * WebCore.gyp/WebCore.gyp:
        * WebCore.gypi:
        * bindings/v8/custom/V8DeliveredIntentCustom.cpp: Copied from Source/WebCore/Modules/intents/Intent.h.
        (WebCore):
        (WebCore::V8DeliveredIntent::portsAccessorGetter):

2012-05-16  Kentaro Hara  <haraken@chromium.org>

        [V8][Refactoring] Replace throwError("message", XXXError)
        with throwError(XXXError, "message")
        https://bugs.webkit.org/show_bug.cgi?id=86579

        Reviewed by Adam Barth.

        This is one of a series of refactoring commented in
        https://bugs.webkit.org/show_bug.cgi?id=84074#c5

        Currently there are two equivalent throwError()s; i.e. throwError("message", XXXError)
        and throwError(XXXError, "message"). In this bug we replace
        throwError("message", XXXError) with throwError(XXXError, "message")
        (except for the case where XXXError == TypeError. This is because
        throwError("message", TypeError) will be replaced with throwTypeError("message")
        in a follow-up patch).

        No tests. No change in behavior.

        * bindings/v8/V8NPObject.cpp:
        (WebCore::npObjectInvokeImpl):
        (WebCore::npObjectGetProperty):
        (WebCore::npObjectSetProperty):
        (WebCore::npObjectPropertyEnumerator):
        * bindings/v8/V8Proxy.cpp:
        (WebCore::handleMaxRecursionDepthExceeded):
        * bindings/v8/custom/V8ArrayBufferCustom.cpp:
        (WebCore::V8ArrayBuffer::constructorCallback):
        * bindings/v8/custom/V8ArrayBufferViewCustom.h:
        (WebCore::constructWebGLArrayWithArrayBufferArgument):
        (WebCore::constructWebGLArray):
        * bindings/v8/custom/V8AudioContextCustom.cpp:
        (WebCore::V8AudioContext::constructorCallback):
        * bindings/v8/custom/V8BlobCustom.cpp:
        (WebCore::V8Blob::constructorCallback):
        * bindings/v8/custom/V8ClipboardCustom.cpp:
        (WebCore::V8Clipboard::clearDataCallback):
        (WebCore::V8Clipboard::setDragImageCallback):
        * bindings/v8/custom/V8DOMFormDataCustom.cpp:
        (WebCore::V8DOMFormData::appendCallback):
        * bindings/v8/custom/V8HTMLImageElementConstructor.cpp:
        (WebCore::v8HTMLImageElementConstructorCallback):
        * bindings/v8/custom/V8WebKitMutationObserverCustom.cpp:
        (WebCore::V8WebKitMutationObserver::constructorCallback):
        * bindings/v8/custom/V8WebSocketCustom.cpp:
        (WebCore::V8WebSocket::constructorCallback):
        * bindings/v8/custom/V8XMLHttpRequestConstructor.cpp:
        (WebCore::V8XMLHttpRequest::constructorCallback):

2012-05-16  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to remaining toV8()
        https://bugs.webkit.org/show_bug.cgi?id=86570

        Reviewed by Nate Chapin.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to toV8(). I've landed a bunch of
        patches to pass Isolate to toV8(), and this would be the last
        patch for passing Isolate to toV8().

        No tests. No change in behavior.

        * bindings/v8/custom/V8HTMLCollectionCustom.cpp:
        (WebCore::getNamedItems):
        * bindings/v8/custom/V8IDBAnyCustom.cpp:
        (WebCore::toV8):

2012-05-16  James Robinson  <jamesr@chromium.org>

        GraphicsContext3D interface should not be aware of CanvasRenderingContext
        https://bugs.webkit.org/show_bug.cgi?id=86550

        Reviewed by Darin Adler.

        GraphicsContext3D is a WebCore/platform API construct. CanvasRenderingContext is a WebCore/html concept. Thus,
        the former shouldn't depend on the latter.  In turns out that all everyone ever wants from a
        CanvasRenderingContext in GraphicsContext3D is its underlying ImageBuffer, which is a WebCore/platform concept,
        so this just updates the APIs and implementations to use that instead.

        Refactor only, no new tests.

        * html/canvas/WebGLRenderingContext.cpp:
        (WebCore::WebGLRenderingContext::paintRenderingResultsToCanvas):
        * platform/graphics/GraphicsContext3D.h:
        * platform/graphics/cairo/DrawingBufferCairo.cpp:
        (WebCore::DrawingBuffer::paintCompositedResultsToCanvas):
        * platform/graphics/chromium/DrawingBufferChromium.cpp:
        (WebCore::DrawingBuffer::paintCompositedResultsToCanvas):
        * platform/graphics/clutter/DrawingBufferClutter.cpp:
        (WebCore::DrawingBuffer::paintCompositedResultsToCanvas):
        * platform/graphics/efl/GraphicsContext3DEfl.cpp:
        (WebCore::GraphicsContext3D::paintRenderingResultsToCanvas):
        (WebCore::GraphicsContext3D::paintCompositedResultsToCanvas):
        * platform/graphics/gpu/DrawingBuffer.h:
        * platform/graphics/gpu/qt/DrawingBufferQt.cpp:
        (WebCore::DrawingBuffer::paintCompositedResultsToCanvas):
        * platform/graphics/opengl/GraphicsContext3DOpenGLCommon.cpp:
        (WebCore::GraphicsContext3D::paintRenderingResultsToCanvas):
        (WebCore::GraphicsContext3D::paintCompositedResultsToCanvas):

2012-05-16  Joshua Bell  <jsbell@chromium.org>

        SerializedScriptValue: lazy initialization of static nullValue not threadsafe
        https://bugs.webkit.org/show_bug.cgi?id=70833

        Reviewed by Kentaro Hara.

        Remove unsafe lazy initialization of static |null| SSV. None of the callers
        appeared to be in performance-critical areas - most were preparing an event to
        be dispatched to script - so no per-call-site caching was added.

        No new tests - no functional changes.

        * bindings/js/SerializedScriptValue.cpp: Mint a new one each time.
        (WebCore::SerializedScriptValue::nullValue):
        * bindings/js/SerializedScriptValue.h: Return via PassRefPtr.
        * bindings/v8/SerializedScriptValue.cpp: Mint a new one each time.
        (WebCore::SerializedScriptValue::nullValue):
        * bindings/v8/SerializedScriptValue.h: Return via PassRefPtr.
        (SerializedScriptValue):
        * dom/Document.cpp:
        (WebCore::Document::statePopped): Change to PassRefPtr to maintain refcount.
        * dom/Document.h:
        (Document):

2012-05-16  James Robinson  <jamesr@chromium.org>

        CachedImage does not clear the ImageObserver pointer when dropping its Image ref
        https://bugs.webkit.org/show_bug.cgi?id=86689

        Reviewed by Eric Seidel.

        Image instances keep a weak pointer to their ImageObserver, which may be null. CachedImage is an ImageObserver
        and holds a RefPtr<Image> m_image. When CachedImage initializes its m_image to either an SVGImage or BitmapImage,
        it sets itself as that Image's ImageObserver. However, CachedImage never clears the ImageObserver pointer, even
        when dropping its reference to the Image. This means if other code holds a RefPtr<Image> there is no promise
        that calls on that Image will be valid. This patch clears the CachedImage::m_image's ImageObserver pointer
        whenever the CachedImage drops its reference. Image already has null checks for its m_imageObserver so this is
        always a safe operation.

        * loader/cache/CachedImage.cpp:
        (WebCore::CachedImage::~CachedImage):
        (WebCore::CachedImage::clear):

2012-05-16  Kentaro Hara  <haraken@chromium.org>

        [V8] Fix a broken copyright of V8SVGElementCustom.cpp
        https://bugs.webkit.org/show_bug.cgi?id=86569

        Reviewed by Nate Chapin.

        This patch just fixes a broken copyright of V8SVGElementCustom.cpp.

        Blame changeset: r54153

        No tests. No change in behavior.

        * bindings/v8/custom/V8SVGElementCustom.cpp:

2012-05-16  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to convertEventTargetToV8Object()
        https://bugs.webkit.org/show_bug.cgi?id=86566

        Reviewed by Nate Chapin.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to convertEventTargetToV8Object().
        I made the 'isolate' argument optional, since
        convertEventTargetToV8Object() can be called from the WebCore context.

        No tests. No change in behavior.

        * bindings/scripts/CodeGeneratorV8.pm:
        (NativeToJSValue):
        * bindings/v8/V8DOMWrapper.cpp:
        (WebCore):
        (WebCore::V8DOMWrapper::convertEventTargetToV8Object):
        * bindings/v8/V8DOMWrapper.h:
        (WebCore::V8DOMWrapper::convertEventTargetToV8Object):
        (V8DOMWrapper):

2012-05-16  Peter Kasting  <pkasting@google.com>

        Correctly display malformed GIFs which specify bogus extension block
        sizes.
        https://bugs.webkit.org/show_bug.cgi?id=86531

        Reviewed by James Robinson.
        
        This was broken by r117333, which was an attempt to avoid memory errors
        on GIFs that were malformed in a similar way.  It turns out some GIFs
        in the wild (i.e. "our LayoutTests directory") relied on some of the
        effects of the old code.  This refixes in a way that doesn't break
        these.

        No new tests, covered by existing tests.

        * platform/image-decoders/gif/GIFImageReader.cpp:
        (GIFImageReader::read):

2012-05-16  Chris Rogers  <crogers@google.com>

        AudioParam must support fan-in (multiple audio connections)
        https://bugs.webkit.org/show_bug.cgi?id=83610

        Reviewed by Kenneth Russell.

        Test: webaudio/audioparam-summingjunction.html

        * Modules/webaudio/AudioParam.cpp:
        * Modules/webaudio/AudioParam.h:
        (WebCore::AudioParam::calculateSampleAccurateValues):
        (WebCore::AudioParam::calculateAudioRateSignalValues):
        Sums intrinsic parameter value with all audio-rate connections.

        (WebCore::AudioParam::connect):
        (WebCore::AudioParam::disconnect):
        Support multiple connections.

        (WebCore::AudioParam::hasSampleAccurateValues):
        If we have one or more audio-rate connections.

        (WebCore::AudioParam::AudioParam):
        AudioParam now sub-classes AudioSummingJunction.

2012-05-16  Kentaro Hara  <haraken@chromium.org>

        [V8] Pass Isolate to createV8HTMLWrapper() and createV8SVGWrapper()
        https://bugs.webkit.org/show_bug.cgi?id=86558

        Reviewed by Nate Chapin.

        The objective is to pass Isolate around in V8 bindings.
        This patch passes Isolate to createV8HTMLWrapper() and createV8SVGWrapper().

        Basically 'isolate' has been implemented as the last argument
        but before 'forceNewObject' argument, because 'forceNewObject' is an optional
        argument and omitted in most cases. Due to the convention,
        this patch puts 'isolate' before 'forceNewObject'.

        No tests. No change in behavior.

        * bindings/v8/custom/V8HTMLElementCustom.cpp:
        (WebCore::toV8):
        * bindings/v8/custom/V8SVGElementCustom.cpp:
        (WebCore::toV8):
        * dom/make_names.pl:
        (printWrapperFunctions):
        (printWrapperFactoryCppFile):
        (printWrapperFactoryHeaderFile):

2012-05-16  Ryosuke Niwa  <rniwa@webkit.org>

        Move showStyle from CSSStyleDeclaration to StylePropertySet
        https://bugs.webkit.org/show_bug.cgi?id=86675

        Reviewed by Andreas Kling.

        Moved the function. Also deleted CSSStyleDeclaration.cpp since it's no longer needed.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * WebCore.gypi:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSAllInOne.cpp:
        * css/CSSStyleDeclaration.cpp:
        (WebCore):
        * css/CSSStyleDeclaration.h:
        (CSSStyleDeclaration):
        * css/StylePropertySet.cpp:
        (WebCore):
        (WebCore::StylePropertySet::showStyle):
        * css/StylePropertySet.h:
        (StylePropertySet):

2012-05-16  Martin Robinson  <mrobinson@igalia.com>

        Fix the indexed database build for GTK+.

        * GNUmakefile.list.am: Add missing files to the build.
        * bindings/gobject/GNUmakefile.am: Be smarter about filtering out deactivating indexed database.
        * bindings/scripts/CodeGeneratorGObject.pm:
        (SkipAttribute): Always skip attributes that return indexed database types.

2012-05-16  Jon Lee  <jonlee@apple.com>

        Animated GIFs in page cache get updated
        https://bugs.webkit.org/show_bug.cgi?id=86668
        <rdar://problem/11395549>

        Reviewed by Brady Eidson.

        Test: fast/loader/image-in-page-cache.html

        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::imageChanged): When we are notified by the CachedImage that the image has
        changed, we check to see if the document is in the page cache. If so, we should not be updating,
        so we bail out early.

2012-05-16  Tim Horton  <timothy_horton@apple.com>

        Crash if SVG gradient stop has display: none set
        https://bugs.webkit.org/show_bug.cgi?id=86686
        <rdar://problem/10751905>

        Reviewed by Dean Jackson.

        Create a renderer for SVGStopElement regardless of the "display" property.
        This matches the behavior of Opera and the SVG specification.

        Test: svg/custom/gradient-stop-display-none-crash.svg

        * svg/SVGStopElement.cpp:
        (WebCore::SVGStopElement::rendererIsNeeded):
        (WebCore):
        * svg/SVGStopElement.h:
        (SVGStopElement):

2012-05-16  Dana Jansens  <danakj@chromium.org>

        [chromium] Clear the m_private pointer when destroying WebFilterOperations to avoid assert in WebPrivateOwnPtr
        https://bugs.webkit.org/show_bug.cgi?id=86654

        Reviewed by James Robinson.

        * platform/chromium/support/WebFilterOperations.cpp:
        (WebKit::WebFilterOperations::reset):
        (WebKit::WebFilterOperations::destroy):
        (WebKit):

2012-05-16  Ryosuke Niwa  <rniwa@webkit.org>

        REGRESSION(r92823): WebKit strips font-weight: normal from b element when copying
        https://bugs.webkit.org/show_bug.cgi?id=86663

        Reviewed by Tony Chang.

        The bug was caused by removeStyleFromRulesAndContext incorrectly stripping font-weight property
        even when the context had no font-weight property because of a property name mismatch in getPropertiesNotIn.

        Fixed the mismatch.

        Test: editing/pasteboard/paste-text-with-style-5.html

        * editing/EditingStyle.cpp:
        (WebCore::getPropertiesNotIn):

2012-05-16  Ryosuke Niwa  <rniwa@webkit.org>

        Merge nextRootInlineBox with nextLinePosition
        https://bugs.webkit.org/show_bug.cgi?id=81593

        Reviewed by Enrica Casucci.

        Call previousRootInlineBox and nextRootInlineBox in previousLinePosition and nextLinePosition respectively
        to share the code. Moved out the nullity check of startBox and extracted the renderer's node from the former
        two, and added editableType to their argument lists to match the interface in both use cases.

        Also moved out the code to extract root inline box using RenderedPosition from those two functions and
        expanded in call sites since previousLinePosition and nextLinePosition need to return the candidate position
        even when the root inline box doesn't exist. To this end, renamed previousRootInlineBox and nextRootInlineBox
        to previousRootInlineBoxCandidatePosition and nextRootInlineBoxCandidatePosition respectively.

        In addition, got rid of one version of nextLeafWithSameEditability that adjusted node with respect to offset
        This variant did:

        Node* child = node->childNode(offset);
        node = child ? child->nextLeafNode() : node->lastDescendant()->nextLeafNode();

        instead of:

        node = node->nextLeafNode();

        at the beginning of the function. Observe that the former code is logically equivalent to:

        Node* child = node->childNode(offset);
        node = child ? child : node->lastDescendant();
        node = node->nextLeafNode();

        Thus, the first two lines of this logically equivalent code is added in nextLinePosition wherein we used to
        call the removed variant.

        This refactoring with no behavioral change would help us resolving the bug 81490.

        * editing/visible_units.cpp:
        (WebCore::previousRootInlineBoxCandidatePosition): Renamed from previousRootInlineBox.
        (WebCore::nextRootInlineBoxCandidatePosition): Renamed from nextRootInlineBox.
        (WebCore::logicallyPreviousBox): Checks the nullity of startBox's renderer and node. Also extracts the root
        inline box out of the position per the interface change.
        (WebCore::logicallyNextBox): Ditto.
        (WebCore::previousLinePosition): Calls previousRootInlineBoxCandidatePosition.
        (WebCore::nextLinePosition): Calls nextRootInlineBoxCandidatePosition.

2012-05-16  Noel Gordon  <noel.gordon@gmail.com>

        [chromium] Remove ImageDecoderCG.cpp from platform/image-decoders
        https://bugs.webkit.org/show_bug.cgi?id=86346

        Reviewed by Adam Barth.

        ImageDecoderCG.cpp was added for use in the Chromium port in r70846. Remove the
        implementation now that Chromium uses Skia on Mac OSX by default.

        No new tests. No change in behavior.
        
        * WebCore.gypi: Remove ImageDecoderCG.cpp from the gyp project.
        * platform/graphics/ImageSource.h: Revert the r70846 changes.
        * platform/image-decoders/ImageDecoder.cpp: Remove copyReferenceToBitmapData().
        (WebCore::ImageFrame::operator=): Return to using copyBitmapData() (as it was)
        given the removal of copyReferenceToBitmapData() above.
        * platform/image-decoders/ImageDecoder.h:
        (ImageFrame): Remove copyReferenceToBitmapData() declaration.
        * platform/image-decoders/cg/ImageDecoderCG.cpp: Removed, and it was the only
        decoder with a port-specific implementation of copyReferenceToBitmapData().

2012-05-16  Raymond Toy  <rtoy@google.com>

        Simplify AudioNode ref-counting by removing RefTypeDisabled
        https://bugs.webkit.org/show_bug.cgi?id=85681

        Reviewed by Chris Rogers.

        Existing tests should cover these changes.

        * Modules/webaudio/AudioNode.cpp: Remove RefTypeDiabled and m_disabledRefCount.
        (WebCore::AudioNode::AudioNode):
        (WebCore::AudioNode::~AudioNode):
        (WebCore::AudioNode::enableOutputsIfNecessary): New
        (WebCore::AudioNode::ref): 
        (WebCore::AudioNode::disableOutputsIfNecessary): New
        (WebCore::AudioNode::finishDeref):
        * Modules/webaudio/AudioNode.h: Remove RefTypeDisabled and m_disabledRefCount.
        * Modules/webaudio/AudioNodeInput.cpp: Removed uses of RefTypeDisbled.
        (WebCore::AudioNodeInput::disconnect):
        (WebCore::AudioNodeInput::disable):
        (WebCore::AudioNodeInput::enable):

2012-05-16  Ojan Vafai  <ojan@chromium.org>

        Fix perf regression from r116487
        https://bugs.webkit.org/show_bug.cgi?id=86680

        Reviewed by Ryosuke Niwa.

        http://trac.webkit.org/changeset/116487 caused a 6% regression on
        Dromaeo's dom-attr test. The issue is that we invalidated NodeList
        caches whenever an id/checked/type attribute changed.

        First, we don't need to invalidate on checked/type since that only
        affects the values return by NodeList items, not the list of items.
        Second, we only need to invalidate NodeList caches when an id attribute
        changes on a FormControlElement.

        Incidentally, we also don't need to invalidate caches for changes
        to attributes that don't have an ownerElement.

        No new tests. This is strictly a performance improvement.

        * dom/Attr.cpp:
        (WebCore::Attr::setValue):
        (WebCore::Attr::childrenChanged):
        * dom/Element.cpp:
        (WebCore::Element::attributeChanged):
        * dom/Node.cpp:
        (WebCore::Node::invalidateNodeListsCacheAfterAttributeChanged):
        * dom/Node.h:
        (Node):

2012-04-22  Robert Hogan  <robert@webkit.org>

        CSS 2.1 failure: inline-table-001 fails
        https://bugs.webkit.org/show_bug.cgi?id=84167

        Reviewed by Julien Chaffraix.

        Override lastLineBoxBaseline() in RenderTable so that it picks up the baseline
        of the text in the first row of the table. This allows inline tables to find the
        correct baseline to align to.

        Tests:
                css2.1/20110323/inline-table-001.htm
                css2.1/20110323/inline-table-002a.htm
                css2.1/20110323/inline-table-003.htm
                fast/css/empty-cell-baseline.html

        * rendering/RenderTable.cpp:
        (WebCore::getLineBoxBaseline):
        (WebCore):
        (WebCore::RenderTable::lastLineBoxBaseline):
        (WebCore::RenderTable::firstLineBoxBaseline):
        * rendering/RenderTable.h:
        (RenderTable):
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::firstLineBoxBaseline): if a cell is empty it cannot provide a 
          baseline. Tested by fast/css/empty-cell-baseline.html

2012-05-16  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Rename valid/finished methods to isValid/isFinished to match coding standard
        https://bugs.webkit.org/show_bug.cgi?id=86655

        Reviewed by Tony Chang.

        No new tests - no functional changes.

        * Modules/indexeddb/IDBKey.h:
        (WebCore::IDBKey::isValid): valid() => isValid()
        * Modules/indexeddb/IDBObjectStore.cpp:
        (WebCore::IDBObjectStore::deleteFunction):
        (WebCore::IDBObjectStore::index):
        (WebCore::IDBObjectStore::transactionFinished):
        * Modules/indexeddb/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::put):
        (WebCore::IDBObjectStoreBackendImpl::putInternal):
        (WebCore::IDBObjectStoreBackendImpl::deleteFunction):
        * Modules/indexeddb/IDBRequest.cpp:
        (WebCore::IDBRequest::onSuccess):
        * Modules/indexeddb/IDBTransaction.cpp:
        (WebCore::IDBTransaction::isFinished): finished() => isFinished()
        * Modules/indexeddb/IDBTransaction.h:
        * inspector/InspectorIndexedDBAgent.cpp:
        (WebCore):

2012-05-16  Jeffrey Pfau  <jpfau@apple.com>

        ImageLoader can still dispatch beforeload events for ImageDocuments
        https://bugs.webkit.org/show_bug.cgi?id=86658
        <rdar://problem/11465863>

        Reviewed by Brady Eidson.

        Prevent flags regarding sending beforeload events from being set on ImageDocuments.

        No new tests; testing framework doesn't allow for testing ImageDocuments with injected JavaScript.

        * loader/ImageLoader.cpp:
        (WebCore::ImageLoader::updateFromElement):

2012-05-16  Julien Chaffraix  <jchaffraix@webkit.org>

        layerX/layerY warning should be removed
        https://bugs.webkit.org/show_bug.cgi?id=86264

        Reviewed by James Robinson.

        Covered by: fast/dom/Window/window-xy-properties.html
                    fast/events/init-events.html
                    fast/events/mouse-relative-position.html
                    fast/events/mouseclick-target-and-positioning.html
                    fast/events/simulated-click-coords.html
                    jquery/event.html

        This change just removes the warning pending proper investigation.

        Longer explanation: The layerX/layerY warning was added prematurely
        as we didn't assess the web-compatibility potential breakage vs the
        maintenance cost. There is also not readily available replacement.

        * dom/MouseRelatedEvent.cpp:
        (WebCore::MouseRelatedEvent::layerX):
        (WebCore::MouseRelatedEvent::layerY):
        * dom/UIEvent.cpp:
        (WebCore::UIEvent::layerX):
        (WebCore::UIEvent::layerY):
        * dom/UIEvent.h:
        Removed warnDeprecatedLayerXYUsage and all the associated calls.

2012-05-16  Joshua Bell  <jsbell@chromium.org>

        IndexedDB: Use accessors for backing store / database id in store/index backends
        https://bugs.webkit.org/show_bug.cgi?id=86652

        Reviewed by Tony Chang.

        Hide the private members m_backingStore and m_databaseId of IDBObjectStoreBackendImpl
        and IDBIndexBackendImpl behind accessors. This is preparation for removing these
        members and only holding references to the IDBDatabaseBackendImpl: webkit.org/b/83074

        No new tests - no functional changes.

        * Modules/indexeddb/IDBIndexBackendImpl.cpp:
        (WebCore::IDBIndexBackendImpl::openCursorInternal):
        (WebCore::IDBIndexBackendImpl::countInternal):
        (WebCore::IDBIndexBackendImpl::getInternal):
        (WebCore::IDBIndexBackendImpl::getByRangeInternal):
        (WebCore::IDBIndexBackendImpl::getKeyInternal):
        (WebCore::IDBIndexBackendImpl::getKeyByRangeInternal):
        (WebCore::IDBIndexBackendImpl::addingKeyAllowed):
        * Modules/indexeddb/IDBIndexBackendImpl.h:
        (WebCore::IDBIndexBackendImpl::backingStore): Added.
        (WebCore::IDBIndexBackendImpl::databaseId): Added.
        (IDBIndexBackendImpl):
        * Modules/indexeddb/IDBObjectStoreBackendImpl.cpp:
        (WebCore::IDBObjectStoreBackendImpl::getByRangeInternal):
        (WebCore::IDBObjectStoreBackendImpl::getInternal):
        (WebCore::IDBObjectStoreBackendImpl::putInternal):
        (WebCore::IDBObjectStoreBackendImpl::deleteInternal):
        (WebCore::IDBObjectStoreBackendImpl::clearInternal):
        (WebCore):
        (WebCore::IDBObjectStoreBackendImpl::createIndex):
        (WebCore::IDBObjectStoreBackendImpl::createIndexInternal):
        (WebCore::IDBObjectStoreBackendImpl::deleteIndexInternal):
        (WebCore::IDBObjectStoreBackendImpl::openCursorInternal):
        (WebCore::IDBObjectStoreBackendImpl::countInternal):
        (WebCore::IDBObjectStoreBackendImpl::loadIndexes):
        (WebCore::IDBObjectStoreBackendImpl::genAutoIncrementKey):
        * Modules/indexeddb/IDBObjectStoreBackendImpl.h:
        (WebCore::IDBObjectStoreBackendImpl::backingStore): Added.
        (WebCore::IDBObjectStoreBackendImpl::databaseId): Added.
        (IDBObjectStoreBackendImpl):

2012-05-15  Peter Kasting  <pkasting@google.com>

        Malformed GIF can cause decoder to read off end of heap buffer
        https://bugs.webkit.org/show_bug.cgi?id=86531

        Reviewed by Adam Barth.

        Test: fast/images/read-past-end-of-buffer.html
        This test is only expected to catch problems if run under Address
        Sanitizer or a similar memory-checking utility.

        * platform/image-decoders/gif/GIFImageReader.cpp:
        (GIFImageReader::read):

2012-05-16  Varun Jain  <varunjain@google.com>

        [chromium] No modifier flags (shift/ctrl/alt) in drag&drop events on chromium linux
        https://bugs.webkit.org/show_bug.cgi?id=86236

        Reviewed by Tony Chang.

        ManualTests: ManualTests/chromium/modifiers-during-drag-and-drop.html

        * page/DragController.cpp:
        (WebCore::createMouseEvent):
        * platform/DragData.cpp:
        (WebCore):
        (WebCore::DragData::modifierKeyState):
        * platform/DragData.h:
        (DragData):
        * platform/chromium/ChromiumDataObject.cpp:
        (WebCore::ChromiumDataObject::ChromiumDataObject):
        * platform/chromium/ChromiumDataObject.h:
        (WebCore::ChromiumDataObject::modifierKeyState):
        (WebCore::ChromiumDataObject::setModifierKeyState):
        (ChromiumDataObject):
        * platform/chromium/DragDataChromium.cpp:
        (WebCore::DragData::modifierKeyState):
        (WebCore):

2012-05-16  Jer Noble  <jer.noble@apple.com>

        <video> elements with no video tracks report false for webkitSupportsFullscreen.
        https://bugs.webkit.org/show_bug.cgi?id=86650

        Reviewed by Eric Carlson.

        No new tests; updated media/media-fullscreen-inline.html.

        With the new Full Screen API, the restriction that only video elements with
        video tracks can enter full screen seems arbitrary. Some media types will
        occasionally determine they have video tracks long after loadedmetadata, which
        breaks websites who check for webkitSupportsFullscreen(). Relax the restriction
        on webkitSupportsFullscreen() for ports where the Full Screen API is enabled and
        supported so as to no longer require hasVideo().

        * html/HTMLVideoElement.cpp:
        (WebCore::HTMLVideoElement::supportsFullscreen):

2012-05-16  Andreas Kling  <kling@webkit.org>

        Avoid reparsing the style attribute when cloning elements.
        <http://webkit.org/b/86574>

        Reviewed by Antti Koivisto.

        Refactor cloning of attributes a bit to dodge the styleAttr reparse previously
        caused by ElementAttributeData::setAttributes().

        Introduced Element::cloneDataFromElement() which takes care of cloning the
        ElementAttributeData as well as "non-attribute properties" (which is currently
        specific to HTMLInputElement.)

        Also includes some additional dodging of attribute vector traversal to find
        old/new 'id' and 'name' attributes.

        I'm seeing a ~10% improvement on PerformanceTests/DOM/CloneNodes locally.

        * dom/Document.cpp:
        (WebCore::Document::importNode):
        * dom/Element.cpp:
        (WebCore::Element::cloneElementWithoutChildren):
        (WebCore::Element::cloneAttributesFromElement):
        (WebCore::Element::cloneDataFromElement):
        * dom/Element.h:
        (WebCore::Element::copyNonAttributePropertiesFromElement):
        * dom/ElementAttributeData.cpp:
        (WebCore::ElementAttributeData::cloneDataFrom):
        * dom/ElementAttributeData.h:
        (ElementAttributeData):
        * dom/Node.h:
        * dom/StyledElement.cpp:
        (WebCore::StyledElement::styleAttributeChanged):
        (WebCore::StyledElement::parseAttribute):
        * dom/StyledElement.h:
        * editing/ReplaceNodeWithSpanCommand.cpp:
        (WebCore::swapInNodePreservingAttributesAndChildren):
        * html/HTMLElement.cpp:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::copyNonAttributePropertiesFromElement):
        * html/HTMLInputElement.h:
        * inspector/DOMPatchSupport.cpp:
        (WebCore::DOMPatchSupport::innerPatchNode):
        * inspector/InspectorDOMAgent.cpp:
        (WebCore::InspectorDOMAgent::setNodeName):
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::expandSymbolElementsInShadowTree):
        (WebCore::SVGUseElement::transferUseAttributesToReplacedElement):

2012-05-16  Brent Fulgham  <bfulgham@webkit.org>

        [WinCairo] Unreviewed build change after r115385.  Several Cairo
        image routines were modified to use new wrapper classes, but the
        relevant WinCairo sources were not updated to match.

        * WebCore.vcproj/WebCore.vcproj:
        * platform/graphics/win/ImageCairoWin.cpp:
        (WebCore::BitmapImage::create):
        (WebCore::BitmapImage::drawFrameMatchingSourceSize):
        * platform/win/DragImageCairoWin.cpp:
        (WebCore::createDragImageFromImage):

2012-05-16  Tim Horton  <timothy_horton@apple.com>

        Scrollbar layers should respect accelerated drawing setting
        https://bugs.webkit.org/show_bug.cgi?id=86644
        <rdar://problem/11462038>

        Reviewed by Simon Fraser.

        When creating scrollbar layers, pass through the accelerated drawing setting.

        No new tests.

        * rendering/RenderLayerCompositor.cpp:
        (WebCore::RenderLayerCompositor::updateOverflowControlsLayers):

2012-05-16  Tim Horton  <timothy_horton@apple.com>

        FrameView::scrollContentsFastPath should use painted area to determine whether to drop out of the fast path
        https://bugs.webkit.org/show_bug.cgi?id=86651
        <rdar://problem/11459243>

        Reviewed by Simon Fraser.

        Previously, we decided to fall out of the fast scrolling path by the number of fixed-position elements
        on the page. This was less than ideal if a single fixed position element took up a significant portion
        of the page, or if there were many small, cheap-to-paint fixed elements.

        Instead, we should use the fast path if less than 50% of the page will be repainted by fixed-position
        elements, and otherwise fall back to the slow path.

        I've tested a few different thresholds with an internal test; 50% seems to work relatively well,
        but the ideal value is hard to determine and likely depends on hardware.

        No new tests, performance improvement with few large fixed-position objects or many small ones.

        * page/FrameView.cpp:
        (WebCore::FrameView::scrollContentsFastPath):

2012-05-16  David Reveman  <reveman@chromium.org>

        [Chromium] Use ThrottledTextureUploader with threaded compositing.
        https://bugs.webkit.org/show_bug.cgi?id=85848

        Reviewed by Adrienne Walker.

        Switch to ThrottledUploader in CCThreadProxy.

        * platform/graphics/chromium/cc/CCThreadProxy.cpp:

2012-05-15  Emil A Eklund  <eae@chromium.org>

        Change ascents and descent back to ints for now
        https://bugs.webkit.org/show_bug.cgi?id=86518

        Reviewed by Eric Seidel.

        Change ascents and descent calculation back to integers for now as it
        looks like we'll need to support both the 1/60 and 1/1 implementations of
        FractionalLayoutUnit for the immediate future to ensure that text is
        rendered at the same offset and with the height regardless of the
        ENABLE_SUBPIXEL_LAYOUT flag.

        This ensures that most websites will look the same at 100% zoom
        regardless of the flag and also allows us to the same test expectations
        for the vast majority of layout tests.

        Eventually we want to move those back to FractionalLayoutUnits as that
        will result in more correct rendering.

        No new tests, no change in functionality.

        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::computeLogicalBoxHeights):
        * rendering/RootInlineBox.cpp:
        (WebCore::setAscentAndDescent):
        (WebCore::RootInlineBox::ascentAndDescentForBox):
        * rendering/RootInlineBox.h:
        (RootInlineBox):

2012-05-16  Ken Buchanan  <kenrb@chromium.org>

        Crash due to first-letter not getting computed on RenderTableCell
        https://bugs.webkit.org/show_bug.cgi?id=86133

        Reviewed by Abhishek Arya.

        RenderTableCell overrides RenderBlock::layout() but doesn't call
        updateFirstLetter() in it. This is normally not a problem because
        updateFirstLetter() gets called during preferred logical width
        computation, but there exist rare occasions when layout of the table
        cell happens without preferred logical widths being dirty, in which
        case the first-letter update can be skipped.

        This patch adds a call to updateFirstLetter() to
        RenderTableCell::layout(). This ensures that the first-letter is up
        to date before commencing block layout.

        * rendering/RenderTableCell.cpp:
        (WebCore::RenderTableCell::layout)

2012-05-16  Mikhail Naganov  <mnaganov@chromium.org>

        Avoid jumpscroll when entering new text in a multi-line editor.
        https://bugs.webkit.org/show_bug.cgi?id=82875

        Reviewed by Ryosuke Niwa.

        Scroll caret to the edge of the viewport in case if a line break or a paragraph
        separator is inserted at the end of a multi-line editor.  This avoids
        undesirable jumpscroll in cases when there is content under the editor.

        Tests: editing/input/scroll-to-edge-if-line-break-at-end-of-document-contenteditable.html
               editing/input/scroll-to-edge-if-line-break-at-end-of-document-textarea.html
               editing/input/scroll-to-edge-if-paragraph-separator-at-end-of-document-contenteditable.html

        * editing/Editor.cpp:
        (WebCore::Editor::insertLineBreak):
        (WebCore::Editor::insertParagraphSeparator):
        (WebCore::Editor::revealSelectionAfterEditingOperation):
        * editing/Editor.h:
        (Editor):

2012-05-16  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Pressing esc after requesting snippet creation should remove snippet.
        https://bugs.webkit.org/show_bug.cgi?id=86639

        Reviewed by Pavel Feldman.

        Added committed parameter to NavigatorView.rename() callback.

        * inspector/front-end/NavigatorView.js:
        (WebInspector.NavigatorView.prototype.rename.commitHandler):
        (WebInspector.NavigatorView.prototype.rename.cancelHandler):
        (WebInspector.NavigatorView.prototype.rename.afterEditing):
        * inspector/front-end/ScriptsNavigator.js:
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._snippetCreationRequested.callback):
        (WebInspector.ScriptsPanel.prototype._snippetCreationRequested):

2012-05-16  Abhishek Arya  <inferno@chromium.org>

        Missing RenderApplet cast check in HTMLAppletElement::renderWidgetForJSBindings.
        https://bugs.webkit.org/show_bug.cgi?id=86627

        Reviewed by Andreas Kling.

        Test: java/inline-applet-crash.html

        * html/HTMLAppletElement.cpp:
        (WebCore::HTMLAppletElement::renderWidgetForJSBindings):

2012-05-16  Pavel Feldman  <pfeldman@chromium.org>

        Web Inspector: extract CompositeUISourceCodeProvider from DebuggerScriptMapping.
        https://bugs.webkit.org/show_bug.cgi?id=86634

        Reviewed by Vsevolod Vlasov.

        Extract refactoring.

        * inspector/front-end/DebuggerScriptMapping.js:
        (WebInspector.DebuggerScriptMapping):
        (WebInspector.DebuggerScriptMapping.prototype.uiSourceCodeProviders):
        (WebInspector.DebuggerScriptMapping.prototype._parsedScriptSource):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype._loadUISourceCodes):
        (WebInspector.ScriptsPanel.prototype._toggleFormatSource):
        (WebInspector.CompositeUISourceCodeProvider):
        (WebInspector.CompositeUISourceCodeProvider.prototype._registerUISourceCodeProvider):
        (WebInspector.CompositeUISourceCodeProvider.prototype._handleUISourceCodeAdded):
        (WebInspector.CompositeUISourceCodeProvider.prototype._handleUISourceCodeReplaced):
        (WebInspector.CompositeUISourceCodeProvider.prototype._handleUISourceCodeRemoved):
        (WebInspector.CompositeUISourceCodeProvider.prototype.uiSourceCodes):
        * inspector/front-end/UISourceCode.js:
        (WebInspector.UISourceCodeProvider.prototype.uiSourceCodes):
        (WebInspector.UISourceCodeProvider.prototype.addEventListener):
        (WebInspector.UISourceCodeProvider.prototype.removeEventListener):

2012-05-16  Alexander Pavlov  <apavlov@chromium.org>

        Web Inspector: Double Clicking on "No watch expressions" should add an expression
        https://bugs.webkit.org/show_bug.cgi?id=86631

        Reviewed by Vsevolod Vlasov.

        A double-click listener for the section element adds a new watch expression if the correct element
        has been clicked.
        Drive-by: do not persist deleted (null) watch expressions.

        * inspector/front-end/WatchExpressionsSidebarPane.js:
        (WebInspector.WatchExpressionsSection.prototype._sectionDoubleClick):
        (WebInspector.WatchExpressionsSection.prototype.updateExpression):

2012-05-16  Vsevolod Vlasov  <vsevik@chromium.org>

        Web Inspector: Support script snippets saving.
        https://bugs.webkit.org/show_bug.cgi?id=86632

        Reviewed by Pavel Feldman.

        Added SnippetJavaScriptSource extending JavaScriptSource and overriding isEditable() and commitWorkingCopy() methods.
        ScriptSnippetModel now creates instances of this new class for snippets.
        Also maps in ScriptSnippetModel simplified.

        * inspector/front-end/JavaScriptSource.js:
        (WebInspector.JavaScriptSource.prototype.commitWorkingCopy):
        (WebInspector):
        * inspector/front-end/JavaScriptSourceFrame.js:
        (WebInspector.JavaScriptSourceFrame.prototype.commitEditing):
        * inspector/front-end/ScriptSnippetModel.js:
        (WebInspector.ScriptSnippetModel):
        (WebInspector.ScriptSnippetModel.prototype._addScriptSnippet):
        (WebInspector.ScriptSnippetModel.prototype.deleteScriptSnippet):
        (WebInspector.ScriptSnippetModel.prototype.renameScriptSnippet):
        (WebInspector.ScriptSnippetModel.prototype.setScriptSnippetContent):
        (WebInspector.ScriptSnippetModel.prototype._uiSourceCodeList):
        (WebInspector.ScriptSnippetModel.prototype._releasedUISourceCodes):
        (WebInspector.SnippetJavaScriptSource):
        (WebInspector.SnippetJavaScriptSource.prototype.isEditable):
        (WebInspector.SnippetJavaScriptSource.prototype.commitWorkingCopy):
        (WebInspector.SnippetJavaScriptSource.prototype.get snippetId):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.set _fileRenamed):
        (WebInspector.ScriptsPanel.prototype._snippetCreationRequested.callback):
        (WebInspector.ScriptsPanel.prototype._snippetCreationRequested):

2012-05-16  Sudarsana Nagineni  <sudarsana.nagineni@linux.intel.com>

        [EFL] Memory leak in RenderThemeEfl
        https://bugs.webkit.org/show_bug.cgi?id=86609

        Reviewed by Martin Robinson.

        Fix a memory leak by freeing the cairo surface with
        cairo_surface_destroy.

        * platform/efl/RenderThemeEfl.cpp:
        (WebCore::RenderThemeEfl::cacheThemePartFlush):

2012-05-16  Alexei Filippov  <alexeif@chromium.org>

        Web Inspector: Speedup heap snapshot postprocessing
        https://bugs.webkit.org/show_bug.cgi?id=86635

        Reviewed by Yury Semikhatsky.

        * inspector/front-end/HeapSnapshot.js:
        (WebInspector.HeapSnapshot.prototype._markQueriableHeapObjects):

2012-05-16  Alexander Pavlov  <apavlov@chromium.org>

        Unreviewed, followup for r117273 that fixes the Web Inspector's Computed Style pane layout.

        * inspector/front-end/elementsPanel.css:
        (.styles-section.computed-style.expanded .properties > li):
        (.styles-section.computed-style.expanded .properties > li .webkit-css-property):

2012-05-16  Andrey Kosyakov  <caseq@chromium.org>

        Web Inspector: [Extensions API] expose evaluateOptions in audit formatters
        https://bugs.webkit.org/show_bug.cgi?id=86617

        Reviewed by Pavel Feldman.

        Test: inspector/extensions/extensions-audits-content-script.html

        - apply extension-specific audit formatters earlier (in ExtensionAduitCategory, not along with the rest in AuditFormatters);
        - use ExtensionServer.evaluate() to handle evaluateOptions instead of PageAgent.evaluate();

        * inspector/front-end/AuditFormatters.js: Move node and object formatters to ExtensionAuditCategory.
        (WebInspector.partiallyApplyFormatters): Added a method to traverse formatters tree and apply formatters that are passed as input.
        * inspector/front-end/ExtensionAuditCategory.js:
        (WebInspector.ExtensionAuditCategory): Pass extensionOrigin.
        (WebInspector.ExtensionAuditCategoryResults.prototype._addNode): Apply extensions formatters before adding the result.
        (WebInspector.ExtensionAuditCategoryResults.prototype._addResult):
        (WebInspector.ExtensionAuditCategoryResults.prototype.evaluate): moved from AuditFormatters.
        (WebInspector.ExtensionAuditFormatters.object.onEvaluate):
        (WebInspector.ExtensionAuditFormatters.object):
        (WebInspector.ExtensionAuditFormatters.node.onNodeAvailable):
        (WebInspector.ExtensionAuditFormatters.node.onEvaluate):
        (WebInspector.ExtensionAuditFormatters.node):
        * inspector/front-end/ExtensionServer.js:
        (WebInspector.ExtensionServer.prototype._onAddAuditCategory): Plumb extensionOrigin through to audit category.

2012-05-16  Donald Carr  <donald.carr@nokia.com>

        Fixes the build with Qt 5 HEAD

        Reviewed by Csaba Osztrogonác.

        * WebCore.pri:
        * platform/graphics/texmap/TextureMapperGL.cpp:
        * plugins/qt/PluginViewQt.cpp:

2012-05-16  Rob Buis  <rbuis@rim.com>

        SVGSVGElement checkIntersection and checkEnclosure Mem corruption
        https://bugs.webkit.org/show_bug.cgi?id=67923

        Reviewed by Nikolas Zimmermann.

        Only call checkIntersection/checkEnclosure when we have a valid renderer.

        Test: svg/custom/intersection-list-null.svg

        * svg/SVGSVGElement.cpp:
        (WebCore::SVGSVGElement::checkIntersection):
        (WebCore::SVGSVGElement::checkEnclosure):

2012-05-16  Simon Hausmann  <simon.hausmann@nokia.com>

        Unreviewed, rolling out r110699.
        http://trac.webkit.org/changeset/110699
        https://bugs.webkit.org/show_bug.cgi?id=80982

        Not needed anymore and broke modal event loops

        * platform/qt/RunLoopQt.cpp:
